REM The Sceptre of Shalimar Land Maker Version 0.96a
REM Created by Seth Hopkinson on October 19, 1991
REM Ported to MS DOS QBasic:  16 Apr 1996    Last modified:  08-Jun-1996

DECLARE SUB status ()
DECLARE SUB GetName (a$, b$)
DECLARE SUB TPorter (x!, y!)

ver$ = "The Sceptre of Shalimar    Land Maker    Ver 0.96b"
auth$ = "Created by Seth Hopkinson, 19-Oct-1991   Last Updated:  08-Jun-1996"

Xmax = 60: Ymax = 22: MaxTiles = 45: MaxTowns = 10: MaxDungs = 10

DIM land(Xmax, Ymax), TileName$(MaxTiles)
DIM tx(MaxTowns), ty(MaxTowns), Tfile$(MaxTowns), Tmap$(MaxTowns)
DIM dx(MaxDungs), dy(MaxDungs), Dfile$(MaxDungs), Dmap$(MaxDungs)
NoTowns = 0: NoDung = 0
RDate$ = DATE$
MapName$ = "The Nameless Place"
Author$ = "Unknown"
MapFile$ = "Shalwrap.SMA"
REM ... Set custom terrain to 11 -- SandStone
custom = 11
GOSUB SetTileNames

GOTO IBMkeys
REM goto AmigaKeys

AmigaKeys:
    ibm = 0
    Help = 139
    F1 = 129
    F2 = 130
    F3 = 131
    F4 = 132
    F5 = 133
    F6 = 134
    F7 = 135
    F8 = 136
    F9 = 137
    F10 = 138
GOTO Start
   
IBMkeys:
    ibm = 1
    Help = 27
    F1 = 129
    F2 = 130
    F3 = 131
    F4 = 132
    F5 = 133
    F6 = 134
    F7 = 135
    F8 = 136
    F9 = 137
    F10 = 138
    KEY 1, CHR$(129)
    KEY 2, CHR$(130)
    KEY 3, CHR$(131)
    KEY 4, CHR$(132)
    KEY 5, CHR$(133)
    KEY 6, CHR$(134)
    KEY 7, CHR$(135)
    KEY 8, CHR$(136)
    KEY 9, CHR$(137)
    KEY 10, CHR$(138)
GOTO Start

Start:
RANDOMIZE TIMER
DEF FNran (Low, High) = INT(RND(1) * ((High + 1) - Low)) + Low

black = 0: brn = 6: red = 4: org = 13: yel = 14: grn = 2: blu = 1: pur = 5: wht = 15
lgr = 7: mgr = 3: dgr = 8: lred = 12: lyel = 11: Lgrn = 10: Lblu = 9

COLOR yel: PRINT : PRINT "   PLEASE WAIT..."
REM Window OUTPUT 2
CLS
GOSUB PutUpKeys
GOTO LoadScreen

PutUpKeys:
    LOCATE 1, 62: COLOR lgr: PRINT "#pad to move"
    LOCATE 3, 62: COLOR org: PRINT "Terrain:"
    LOCATE 5, 62: COLOR yel: PRINT "D   "; : COLOR lred: PRINT "Desert"
    LOCATE 6, 62: COLOR Lblu: PRINT "W   "; : COLOR lred: PRINT "Water"
    LOCATE 7, 62: COLOR grn: PRINT "T   "; : COLOR lred: PRINT "Trees"
    LOCATE 8, 62: COLOR Lgrn: PRINT "F   "; : COLOR lred: PRINT "Fields"
    LOCATE 9, 62: COLOR wht: PRINT "C   "; : COLOR lred: PRINT "City"
    LOCATE 10, 62: COLOR brn: PRINT "M   "; : COLOR lred: PRINT "Mountains"
    LOCATE 11, 62: COLOR pur: PRINT "X   "; : COLOR lred: PRINT "Dungeons"
    LOCATE 12, 62: COLOR red: PRINT "P   "; : COLOR lred: PRINT "Lava"
    LOCATE 13, 62: COLOR mgr: PRINT "N   "; : COLOR lred: PRINT "Tile #"; custom;
    IF ibm = 1 THEN
        LOCATE 15, 62: COLOR lyel: PRINT "ESC "; : COLOR lgr: PRINT "More Keys"
    ELSE
        LOCATE 15, 61: COLOR lyel: PRINT "HELP"; : COLOR lgr: PRINT "More Keys"
    END IF
    LOCATE 16, 62: COLOR lyel: PRINT "S   "; : COLOR lgr: PRINT "Save"
    LOCATE 17, 62: COLOR lyel: PRINT "R   "; : COLOR lgr: PRINT "Load"
    LOCATE 18, 62: COLOR lyel: PRINT "Z   "; : COLOR lgr: PRINT "Teleport"
    LOCATE 19, 62: COLOR lyel: PRINT "!   "; : COLOR lgr: PRINT "Remove C/D"
    LOCATE 21, 62: COLOR lyel: PRINT "Q   "; : COLOR yel: PRINT "QUIT PROGRAM"
RETURN

LoadScreen:
status
CLS
COLOR mgr: PRINT ver$: PRINT auth$: PRINT
COLOR lgr: PRINT "Should be in 80 column mode!"
COLOR grn: PRINT : PRINT "L"; : COLOR red: PRINT "oad map"
PRINT : PRINT "  OR PRESS  "
COLOR grn: PRINT : PRINT "D W T F P M"; : COLOR red
PRINT TAB(15); "Terrain to fill"
PRINT TAB(15); "a NEW MAP with."
PRINT
2 a$ = INKEY$: IF a$ = "" THEN 2
  a$ = UCASE$(a$)
  IF a$ = "L" THEN GOSUB LoadMap: GOSUB DisplayMap: GOTO 1
  GOSUB GetTerrain: IF Terrain = 0 OR Terrain > 6 THEN BEEP: GOTO 2
REM Window CLOSE 3
LOCATE 1, 1
FOR y = 1 TO Ymax
  FOR x = 1 TO Xmax
    land(x, y) = Terrain
    GOSUB Evaluate
  NEXT x
  PRINT
NEXT y
GOSUB PutUpKeys
GOSUB MakeTD
x = 1: y = 1
1 LOCATE y, x: ox = x: oy = y
  COLOR lgr: PRINT "*"
  a$ = INKEY$: a$ = UCASE$(a$): f = land(x, y)
  GOSUB GetTerrain
  IF Terrain = 7 THEN
    NoDung = NoDung + 1
    dx(NoDung) = x: dy(NoDung) = y
    GetName Dfile$(NoDung), Dmap$(NoDung)
    GOSUB DrawMap
  END IF
  IF Terrain = 8 THEN
    NoTowns = NoTowns + 1
    tx(NoTowns) = x: ty(NoTowns) = y
    GetName Tfile$(NoTowns), Tmap$(NoTowns)
    GOSUB DrawMap
  END IF
  IF Terrain > 0 THEN land(x, y) = Terrain
  LOCATE y, x: GOSUB Evaluate
  IF f <> land(x, y) THEN x = x + 1
  IF a$ = "Q" THEN GOTO Quit
  IF a$ = "!" THEN GOSUB DelTownDung: GOSUB DrawMap
  IF a$ = "B" THEN GOSUB SetCust: GOSUB DrawMap
  IF a$ = " " THEN GOSUB DrawMap
  IF a$ = CHR$(28) OR a$ = "8" THEN y = y - 1
  IF a$ = CHR$(29) OR a$ = "2" THEN y = y + 1
  IF a$ = CHR$(31) OR a$ = "4" THEN x = x - 1
  IF a$ = CHR$(30) OR a$ = "6" THEN x = x + 1
  IF a$ = "9" THEN x = x + 1: y = y - 1
  IF a$ = "7" THEN x = x - 1: y = y - 1
  IF a$ = "1" THEN x = x - 1: y = y + 1
  IF a$ = "3" THEN x = x + 1: y = y + 1
  IF a$ = "" THEN GOTO Move
  a = ASC(a$)
  IF a = Help THEN GOSUB Commands
  IF a < 64 THEN GOTO Move
  IF a$ = "S" THEN CLS : GOSUB SaveMap
  IF a$ = "R" THEN CLS : GOSUB LoadMap
  IF a$ = "L" THEN CLS : GOSUB LoadMap
  IF a$ = "Z" THEN GOSUB OpenWindow: COLOR wht: TPorter x, y: GOSUB DrawMap
  IF a = F1 THEN GOSUB MapNamer
  IF a = F2 THEN GOSUB Author
  IF a = F3 THEN GOSUB DateStamper
  IF a = F4 THEN GOSUB MapSizer
  IF a = F5 THEN GOSUB ClearTerrain
  IF a = F6 THEN GOSUB Purge: GOSUB DrawMap
  IF a = F7 THEN GOSUB PrintMap
  IF a = F8 THEN GOSUB EditTown: GOSUB DrawMap
  IF a = F9 THEN GOSUB EditDungeon: GOSUB DrawMap
  IF a = F10 THEN GOSUB RepTer
Move:
  IF x < 1 THEN x = 1
  IF x > Xmax THEN x = 60
  IF y < 1 THEN y = 1
  IF y > Ymax THEN y = 22
  IF ox <> x OR oy <> y OR a$ = "5" THEN
    LOCATE 23, 1: PRINT "X="; x; "  Y="; y;
    of = f: f = land(x, y)
    PRINT "  Tile:"; f; UCASE$(TileName$(f)); SPACE$(45);
    IF f = 8 THEN
      FOR g = 1 TO NoTowns
        IF tx(g) = x AND ty(g) = y THEN h = g
      NEXT g
      COLOR wht
      LOCATE 23, 16: PRINT SPACE$(62);
      LOCATE 23, 16: PRINT "CITY #"; h; "    NAME: "; Tmap$(h); "    FILE:"; Tfile$(h);
    END IF
    IF f = 7 THEN
      FOR g = 1 TO NoDung
        IF dx(g) = x AND dy(g) = y THEN h = g
      NEXT g
      COLOR pur
      LOCATE 23, 16: PRINT SPACE$(62);
      LOCATE 23, 16: PRINT "DUNGEON #"; h; "    NAME: "; Dmap$(h); "    FILE:"; Dfile$(h);
    END IF
  END IF
GOTO 1
 
OpenWindow:
  FOR g = 1 TO 4
    LOCATE g, 1: PRINT SPACE$(70);
  NEXT g
  LOCATE 1, 1
RETURN

SetCust:
  GOSUB OpenWindow
  LOCATE 2, 1: PRINT "Enter custom Tile Number (1 -"; MaxTiles;
  INPUT "): ", custom
  custom = INT(custom)
  IF custom < 1 THEN custom = 1
  IF custom > MaxTiles THEN custom = MaxTiles
RETURN

DelTownDung:
  CLS : COLOR org
  PRINT "DELETE TOWN/DUNGEON:"
  PRINT : COLOR grn
  PRINT "  Delete ";
  COLOR yel: PRINT "T";
  COLOR grn: PRINT "own or ";
  COLOR yel: PRINT "D";
  COLOR grn: PRINT "ungeon?    (ENTER to return to map)"
WaitTD:
  a$ = UCASE$(INKEY$)
  IF a$ = CHR$(13) OR a$ = CHR$(27) OR a$ = CHR$(10) THEN RETURN
  IF a$ = "T" THEN GOTO DelTown
  IF a$ = "D" THEN GOTO DelDung
GOTO WaitTD

DelTown:
  CLS
  PRINT "Ltr:"; TAB(7); "Coordinates:"; TAB(22); "MapName:"; TAB(65); "FileName:"
  FOR g = 1 TO NoTowns
    PRINT " "; CHR$(64 + g); TAB(8); tx(g); ","; ty(g); TAB(22); Tmap$(g); TAB(65); Tfile$(g)
  NEXT g
  PRINT : PRINT "Which town to delete?   (ENTER to return to map)"
4 a$ = UCASE$(INKEY$)
  IF a$ = CHR$(13) OR a$ = CHR$(27) OR a$ = CHR$(10) THEN RETURN
  IF a$ < "A" OR a$ > CHR$(64 + NoTowns) THEN 4
  a = ASC(a$) - 64
  land(tx(a), ty(a)) = 4
  tmp$ = Tmap$(NoTowns): Tmap$(NoTowns) = Tmap$(a): Tmap$(a) = tmp$
  tmp$ = Tfile$(NoTowns): Tfile$(NoTowns) = Tfile$(a): Tfile$(a) = tmp$
  tmp = tx(NoTowns): tx(NoTowns) = tx(a): tx(a) = tmp
  tmp = ty(NoTowns): ty(NoTowns) = ty(a): ty(a) = tmp
  NoTowns = NoTowns - 1
GOTO DelTown

DelDung:
  CLS
  PRINT "Ltr:"; TAB(7); "Coordinates:"; TAB(22); "MapName:"; TAB(65); "FileName:"
  FOR g = 1 TO NoDung
    PRINT " "; CHR$(64 + g); TAB(8); dx(g); ","; dy(g); TAB(22); Dmap$(g); TAB(65); Dfile$(g)
  NEXT g
  PRINT : PRINT "Which dungeon to delete?   (ENTER to return to map)"
5 a$ = UCASE$(INKEY$)
  IF a$ = CHR$(13) OR a$ = CHR$(27) OR a$ = CHR$(10) THEN RETURN
  IF a$ < "A" OR a$ > CHR$(64 + NoDung) THEN 5
  a = ASC(a$) - 64
  land(dx(a), dy(a)) = 4
  tmp$ = Dmap$(NoDung): Dmap$(NoDung) = Dmap$(a): Dmap$(a) = tmp$
  tmp$ = Dfile$(NoDung): Dfile$(NoDung) = Dfile$(a): Dfile$(a) = tmp$
  tmp = dx(NoDung): dx(NoDung) = dx(a): dx(a) = tmp
  tmp = dy(NoDung): dy(NoDung) = dy(a): dy(a) = tmp
  NoDung = NoDung - 1
GOTO DelDung

DrawMap:
  tmpXX = x: tmpYY = y
  GOSUB DisplayMap
  x = tmpXX: y = tmpYY
RETURN

DisplayMap:
  GOSUB PutUpKeys
  LOCATE 1, 1
  FOR y = 1 TO Ymax
    FOR x = 1 TO Xmax
      GOSUB Evaluate
    NEXT x
    PRINT
  NEXT y
MakeTD:
  FOR g = 1 TO NoTowns
    x = tx(g): y = ty(g): LOCATE y, x: land(x, y) = 8: GOSUB Evaluate
  NEXT g
  FOR g = 1 TO NoDung
    x = dx(g): y = dy(g): LOCATE y, x: land(x, y) = 7: GOSUB Evaluate
  NEXT g
  x = 1: y = 1
RETURN

Commands:
  REM Window 4,"Commands",(50,20)-(580,170),16,2
  CLS
  COLOR mgr
  PRINT " SPACE  ReDraw Map (cleans up screen, removes leftover text and stuff)"
  PRINT
  PRINT "  N    Place Custom Terrain, currently set to tile #"; custom
  PRINT "  B    Set custom terrain tile number ( 1 -"; MaxTiles; ") -- see file CONSET.TXT"
  PRINT
  PRINT "  F1   Display/change Map Name ("; MapName$; ")"
  PRINT "  F2   Display/change Author ("; Author$; ")"
  PRINT "  F3   Display/change DLR ("; RDate$; ")"; TAB(50); "DLR = Date of Last Revision"
  PRINT "  F4   Change size of Map"
  PRINT "  F5   Clear out excess Terrain (write all zeros to area outside of the map)"
  PRINT "  F6 * Purge blank Town & Dungeons"
  PRINT "  F7   Print Map"
  PRINT "  F8   Edit Town"
  PRINT "  F9   Edit Dungeon"
  PRINT "  F10  Replace terrains"
  PRINT : PRINT "*  Purge the map if un-enterable Towns/Dungeons show up in the game.  Purging"
  PRINT "removes any Towns/Dungeons that do not have data associated with them."
  COLOR lred: PRINT : PRINT "Press any key when done"
  tmp = Lgrn
  a = TIMER
40 a$ = INKEY$
  IF ABS(TIMER - a) > .25 THEN
    IF tmp = Lgrn THEN
        tmp = grn
    ELSE
        tmp = Lgrn
    END IF
    a = TIMER
    COLOR tmp: LOCATE 23, 15: PRINT "MAKE SURE  NUM LOCK  IS ON!!!";
  END IF
  IF a$ = "" THEN 40
  REM Window CLOSE 4
  CLS : GOSUB DrawMap: GOSUB PutUpKeys
RETURN

MapNamer:
  REM Window 4,"Map Name",(50,20)-(580,170),16,2
  GOSUB OpenWindow
  PRINT "Current name is:"
  PRINT MapName$: PRINT
  INPUT "Name of Map: ", a$
  IF a$ = "" THEN GOTO DoneMN
  MapName$ = a$
DoneMN:
  REM Window CLOSE 4
  GOSUB DrawMap
RETURN

Author:
  REM Window 4,"Author",(50,20)-(580,170),16,2
  GOSUB OpenWindow
  PRINT "Current Author is:"
  PRINT Author$: PRINT
  INPUT "Your Name: ", a$
  IF a$ = "" THEN GOTO DoneMN
  Author$ = a$
  GOSUB DrawMap
GOTO DoneMN

DateStamper:
  REM Window 4,"Date of Last Revision",(50,20)-(580,170),16,2
  GOSUB OpenWindow
  PRINT "Current DLR is:"
  PRINT RDate$: PRINT
  INPUT "Today's Date: ", a$
  IF a$ = "" THEN GOTO DoneMN
  RDate$ = a$
  GOSUB DrawMap
GOTO DoneMN

MapSizer:
ClearTerrain:
RepTer:
BEEP
RETURN

Purge:
  REM Window 3,"Purge Map",(20,50)-(600,180),3,2
  GOSUB OpenWindow
  COLOR lgr
  PRINT "Searching for BLANK towns/dungeons"
  FOR y = 1 TO Ymax
   FOR x = 1 TO Xmax
     IF land(x, y) = 8 THEN GOSUB CheckTn
     IF land(x, y) = 7 THEN GOSUB CheckDg
   NEXT x
   LOCATE 5, 5: PRINT y;
  NEXT y
  REM Window CLOSE 3
  GOSUB DrawMap
RETURN
CheckTn:
  flag = 1
  LOCATE 6, 5: PRINT "Checking Town...";
  FOR g = 1 TO NoTowns
    IF (tx(g) = x) AND (ty(g) = y) THEN flag = 0
  NEXT g
  IF flag = 1 THEN
    land(x, y) = 1
    LOCATE 6, 5: PRINT " PURGED ";
  ELSE
    LOCATE 6, 5: PRINT SPACE$(22);
  END IF
RETURN
CheckDg:
  flag = 1
  LOCATE 6, 5: PRINT "Checking Dungeon...";
  FOR g = 1 TO NoDung
    IF (dx(g) = x) AND (dy(g) = y) THEN flag = 0
  NEXT g
  IF flag = 1 THEN
    land(x, y) = 1
    LOCATE 6, 5: PRINT " PURGED ";
  ELSE
    LOCATE 6, 5: PRINT SPACE$(22);
  END IF
RETURN

EditTown:
  REM Window 3,"Edit Town",(20,50)-(600,180),3,2
  COLOR lgr
  FOR g = 1 TO NoTowns
    LOCATE g, 1: PRINT SPACE$(70); : LOCATE g, 1
    x = tx(g): y = ty(g): land(x, y) = 8
    a$ = CHR$(64 + g)
    PRINT " "; a$; TAB(6); x; ","; y; TAB(19); Tmap$(g); TAB(55); UCASE$(Tfile$(g))
  NEXT g
  PRINT SPACE$(70)
  PRINT "Letter of town to edit?   (ENTER for map)"; SPACE$(29)
30 a$ = UCASE$(INKEY$)
  IF a$ = CHR$(13) OR a$ = CHR$(27) OR a$ = CHR$(10) THEN RETURN
  IF a$ < "A" OR a$ > CHR$(64 + NoTowns) THEN 30
  a = ASC(a$) - 64
34 CLS
  PRINT "Town #"; a; "  "; Tmap$(a)
  PRINT "File: "; Tfile$(a)
  PRINT "Coords: "; tx(a); ","; ty(a)
  PRINT : PRINT "Change N, F, C or ENTER to exit": PRINT
31 a$ = UCASE$(INKEY$)
  IF a$ = CHR$(13) THEN
    REM Window CLOSE 3
    RETURN
  END IF
  IF a$ = "N" THEN GOSUB RenTown: GOTO 34
  IF a$ = "F" THEN GOSUB RefTown: GOTO 34
  IF a$ = "C" THEN GOSUB RecTown: GOTO 34
GOTO 31
RenTown:
  INPUT "Enter new name: ", a$
  IF a$ = "" THEN RETURN
  Tmap$(a) = a$
RETURN
RefTown:
  INPUT "Enter new file: ", a$
  IF a$ = "" THEN RETURN
  Tfile$(a) = a$
RETURN
RecTown:
  INPUT "Enter new X: ", x
  INPUT "Enter new y: ", y
  IF (x = 0) OR (y = 0) THEN RETURN
  IF land(x, y) = 8 THEN PRINT "Already a city there!": RETURN
  IF land(x, y) = 7 THEN PRINT "There is a dungeon there!": RETURN
  land(tx(a), ty(a)) = land(x, y)
  tx(a) = x: ty(a) = y
RETURN

EditDungeon:
  REM Window 3,"Edit Dungeon",(20,50)-(600,180),3,2
  GOSUB OpenWindow
  COLOR lgr
  FOR g = 1 TO NoDung
    LOCATE g, 1: PRINT SPACE$(70); : LOCATE g, 1
    x = dx(g): y = dy(g): land(x, y) = 7
    a$ = CHR$(64 + g)
    PRINT " "; a$; TAB(6); x; ","; y; TAB(19); Dmap$(g); TAB(55); UCASE$(Dfile$(g))
  NEXT g
  PRINT SPACE$(70)
  PRINT "Letter of dungeon to edit?   (ENTER for map)"; SPACE$(26)
32 a$ = UCASE$(INKEY$)
  IF a$ = CHR$(13) OR a$ = CHR$(27) OR a$ = CHR$(10) THEN RETURN
  IF a$ < "A" OR a$ > CHR$(64 + NoDung) THEN 32
  a = ASC(a$) - 64
35 CLS
  PRINT "Duneon #"; a; "  "; Dmap$(a)
  PRINT "File: "; Dfile$(a)
  PRINT "Coords: "; dx(a); ","; dy(a)
  PRINT : PRINT "Change N, F, C or ENTER to exit": PRINT
33 a$ = UCASE$(INKEY$)
  IF a$ = CHR$(13) THEN
    REM Window CLOSE 3
    RETURN
  END IF
  IF a$ = "N" THEN GOSUB RenDung: GOTO 35
  IF a$ = "F" THEN GOSUB RefDung: GOTO 35
  IF a$ = "C" THEN GOSUB RecDung: GOTO 35
GOTO 33
RenDung:
  INPUT "Enter new name: ", a$
  IF a$ = "" THEN RETURN
  Dmap$(a) = a$
RETURN
RefDung:
  INPUT "Enter new file: ", a$
  IF a$ = "" THEN RETURN
  Dfile$(a) = a$
RETURN
RecDung:
  INPUT "Enter new X: ", x
  INPUT "Enter new y: ", y
  IF (x = 0) OR (y = 0) THEN RETURN
  IF land(x, y) = 8 THEN PRINT "There is a city there!": RETURN
  IF land(x, y) = 7 THEN PRINT "Already a dungeon there!": RETURN
  land(dx(a), dy(a)) = land(x, y)
  dx(a) = x: dy(a) = y
RETURN

SaveMap:
  REM Window 3,"Save Map",(20,50)-(400,100),3,2
  CLS : COLOR lgr
  GOSUB getFile
  OPEN File$ FOR OUTPUT AS #2
  GOTO NewSave

REM We can skip these next few lines since the old (original)
REM map format (.MAP) is no longer used.
  PRINT : PRINT " Save "; File$; " as type: ": PRINT
  PRINT "S  .SMAP   (.SMA file for Pre-Release 1, Pre-Release 0, and later versions)"
  PRINT "M  .MAP    (.MAP file for versions BEFORE Pre-Release 0) "
  PRINT
51 a$ = UCASE$(INKEY$)
  IF a$ = "S" THEN GOTO NewSave
  IF a$ = "M" THEN GOTO OldSave
GOTO 51

NewSave:
  PRINT "Saving...  SMAP file"
  WRITE #2, "SMAP", 0
  WRITE #2, MapName$
  WRITE #2, Author$, RDate$
  WRITE #2, Xmax, Ymax
  WRITE #2, "TOWNS"
  WRITE #2, NoTowns
  IF NoTowns = 0 THEN GOTO SDungs
  FOR g = 1 TO NoTowns
    WRITE #2, tx(g), ty(g), Tfile$(g), Tmap$(g)
  NEXT g
SDungs:
  WRITE #2, "DUNGEONS"
  WRITE #2, NoDung
  IF NoDung = 0 THEN GOTO Smap
  FOR g = 1 TO NoDung
    WRITE #2, dx(g), dy(g), Dfile$(g), Dmap$(g)
  NEXT g
Smap:
  WRITE #2, "MAP ARRAY"
  FOR y = 1 TO Ymax
    FOR x = 1 TO Xmax
      a$ = CHR$(land(x, y))
      PRINT #2, a$;
    NEXT x
  NEXT y
GOTO Done

OldSave:
  PRINT "Saving version 0.6 / 0.5 file..."
  IF Xmax < 60 OR Ymax < 22 THEN
    BEEP
    PRINT "WARNING...  This map will be expanded to"
    PRINT "fill the entire map area.  Extra terrain may be added!"
  END IF
  FOR h = 1 TO 22
    FOR g = 1 TO 60
      PRINT #2, land(g, h)
    NEXT g
  NEXT h
  PRINT #2, NoTowns
  IF NoTowns = 0 THEN GOTO Done
  FOR g = 1 TO NoTowns
    WRITE #2, tx(g), ty(g), Tfile$(g), Tmap$(g)
  NEXT g
  PRINT #2, NoDung
  IF NoDung = 0 THEN GOTO Done
  FOR g = 1 TO NoDung
    WRITE #2, dx(g), dy(g), Dfile$(g), Dmap$(g)
  NEXT g
Done:
  CLOSE #2
  REM Window CLOSE 3
  CLS : GOSUB DisplayMap: GOSUB PutUpKeys
RETURN

LoadMap:
  REM Window 3,"Load Map",(20,50)-(400,100),3,2
  CLS : COLOR lgr
  GOSUB getFile
  OPEN File$ FOR INPUT AS #2
  PRINT : PRINT "Loading..."; File$
  INPUT #2, a$, b
  IF a$ <> "SMAP" THEN a = VAL(a$): GOTO LoadOld
  IF b > 0 THEN
    PRINT "WARNING...": BEEP
    PRINT "Some information will be skipped.  Be sure to"
    PRINT "SAVE THIS FILE UNDER A DIFFERENT NAME!"
  END IF
  INPUT #2, MapName$
  INPUT #2, Author$, RDate$
  INPUT #2, Xmax, Ymax
  IF Xmax > 60 OR Ymax > 22 THEN
    PRINT "You'll need a higher version of LandMaker to load this file!"
    GOTO LDone
  END IF
3 INPUT #2, a$
  IF UCASE$(a$) <> "TOWNS" THEN 3
  PRINT "Towns...";
  INPUT #2, NoTowns
  IF NoTowns = 0 THEN GOTO LDung
  FOR g = 1 TO NoTowns
    INPUT #2, tx(g), ty(g), Tfile$(g), Tmap$(g)
  NEXT g
LDung:
  INPUT #2, a$
  IF UCASE$(a$) <> "DUNGEONS" THEN GOTO LDung
  PRINT "Dungeons...";
  INPUT #2, NoDung
  IF NoDung = 0 THEN GOTO LMap
  FOR g = 1 TO NoDung
    INPUT #2, dx(g), dy(g), Dfile$(g), Dmap$(g)
  NEXT g
LMap:
  INPUT #2, a$
  IF UCASE$(a$) <> "MAP ARRAY" THEN GOTO LMap
  PRINT "Map Array..."
  FOR y = 1 TO Ymax
    FOR x = 1 TO Xmax
      a$ = INPUT$(1, 2)
      land(x, y) = ASC(a$)
    NEXT x
  NEXT y
LDone:
  CLOSE #2
  REM Window CLOSE 3
  CLS : GOSUB DisplayMap: GOSUB PutUpKeys
RETURN
  
LoadOld:
  PRINT "Loading verison 0.6 / 0.5 file..."
  Xmax = 60: Ymax = 22
  ON ERROR GOTO SmallMap
  FOR h = 1 TO 22
    FOR g = 1 TO 60
      IF (h = 1) AND (g < 3) THEN
        land(1, 1) = a
        land(2, 1) = b
      ELSE
        INPUT #2, land(g, h)
      END IF
    NEXT g
  NEXT h
  PRINT "Attempting to load TOWNS"
  INPUT #2, NoTowns
  IF EOF(2) THEN GOTO LODone
  IF NoTowns = 0 THEN GOTO LODone
  FOR g = 1 TO NoTowns
    INPUT #2, tx(g), ty(g), Tfile$(g), Tmap$(g)
  NEXT g
  PRINT "Attempting to load DUNGEONS"
  INPUT #2, NoDung
  IF EOF(2) THEN GOTO LODone
  IF NoDung = 0 THEN GOTO Done
  FOR g = 1 TO NoDung
    INPUT #2, dx(g), dy(g), Dfile$(g), Dmap$(g)
  NEXT g
LODone:
  CLOSE #2
  REM Window CLOSE 3
  CLS : GOSUB DisplayMap: GOSUB PutUpKeys
RETURN

SmallMap:
  Xmax = 60: Ymax = 20
  PRINT "Towns unavailable.  Version 0.5 file!"
  BEEP
  ON ERROR GOTO 0
RESUME LODone

getFile:
  COLOR yel: PRINT "Enter filename for Map.";
  COLOR blu: PRINT TAB(45); "Previous Filename:  "; UCASE$(MapFile$)
  File$ = MapFile$
  PRINT : COLOR grn
  PRINT "Type  '  to use previous filename,"; TAB(45); "NOTE:  The ' key is right next"
  PRINT "or press ENTER for directory."; TAB(52); "to ENTER on most keyboards."
  PRINT
  xx$ = "": COLOR yel
  PRINT : INPUT "Enter Filename: ", xx$
  IF xx$ = "" THEN
     COLOR Lblu
     PRINT
     FILES "*.SMA"
     GOTO getFile
  END IF
  IF xx$ = "'" THEN
    File$ = MapFile$
  ELSE
    File$ = xx$
  END IF
  GOSUB Parse
  MapFile$ = UCASE$(File$)
RETURN

Parse:
  g = LEN(File$)
  IF g > 8 THEN g = 8
  FOR x = 1 TO g
    xx$ = MID$(File$, x, 1)
    IF xx$ = "." OR xx$ = "\" OR xx$ = "*" OR xx$ = "?" THEN
      MID$(File$, x, 1) = "_"
    END IF
  NEXT x
  a$ = UCASE$(RIGHT$(File$, 3))
  IF a$ <> "MAP" THEN
     File$ = UCASE$(LEFT$(File$, 8)) + ".SMA"
  END IF
RETURN

GetTerrain:
  Terrain = 0
  IF a$ = "D" THEN Terrain = 1
  IF a$ = "W" THEN Terrain = 2
  IF a$ = "T" THEN Terrain = 3
  IF a$ = "F" THEN Terrain = 4
  IF a$ = "P" THEN Terrain = 5
  IF a$ = "M" THEN Terrain = 6
  IF a$ = "X" THEN Terrain = 7
  IF a$ = "C" THEN Terrain = 8
  IF a$ = "N" THEN Terrain = custom
RETURN
  
Evaluate:
  a = land(x, y)
  ON a GOTO Desert, Water, Trees, Fields, Lava, Mountains, Dungeons, City
  COLOR wht: PRINT "?";
RETURN
Desert:
  COLOR yel: PRINT "D";
  RETURN
Water:
  COLOR blu: PRINT "W";
  RETURN
Trees:
  COLOR grn: PRINT "T";
  RETURN
Fields:
  COLOR Lgrn: PRINT "F";
  RETURN
Lava:
  COLOR red: PRINT "L";
  RETURN
Mountains:
  COLOR brn: PRINT "M";
  RETURN
Dungeons:
  COLOR pur: PRINT "X";
  RETURN
City:
  COLOR wht: PRINT "C";
  RETURN
   
PrintMap:
  LPRINT
  LPRINT ver$
  LPRINT auth$
  LPRINT
  LPRINT "Map: "; MapName$
  LPRINT "Created by: "; Author$
  LPRINT "Date of last modification: "; RDate$
  LPRINT "Size: "; Xmax; " x "; Ymax
  FOR g = 1 TO NoTowns
    land(tx(g), ty(g)) = 0
  NEXT g
  FOR g = 1 TO NoDung
    land(dx(g), dy(g)) = 0
  NEXT g
  LPRINT
  FOR y = 1 TO Ymax
    LPRINT SPACE$(10);
    FOR x = 1 TO Xmax
      IF land(x, y) > 0 THEN
        GOSUB Pvaluate
      ELSE
        FOR g = 1 TO NoTowns
          IF (tx(g) = x) AND (ty(g) = y) THEN LPRINT CHR$(96 + g);
        NEXT g
        FOR g = 1 TO NoDung
          IF (dx(g) = x) AND (dy(g) = y) THEN LPRINT CHR$(109 + g);
        NEXT g
      END IF
    NEXT x
    LPRINT
  NEXT y
  LPRINT
  LPRINT "D   Desert"; TAB(20); "W   Water"; TAB(40); "T   Trees"; TAB(60); "F   Fields"
  LPRINT "L   Lava"; TAB(20); "M   Mountains"; TAB(40); "C, X   BLANK City, Dungeon"
  LPRINT
  LPRINT " Towns/Cities:"
  LPRINT
  FOR g = 1 TO NoTowns
    x = tx(g): y = ty(g): land(x, y) = 8
    a$ = CHR$(96 + g)
    LPRINT "#"; g; TAB(8); a$; TAB(15); x; ","; y; TAB(30); Tmap$(g); TAB(55); Tfile$(g)
  NEXT g
  LPRINT
  LPRINT " Dungeons:"
  LPRINT
  FOR g = 1 TO NoDung
    x = dx(g): y = dy(g): land(x, y) = 7
    a$ = CHR$(109 + g)
    LPRINT "#"; g; TAB(8); a$; TAB(15); x; ","; y; TAB(30); Dmap$(g); TAB(55); Dfile$(g)
  NEXT g
  x = 1: y = 1
  LPRINT
RETURN

Pvaluate:
  a = land(x, y)
  ON a GOTO pDesert, pWater, pTrees, pFields, pLava, pMountains, pDungeons, pCity
  COLOR wht: LPRINT "?";
RETURN
pDesert:
  COLOR yel: LPRINT "D";
  RETURN
pWater:
  COLOR blu: LPRINT "W";
  RETURN
pTrees:
  COLOR grn: LPRINT "T";
  RETURN
pFields:
  COLOR Lgrn: LPRINT "F";
  RETURN
pLava:
  COLOR red: LPRINT "L";
  RETURN
pMountains:
  COLOR brn: LPRINT "M";
  RETURN
pDungeons:
  COLOR pur: LPRINT "X";
  RETURN
pCity:
  COLOR wht: LPRINT "C";
RETURN
  
Quit:
  SYSTEM
END

SetTileNames:
  TileName$(1) = "sand"
  TileName$(2) = "water"
  TileName$(3) = "tree"
  TileName$(4) = "grass"
  TileName$(5) = "lava"
  TileName$(6) = "mountain"
  TileName$(7) = "dungeon"
  TileName$(8) = "town"
  TileName$(9) = "player"
  TileName$(10) = "brick"
  TileName$(11) = "sandston"
  TileName$(12) = "treasure"
  TileName$(13) = "weapon"
  TileName$(14) = "armor"
  TileName$(15) = "item"
  TileName$(16) = "table"
  TileName$(17) = "Door"
  TileName$(18) = "LockDoor"
  TileName$(19) = "Person0"
  TileName$(20) = "Person1"
  TileName$(21) = "Person2"
  TileName$(22) = "Person3"
  TileName$(23) = "Person4"
  TileName$(24) = "Person5"
  TileName$(25) = "Merchant"
  TileName$(26) = "Potion"
  TileName$(27) = "Wall"
  TileName$(28) = "Gold"
  TileName$(29) = "wood"
  TileName$(30) = "fountain"
  TileName$(31) = "key"
  TileName$(32) = "pickaxe"
  TileName$(33) = "boat"
  TileName$(34) = "sworelem"
  TileName$(35) = "shadrack"
  TileName$(36) = "sceptre"
  TileName$(37) = "crstatue"
  TileName$(38) = "gravelfl"
  TileName$(39) = "stonwall"
  TileName$(40) = "magicxtl"
  TileName$(41) = "setenc"
  TileName$(42) = "torch"
  TileName$(43) = "message"
  TileName$(44) = "lamp"
  TileName$(45) = "barrel"
RETURN

SUB GetName (a$, b$) STATIC
  REM Window 3,"Enter names for Dugeon or City:",(1,30)-(600,100)
  INPUT "Filename: ", a$
  INPUT "Mapname: ", b$
  REM Window CLOSE 3
END SUB

SUB main STATIC
SHARED ver$
  REM Window 2,ver$
END SUB

SUB status STATIC
  REM Window 3,"Status"
END SUB

SUB TPorter (x, y) STATIC
  REM Window 3,"Enter coordinates to teleport to:",(1,30)-(300,70)
  INPUT "  X: ", x
  INPUT "  Y: ", y
  REM Window CLOSE 3
END SUB

