MapX = 80: MapY = 25
NoTowns = 10: Dungeons = 10

DIM land%(MapX, MapY)
DIM TName$(NoTowns), TFile$(NoTowns), TownX(NoTowns), TownY(NoTowns)
DIM shn$(Shops), ShopType(Shops)
DIM Dmap$(Dungeons), DFile$(Dungeons), DungX(Dungeons), DungY(Dungeons)

CLS
GOSUB LoadMap
PRINT : PRINT : PRINT
PRINT "Ready printer and hit any key."
WHILE a$ = ""
  a$ = INKEY$
WEND

LPRINT
LPRINT "******  "; MapName$; "  ******"
LPRINT
LPRINT "Created by: "; Author$; "  on  "; revDat$
LPRINT

FOR y = 1 TO YMapSize
    LPRINT
    FOR x = 1 TO XMapSize
        a = land%(x, y)
        SELECT CASE a
            CASE 1: LPRINT "-";
            CASE 2: LPRINT "/";
            CASE 3: LPRINT "!";
            CASE 4: LPRINT ".";
            CASE 5: LPRINT "%";
            CASE 6: LPRINT "^";
            CASE 7: LPRINT "@";
            CASE 8: LPRINT "*";
            CASE ELSE: LPRINT "?";
        END SELECT
    NEXT x
NEXT y
LPRINT : LPRINT
LPRINT "LEGEND:"
LPRINT "         -  Sand          /  Water         !  Trees"
LPRINT "         .  Grass         %  Lava          ^  Mountain"
LPRINT "         @  Dungeon       *  City          ?  OTHER"
LPRINT

END

LoadMap:
  OPEN "shalwrap.sma" FOR INPUT AS #2
  PRINT "Loading..."
  INPUT #2, xx$, b
  IF xx$ <> "SMAP" THEN PRINT "WARNING -- Bad Map Format!"
  INPUT #2, MapName$
  INPUT #2, Author$, revDat$
  INPUT #2, XMapSize, YMapSize
  IF XMapSize > 60 OR YMapSize > 22 THEN PRINT "WARNING --Map too large!"
blow:
  INPUT #2, xx$
  IF UCASE$(xx$) <> "TOWNS" THEN GOTO blow
  PRINT "Towns...    "
  INPUT #2, NoTowns
  IF NoTowns = 0 THEN GOTO LDung
  FOR x = 1 TO NoTowns
    INPUT #2, TownX(x), TownY(x), TFile$(x), Tmap$(x)
    land%(TownX(x), TownY(x)) = town
  NEXT x
LDung:
  INPUT #2, xx$
  IF UCASE$(xx$) <> "DUNGEONS" THEN GOTO LDung
  PRINT "Dungeons..."
  INPUT #2, NoDung
  IF NoDung = 0 THEN GOTO LMap
  FOR x = 1 TO NoDung
    INPUT #2, DungX(x), DungY(x), DFile$(x), Dmap$(x)
    land%(DungX(x), DungY(x)) = Dungeon
  NEXT x
LMap:
  INPUT #2, xx$
  IF UCASE$(xx$) <> "MAP ARRAY" THEN GOTO LMap
  LOCATE 1, 1: PRINT "Main Map:  22"
  FOR y = 1 TO YMapSize
    FOR x = 1 TO XMapSize
      land%(x, y) = ASC(INPUT$(1, #2))
    NEXT x
    LOCATE 1, 16: PRINT y
  NEXT y
LDone:
  CLOSE #2
RETURN

