'  SCEPTRE OF SHALIMAR VERSION 0.69 ... For IBM-Compatibles
'
'   Created by Seth Hopkinson ... Using AmigaBASIC & Ms Dos QBASIC
'   Last Modification --  9 Jun 1996
'
DECLARE SUB SetGlobals ()
DECLARE SUB LoadGfx ()
DECLARE SUB AngryMerchantSub ()
DECLARE SUB readMe (finam$, co!, hi!)
DECLARE SUB HelpScreen ()
DECLARE SUB AddItem (Number!)
DECLARE SUB MsgOut (A$)
DECLARE SUB ScanItem (n!)
DECLARE SUB display (file$)
DECLARE SUB Toggle (var!)
DECLARE SUB CLPrint (px%, py%, cpen!, paper!, msg$)
DECLARE SUB ClPrintr (px%, py%, cpen!, paper!, msg$)
DECLARE SUB TwindowClose ()
DECLARE SUB Twindow (num, clr, title$)
DECLARE SUB CenterText (text$, posn%)
DECLARE SUB PrintAt (px%, py%, msg$)
DECLARE SUB HitAnyKey ()
DECLARE SUB ukey (zxc$)
DECLARE SUB WaitNSec (n!)
DECLARE SUB Item (fore!, fore$, aft!, aft$)
DECLARE SUB ItemAt (px%, py%, fore!, fore$, aft!, aft$)
DECLARE SUB GetKey (zxc$)
DECLARE SUB GetQuality (Quality!, qt$, FX!)
DECLARE SUB Erx (zxc$)
DECLARE SUB InitTiles ()
DECLARE SUB SaveTile (tileNo, x!, y!, fm$)
DECLARE SUB loadTile (tileNo, fm$)
DECLARE SUB tileAt (xt!, yt!, tileNo%)
DECLARE SUB DrawMap (xm, ym)
DECLARE SUB DrawPeer (xm, ym, xdir, ydir)

CLEAR , , 2048

DIM SHARED fore, aft, black, blk, brn, red, yel, grn, blu, pur, wht
DIM SHARED org, lgr, mgr, dgr, lred, lyel, lgrn, lblu, dlvl, curMap
DIM SHARED TileSize%, tileXsize, tileYsize, NumTiles, ViewX, ViewY, Items
DIM SHARED Dlvls, dungXsize, dungYsize, townXsize, townYsize, MapX, MapY

InitTiles
Monsters = 51: Spells = 51: Items = 18: MaxDungs = 10: MaxTowns = 10
Shops = 9: MonWeap = 6
SetGlobals

DIM SHARED tile%(TileSize%, NumTiles), land%(MapX, MapY)
DIM SHARED dungmap%(Dlvls, dungXsize, dungYsize), Town%(townXsize, townYsize)
DIM SHARED ItemNo(Items), ItemChg(Items), ItemName$(Items), ItemCost(Items)
DIM SHARED ItemDesc$(Items), noItems, True, inBoat, ItemChFlag

LoadGfx
Weapons = 13: NormWeap = 10: Fams = Weapons: noItems = 0: NumItems = 0
Armors = 9: NormArm = 7:  NoSpells = 0: NumSpells = 0: LastMon = 0
City = 8: Dungeon = 7: lava = 5: mountain = 6: water = 2: sandston = 11
encount = 1: coord = 0: Rstr = 1: True = 0: inBoat = 0: delMsg = 0
ItemChFlag = 1: Rumors = 0: NoTowns = 0: NoDungs = 0: NoShops = 0

DIM SpXp, SpellAdv, Advance, ArmNo, ArmPro, ArmQ, NoMon, nms, NoDung
DIM WpFam(Fams)
DIM wplo(2), wphi(2), weap$(2), weap(2), verbset(2), HitPer(2), FamNo(2)
DIM tblo(Weapons), tbhi(Weapons), tbnam$(Weapons), tbprc(Weapons), tbverb(Weapons)
DIM atpro(Armors), apric(Armors), anam$(Armors), atdmg(Armors)
DIM Atk$(5, 6)
DIM spellName$(Spells), Verb$(Spells), VerbType(Spells), Mpoints(Spells)
DIM Sfx(Spells), slo(Spells), shi(Spells), level(Spells)
DIM spadl(Spells), spadh(Spells), SCode$(Spells), Sxp(Spells)
DIM spellfail$(Spells), Sdec$(Spells), SpellNo(Spells), TimesCast(Spells)
DIM mter(Monsters), Morale(Monsters), Disp(Monsters), MLevel(Monsters)
DIM Mxp(Monsters), mnam$(Monsters), MStr(Monsters), MHitPer(Monsters)
DIM MTough(Monsters), MNHit(Monsters), MNMag(Monsters), noweap(Monsters)
DIM LGold(Monsters), HGold(Monsters), MSel(Monsters), MArm$(Monsters)
DIM MPro(Monsters), MnSpells(Monsters)
DIM MWeap$(Monsters, MonWeap), Vrb$(Monsters, MonWeap)
DIM LoWeap(Monsters, MonWeap), HiWeap(Monsters, MonWeap)
DIM TName$(MaxTowns), TFile$(MaxTowns), TownX(MaxTowns), TownY(MaxTowns)
DIM shn$(Shops), ShopType(Shops), NewSpell(10)
DIM Dmap$(MaxDungs), DFile$(MaxDungs), DungX(MaxDungs), DungY(MaxDungs)
DIM who$(Shops), rumor$(Shops), ItsBeenSaid(Shops)

DEF fnran (Low, High) = INT(RND(1) * ((High + 1) - Low)) + Low

RANDOMIZE TIMER
GOSUB SetWindow2
lastmod$ = "June 8, 1996"
ver$ = "The Sceptre of Shalimar    IBM Version 0.69"
VERSION = .69: Spir = 0
GOSUB SetWindow1
LOCATE 20, 1: GOSUB ColorTest: COLOR yel
CenterText ver$, c%
CLPrint c%, 2, 3!, 0!, ver$
b$ = "Created by: Seth Hopkinson   October 3, 1991"
CenterText b$, c%: PrintAt c%, 4, b$
c$ = "Last Modification:  " + lastmod$
CenterText c$, c%: PrintAt c%, 5, c$
PrintAt 31, 7, "Loading Fonts..."
PrintAt 31, 7, "Initializing..."
PrintAt 31, 7, "Reading Weapons..."
FOR g = 0 TO Weapons
  READ tbnam$(g), tbprc(g), tblo(g), tbhi(g), tbverb(g)
NEXT g
PrintAt 31, 7, "Reading Armors... "
FOR g = 0 TO Armors
  READ anam$(g), apric(g), atpro(g), atdmg(g)
NEXT g
PrintAt 31, 7, "Reading Verbs...  "
FOR g = 1 TO 5
  READ Set
  FOR b = 1 TO 6
    READ Atk$(Set, b)
  NEXT b
NEXT g

COLOR lgr
PrintAt 30, 7, "Loading Monsters...": GOSUB LoadMonsters: GOSUB MonSel
PrintAt 30, 8, "Loading Spells...  ": GOSUB LoadSpells: COLOR lgr
PrintAt 30, 9, "Loading Items...  ": GOSUB LoadItems
COLOR lgr: GOSUB LoadMap: LOCATE 20, 20

Restart:
RANDOMIZE TIMER
erflag = 0
FOR g = 0 TO Fams: WpFam(g) = 0: NEXT g
GOSUB TitleScreen: CLS

IF (UCASE$(xx$)) = "L" THEN
    GOSUB LoadGame
    IF erflag = 1 THEN
        GOTO Restart
    ELSE
        GOTO Outside
    END IF
END IF
IF (UCASE$(xx$)) = "S" THEN
    readMe "storylin.TXT", yel, lred
    GOTO Restart
END IF
IF (UCASE$(xx$)) = "V" THEN
    readMe "readMe.txt", lgr, lred
    GOTO Restart
END IF

GOSUB GenStats
GOSUB DisplayChar
xx$ = nam$ + "'s Adventure begins!"
S = 35 - INT(LEN(xx$) / 2)
PRINT : PRINT : COLOR yel: PRINT SPC(S); xx$
COLOR wht
HitAnyKey
NewChar = 0
youX = 15: youY = 15
GOTO Outside

SetWindow2:
    TwindowClose
RETURN

SetWindow1:
    Twindow 0, 0, ver$
RETURN

InitMap:
  GOSUB SetWindow2
  CLS
  LOCATE 23, 3: PRINT MapName$
  COLOR lgr: LOCATE 10, 32: PRINT "Press";
  COLOR lred: LOCATE 11, 32: PRINT "ESC";
  COLOR lgr: LOCATE 12, 32: PRINT "for";
  LOCATE 13, 32: PRINT "help";
  LOCATE 14, 32: PRINT "screen.";
  GOSUB coords
  dead$ = ""
DoMapDraw:
  DrawMap youX, youY
RETURN

coords:
  IF coord = 0 THEN RETURN
  COLOR lblu
  LOCATE 1, 32: PRINT "X:"; youX
  LOCATE 2, 32: PRINT "Y:"; youY
RETURN

Outside:
  SCREEN 7, , aft, aft
  GOSUB InitMap
  SCREEN 7, , fore, fore
  GOSUB InitMap
50 GOSUB DispMP
  GOSUB dispHP
  IF inBoat = 0 THEN
    tileAt ViewX + 1, ViewY + 1, 9
  ELSE
    tileAt ViewX + 1, ViewY + 1, 33
  END IF
  ox = youX: oy = youY
  xx$ = INKEY$: xx$ = UCASE$(xx$): f = land%(youX, youY)
  CuTim = TIMER
  IF xx$ = "S" THEN GOSUB SaveGame
  IF xx$ = "L" THEN GOTO OutLoad
  IF xx$ = "R" THEN GOTO OutStart
  IF xx$ = "Q" THEN GOTO OutQuit
  IF xx$ = "@" THEN GOSUB Editor: GOTO Outside
  IF xx$ = "C" OR xx$ = "5" THEN GOSUB CastSpell: GOSUB InitMap: GOSUB DispMP: GOSUB dispHP
  IF xx$ = "V" THEN GOTO OutView
  IF f = City THEN GOTO CheckTowns
  IF f = Dungeon THEN GOTO CheckDungeons
  IF xx$ = " " THEN COLOR fnran(1, 15): LOCATE 22, 37: PRINT "*"; : GOTO chk
  IF xx$ = CHR$(139) OR xx$ = CHR$(27) THEN HelpScreen: GOSUB DoMapDraw
ACC:
  IF ABS(TIMER - CuTim) < .05 THEN GOTO ACC
  IF xx$ = "8" OR xx$ = CHR$(28) THEN youY = youY - 1
  IF xx$ = "2" OR xx$ = CHR$(29) THEN youY = youY + 1
  IF xx$ = "4" OR xx$ = CHR$(31) THEN youX = youX - 1
  IF xx$ = "6" OR xx$ = CHR$(30) THEN youX = youX + 1
  IF xx$ = "7" THEN youX = youX - 1: youY = youY - 1
  IF xx$ = "1" THEN youX = youX - 1: youY = youY + 1
  IF xx$ = "9" THEN youX = youX + 1: youY = youY - 1
  IF xx$ = "3" THEN youX = youX + 1: youY = youY + 1
  IF youX < 1 THEN youX = MapX
  IF youX > MapX THEN youX = 1
  IF youY < 1 THEN youY = MapY
  IF youY > MapY THEN youY = 1
chk:
  IF ox <> youX OR oy <> youY OR xx$ = " " THEN
    IF delMsg > 0 THEN
        delMsg = delMsg - 1
        IF delMsg = 0 THEN MsgOut SPACE$(48)
    END IF
    DrawMap youX, youY
    LOCATE 22, 37: PRINT " ";
    GOSUB coords
    Moves = Moves + 1
    A = land%(youX, youY)
    IF A = lava THEN GOSUB ugh
    IF inBoat = 1 AND A <> water THEN
        inBoat = 0
    END IF
    GOSUB TerCheck
    IF errFlag = 1 THEN youX = ox: youY = oy: xx$ = " ": GOTO chk
    IF HitPoints < 0 THEN GOTO Death
    IF INT(Moves / 5) = Moves / 5 THEN GOSUB AddMagic
    IF INT(Moves / 10) = Moves / 10 THEN GOSUB AddHP
    A = fnran(1, 100)
    IF xx$ = " " THEN
      IF INT(A / 25) = A / 25 THEN GOTO Encounter
    ELSE
      IF INT(A / 10) = A / 10 THEN GOTO Encounter
    END IF
  END IF
GOTO 50

TerCheck:
    errFlag = 0
    IF Rstr = 0 THEN RETURN
    IF A = water THEN
        ScanItem 1
        IF True THEN
            inBoat = 1
        ELSE
            MsgOut "Far too rough   to swim!"
            GOSUB buzz: delMsg = 2: errFlag = 1
        END IF
    ELSEIF A = mountain THEN
        ScanItem 2
        IF True THEN
            GOSUB click
        ELSE
            MsgOut "Need    climbinggear."
            GOSUB buzz: delMsg = 2: errFlag = 1
        END IF
    ELSEIF A = sandston THEN
        ScanItem 3
        IF True THEN
            GOSUB click
            MsgOut "You     chizel  your waythrough."
            delMsg = 1
        ELSE
            MsgOut "In Sand-stone?  I do notthink   so!!!"
            GOSUB buzz: delMsg = 2: errFlag = 1
        END IF
    END IF
RETURN

ugh:
  ScanItem 10
  IF True THEN
    MsgOut "That    was...Ohnever-  mind!"
    GOSUB buzz
    delMsg = 1
  ELSE
    MsgOut "That waslava    stupid!!"
    delMsg = 1
    HitPoints = HitPoints - INT(mHits / 2)
    GOSUB dispHP
    GOSUB spak
    IF HitPoints < 0 THEN dead$ = "by walking in Firey Molten Lava"
  END IF
RETURN

AddMagic:
  IF Magic < MMagic THEN Magic = Magic + 1
DispMP:
  hc = grn: IF Magic < (MMagic * .25) THEN hc = yel
  IF Magic > MMagic THEN hc = wht
  LOCATE 4, 32: COLOR hc: PRINT "MP";
  LOCATE 4, 35: PRINT Magic;
RETURN

AddHP:
  IF HitPoints < mHits THEN HitPoints = HitPoints + 1
dispHP:
  hc = yel: IF HitPoints < (mHits * .2) THEN hc = red
  IF HitPoints = mHits THEN hc = grn
  IF HitPoints > mHits THEN hc = wht
  LOCATE 3, 32: COLOR hc: PRINT "HP";
  LOCATE 3, 35: PRINT HitPoints;
  LOCATE 5, 32: COLOR yel: PRINT "GD";
  LOCATE 5, 35: PRINT Gold;
RETURN

OutLoad:
  sure$ = "LOAD GAME": GOSUB AreYouSure
  IF sure$ = "Y" THEN GOSUB LoadGame: GOTO Outside
GOTO Outside

OutStart:
  sure$ = "RESTART GAME": GOSUB AreYouSure
  IF sure$ = "Y" THEN
    GOSUB SetWindow1
    GOTO Restart
  END IF
GOTO Outside

OutQuit:
  sure$ = "QUIT GAME": GOSUB AreYouSure
  IF sure$ = "Y" THEN GOTO QuitGame
GOTO Outside

OutView:
  GOSUB DisplayChar
GOTO Outside

CheckDungeons:
  tn = 0
  FOR g = 1 TO NoDung
    IF DungX(g) = youX AND DungY(g) = youY THEN tn = g: g = NoDung
  NEXT g
  xx$ = UCASE$(DFile$(tn))
  sure$ = "Dungeon " + CHR$(34) + Dmap$(tn) + CHR$(34)
  GOSUB NoTDP
  A = TIMER
GOTO ACC

Encounter:
  IF encount = 0 THEN GOTO 50
  tries = 0
51 m = fnran(1, nms)
  b = MSel(m)
  IF (mter(b) AND (2 ^ (land%(youX, youY) - 1))) THEN GOSUB Fight: GOTO 52
  tries = tries + 1: IF tries < 50 THEN GOTO 51
  CLS
  GOSUB SetWindow2
  TwindowClose
  GOSUB DoMapDraw
GOTO 50
52 IF HitPoints < 0 THEN
     combat = 0
     dead$ = "by " + mon$
     COLOR lgr: PRINT : PRINT "YOU HAVE BEEN SLAIN!!!!!": GOSUB HiLf
     HitAnyKey
     TwindowClose
     GOSUB SetWindow1
     GOTO Death
   ELSE
     GOSUB dispHP
     GOSUB DispMP
     GOTO 50
   END IF

Fight:
  GOSUB SetWindow1
  CLS
  mon$ = mnam$(b): V$ = UCASE$(LEFT$(mon$, 1))
  IF V$ = "A" OR V$ = "E" OR V$ = "I" OR V$ = "O" OR V$ = "U" THEN mon$ = "An " + mon$: GOTO FSetUp
  mon$ = "A " + mon$
FSetUp:
  HisHits = MNHit(b): HisMag = MNMag(b): HisMorale = Morale(b): HisStr = MStr(b)
  HisArm = MPro(b): HisPer = MHitPer(b): HisTuf = MTough(b)
FLabel:
  A = fnran(1, 6)
  COLOR yel
  ON A GOSUB 60, 61, 62, 63, 64, 65
  GOTO cnfight
60 PRINT mon$; " growls defiantly!": RETURN
61 PRINT mon$; " stands in your way.": RETURN
62 PRINT "Out of seemingly nowhere, "; mon$; " appears and viciously attacks!": RETURN
63 PRINT "You curse and swear as "; mon$; " charges out towards you.": RETURN
64 PRINT "The sudden appearance of "; mon$; " brings you to attention.": RETURN
65 PRINT mon$; " tries to ransack you and steal all that you own!": RETURN
cnfight:
  COLOR lblu: PRINT
  PRINT "Will you "; : COLOR lred: PRINT "F"; : COLOR lblu: PRINT "ight it or"
  PRINT "Attepmt to "; : COLOR lred: PRINT "R"; : COLOR lblu: PRINT "un away?"
78 ukey xx$
  IF xx$ = "F" OR xx$ = "A" THEN mn$ = mnam$(b): GOTO FFight
  IF xx$ = "R" THEN GOTO Frun
GOTO 78

FFight:
  COLOR lgr: PRINT : PRINT "You face "; : COLOR lblu: PRINT mon$
  COLOR brn: PRINT : PRINT "You have "; Magic; " magic points left,"
  IF HitPoints < INT(mHits * .2) THEN COLOR red
  PRINT "You have "; HitPoints; " hit points left."
  COLOR lgr: PRINT : PRINT "Will you:"
  COLOR lyel: PRINT "A"; : COLOR org: PRINT "ttack, ";
  IF NoSpells > 0 AND Magic > 0 THEN COLOR lyel: PRINT "C"; : COLOR org: PRINT "ast spell, ";
  COLOR lyel: PRINT "V"; : COLOR org: PRINT "iew your stats, OR ";
  COLOR lyel: PRINT "R"; : COLOR org: PRINT "un away?"
  combat = 1: Cspl = 0
90 ukey xx$
  IF xx$ = "R" THEN GOTO Frun
  IF xx$ = "C" THEN GOTO CombatSpell
  IF xx$ = "A" THEN GOTO Attack
  IF xx$ = "V" THEN GOSUB DisplayChar: GOTO FFight
  BEEP: GOTO 90
Attack:
  CLS
  FOR h = 1 TO 2: GOSUB YouAtk: NEXT h
HimFight:
  FOR g = 1 TO noweap(b)
    GOSUB HisAtk
  NEXT g
WinCheck:
  IF HitPoints < 0 THEN RETURN
  IF HisHits < 0 THEN GOTO YouWon
GOTO FFight

CombatSpell:
  Target$ = mon$
  GOSUB CCSpell
  COLOR lblu
  Cspl = 0: dam = 0
  IF wf = 3 THEN
    HitAnyKey
    GOTO FFight
  END IF
  IF wf = 2 THEN
    PRINT "You cannot cast that in the heat of battle!"
    HitAnyKey
    GOTO FFight
  END IF
  IF wf = 1 THEN GOTO HimFight
  SpXp = SpXp + Sxp(spellTabl)
  TimesCast(spellTabl) = TimesCast(spellTabl) + 1
  IF (FX AND 512) THEN
    PRINT "You evade the "; mn$
    PRINT "and escape unnoticed!"
    HitAnyKey
    GOTO ItsOver
  END IF
  IF (FX AND 1) THEN
    Cspl = 0
    dam = fnran(slo(spellTabl), shi(spellTabl))
    PRINT "The "; mn$; " takes "; : COLOR red: PRINT dam; : COLOR lblu: PRINT " damage!!!"
    GOSUB YouDone
    dam = 0
  END IF
  IF (FX AND 32) THEN
    dam = 0
    IF HisArm > slo(spellTabl) THEN
      PRINT "NO EFFECT!": GOSUB click
    ELSEIF HisArm <= 0 THEN
      PRINT "The "; mn$; " has no armor!"
    ELSE
      A = fnran(1, 100)
      IF A <= shi(spellTabl) THEN
        Cspl = 32
        GOSUB YouDone
      ELSE
        PRINT "The "; mn$; "'s "; MArm$(b); " is weakening!"
        HisArm = HisArm - 1: IF HisArm < 1 THEN HisArm = 1
        GOSUB aab
      END IF
    END IF
  END IF
  IF (FX AND 2048) THEN
    PRINT "The "; mn$; " is unable to fight!"
    GOTO WinCheck
  END IF
  IF SpXp > MagVance THEN GOSUB MageLevel
GOTO HimFight

HisAtk:
   COLOR red
   A = fnran(1, 100)
   IF A > HisPer THEN
     PRINT "The "; mn$; " misses!"
     GOSUB Missed
     RETURN
   END IF
   dam = HisStr + fnran(LoWeap(b, g), HiWeap(b, g))
   PRINT "The "; mn$; " "; Vrb$(b, g); " "; nam$; " with it's "; MWeap$(b, g); " for";
   COLOR lgrn: PRINT dam; : COLOR red: PRINT "!!!"
   GOSUB ItHit
   IF ArmPro < 1 THEN GOTO HeTuf
   PreArm = dam
   dam = dam - ArmPro
   IF dam < 1 THEN
     dam = 0
     COLOR pur: PRINT nam$; "'s "; ArmName$; " absorbs the whole blow!!"
     GOSUB aab
     ArmQ = ArmQ - (PreArm / ArmNo)
     GOTO HeDone
   ELSE
     COLOR pur: PRINT nam$; "'s "; ArmName$; " softens the blow."
     GOSUB asf
     ArmQ = ArmQ - (PreArm / ArmNo)
   END IF
HeTuf:
   dam = dam - Tough
   IF dam < 1 THEN
     COLOR pur: PRINT nam$; " IS UNHARMED BY THIS ATTACK!"
     GOSUB tuf
     dam = 0
   END IF
HeDone:
   IF ArmQ < 1 THEN
     COLOR brn
     PRINT nam$; "'s "; ArmName$; " BREAKS AND FALLS TO THE GROUND..."
     GOSUB BrArm
     IF ArmQ > -1000 THEN GOSUB ResetArm
   END IF
   HitPoints = HitPoints - dam
RETURN

YouAtk:
  CW = weap(h)
  tohit = WpFam(CW)
  IF tohit > 125 THEN tohit = 125
  A = fnran(1, 100)
  IF A > tohit THEN
    IF tohit <= WeapSkill THEN tohit = tohit + WeapSkill
    tohit = tohit + .5
    COLOR grn: PRINT nam$; " MISSED!!!"
    IF h = 1 THEN GOSUB Missed
    IF h = 2 THEN GOSUB rmiss
    WpFam(CW) = tohit
    RETURN
  END IF
  dam = fnran(1, 6): dam$ = Atk$(verbset(h), dam)
  dam = Strength + fnran(wplo(h), wphi(h))
  COLOR grn: PRINT nam$; " "; dam$; " "; mon$; " with a "; weap$(h); " for "; : COLOR red
  PRINT dam; : COLOR grn: PRINT "!!!"
  IF h = 1 THEN GOSUB YouHit
  IF h = 2 THEN GOSUB RYouHit
  COLOR yel: WpFam(CW) = WpFam(CW) + .2
  IF HisArm < 1 THEN GOTO YouTuf
  dam = dam - HisArm
  IF dam < 1 THEN
    dam = 0
    PRINT "The "; mn$; "'s "; MArm$(b); " absorbs the whole blow!"
    GOSUB aab
    GOTO YouDone
  ELSE
    PRINT "The "; mn$; "'s "; MArm$(b); " softens the blow!"
    GOSUB asf
  END IF
YouTuf:
  dam = dam - HisTuf
  IF dam < 1 THEN
    dam = 0: COLOR yel
    PRINT "THE "; mn$; " IS NOT EVEN PHASED BY THAT ATTACK!"
    GOSUB tuf
    RETURN
  END IF
YouDone:
  A = fnran(1, 100)
  IF Cspl = 32 OR ((HisArm > 0) AND (INT(A / 25) = A / 25)) THEN
    HisArm = 0
    COLOR brn: PRINT "The "; mn$; "'s "; MArm$(b); " BREAKS INTO 1,000 PIECES!"
    GOSUB BrArm
  END IF
  HisHits = HisHits - dam
RETURN

YouWon:
  combat = 0
  COLOR lgr: PRINT
  PRINT "The "; mn$; " has been defeated!!!"
  GOSUB ItDies
  A = fnran(LGold(b), HGold(b))
  PRINT "You find "; : COLOR yel: PRINT A; : COLOR lgr: PRINT " gold pieces in the remains!"
  Gold = Gold + A
  PRINT "You get "; Mxp(b); " experience points for the kill!"
  xp = xp + Mxp(b)
  COLOR brn: PRINT
  HitAnyKey
  IF xp >= uplevel THEN GOSUB YouAdvance
ItsOver:
  combat = 0
  GOSUB SetWindow2: GOSUB DoMapDraw
RETURN

Frun:
  IF HitPoints < (mHits * .2) THEN
    A = fnran(1, 100)
    IF A > 19 AND A < 81 THEN
      COLOR yel: PRINT "Addrenalin Boost!!!"
      GOSUB Rave
      GOTO 76
    END IF
  END IF
  A = fnran(1, 100)
  IF A > 60 THEN
    COLOR org: PRINT "IT PURSUES!!!";
    GOSUB click
    A = fnran(1, 20)
    IF A < HisMorale THEN
      g = fnran(1, noweap(b))
      A = INT(fnran(LoWeap(b, g), HiWeap(b, g)) / 2)
      PRINT "And hits you for "; : COLOR red: PRINT A; : COLOR org: PRINT " damage!"
      HitPoints = HitPoints - A: IF HitPoints < 0 THEN RETURN
    ELSE
      PRINT
    END IF
    PRINT : GOTO FLabel
  END IF
76 A = fnran(1, 6)
   combat = 0
77 PRINT : COLOR grn
  ON A GOSUB 70, 71, 72, 73, 74, 75
  GOTO 79
70 PRINT "After a long, exhausting chase you manage to escape!": RETURN
71 PRINT "The "; mnam$(b); " stands laughing at your cowardice.": RETURN
72 PRINT "You yell a few swear words at the "; mnam$(b); " and walk away.": RETURN
73 PRINT "The "; mnam$(b); " waves its middle finger high into the air"
   PRINT "as you hastily run away...": RETURN
74 PRINT "The "; mnam$(b); " fumbles around with something and a fireball"
   PRINT "roars towards you as you run away.  Fortunately, it misses!": RETURN
75 PRINT "The "; mnam$(b); " is startled by your actions and runs away!"
   PRINT "Evidently, it wasn't as brave as it looked...": RETURN
79 HitAnyKey
GOTO ItsOver

YouAdvance:
  COLOR yel: PRINT
  PRINT "Your combat knowledge has increased sufficiently...  YOU HAVE ADVANCED!"
  COLOR org
  Advance = Advance + 1: uplevel = 25
  FOR g = 1 TO Advance
    uplevel = uplevel + (g * 25)
  NEXT g
  GOSUB MonSel
  GOSUB 122
  GOSUB 123
129 IF INT(Advance / 2) = Advance / 2 THEN
    GOSUB 120
  ELSE
    GOSUB 121
  END IF
  HitAnyKey
RETURN
120 Strength = Strength + 1
    IF Strength > 10 THEN Strength = 10: GOTO 123
    PRINT "You are now STRONGER!": RETURN
121 Tough = Tough + 1
    IF Tough > 5 THEN Tough = 5: GOTO 123
    PRINT "You are now TOUGHER!": RETURN
122 PRINT "HitPoints Up!": h = fnran(2, 6)
    HitPoints = HitPoints + h: mHits = mHits + h: RETURN
123 IF WeapSkill > 50 THEN WeapSkill = 50: GOTO NowWhat
    h = fnran(2, 4)
    WeapSkill = WeapSkill + h: IF WeapSkill > 50 THEN WeapSkill = 50
    PRINT "Weapon Skill has improved!"
    FOR g = 1 TO Fams
      IF WpFam(g) > 0 THEN WpFam(g) = WpFam(g) + h
      IF WpFam(g) > 125 THEN WpFam(g) = 125
    NEXT g
    RETURN
NowWhat:
  IF Strength < 10 THEN
    GOTO 120
  ELSEIF Tough < 5 THEN
    GOTO 121
  ELSE
   GOTO 122
  END IF
RETURN

MonSel:
  nms = 0
  FOR g = 1 TO NoMon
    IF MLevel(g) <= Advance THEN
      nms = nms + 1
      MSel(nms) = g
    END IF
  NEXT g
RETURN

MageLevel:
  COLOR yel: PRINT
  SpellAdv = SpellAdv + 1
  PRINT "Magical Ability has increased..."
  PRINT "You are now a level "; SpellAdv; " Mage!"
  h = fnran(3, 6)
  Magic = Magic + h: MMagic = MMagic + h
  MagVance = 25
  FOR g = 1 TO SpellAdv
    MagVance = MagVance + (g * 25)
  NEXT g
  COLOR red
  HitAnyKey
RETURN

CastSpell:
  Twindow 0, 1, "Cast Spell:"
  Target$ = "the thin air"
  GOSUB CCSpell
  PRINT : PRINT "Spell Casting Completed.  Hit any key."
  GetKey A$
  TwindowClose
  GOSUB DoMapDraw
RETURN

CCSpell:
  wf = 2
  IF NoSpells = 0 THEN
    COLOR yel: PRINT : PRINT " YOU HAVE NO SPELLS!"
    GOSUB LoLf
    wf = 3
    RETURN
  END IF
  IF Magic < 1 THEN
    COLOR yel: PRINT : PRINT " YOU HAVE NO MAGIC POINTS!"
    GOSUB LoLf
    wf = 3
    RETURN
  END IF
  CLS
  COLOR brn: PRINT "You have "; : COLOR grn: PRINT Magic;
  COLOR brn: PRINT " magic points."
  LOCATE 3, 1: PRINT "Cast Which spell";
  LOCATE 5, 1: COLOR blu: PRINT "(";
  COLOR red: PRINT "L"; : COLOR blu: PRINT " for list, ";
  COLOR red: PRINT "RETURN "; : COLOR blu: PRINT "for none.)";
  xx$ = "": LOCATE 3, 17: INPUT xx$
  xx$ = UCASE$(xx$)
  IF xx$ = "" THEN RETURN
  IF xx$ = "L" THEN GOSUB SpellList: GOTO CCSpell
  spellTabl = 0: CLS
  FOR aa = 1 TO NumSpells
    IF UCASE$(SCode$(aa)) = xx$ THEN spellTabl = aa
  NEXT aa
  IF spellTabl = 0 THEN
    COLOR red: LOCATE 3, 3: PRINT "NO SUCH SPELL!"
    GOSUB click
    WaitNSec .5
    wf = 3
    RETURN
  ELSE
    WhichSpell = 0
    FOR aa = 1 TO NoSpells
      IF SpellNo(aa) = spellTabl THEN WhichSpell = aa
    NEXT aa
    IF WhichSpell = 0 THEN
      COLOR red: LOCATE 3, 3: PRINT "YOU DON'T KNOW THAT SPELL!"
      GOSUB click
      WaitNSec .5
      wf = 3
      RETURN
    END IF
  END IF
  IF Magic < Mpoints(spellTabl) THEN
    COLOR red: LOCATE 3, 3: PRINT "Not enough Magic Points!"
    GOSUB spf
    WaitNSec .5
    wf = 3
    RETURN
  END IF
  COLOR grn: LOCATE 3, 3
  SELECT CASE VerbType(spellTabl)
    CASE 0: PRINT Verb$(spellTabl)
    CASE 1: PRINT nam$; " "; Verb$(spellTabl); " "; Target$
    CASE 2: PRINT nam$; " "; Verb$(spellTabl)
    CASE 3: PRINT Target$; " "; Verb$(spellTabl)
    CASE 4: PRINT Target$; " "; Verb$(spellTabl); " "; nam$
    CASE ELSE
      PRINT nam$; " casts a spell..."
  END SELECT
  Magic = Magic - Mpoints(spellTabl)
  GOSUB spl
  IF level(spellTabl) > SpellAdv THEN
    A = fnran(1, 100)
    IF A > (30 * (level(spellTabl) - SpellAdv)) THEN
      PRINT "..."; spellfail$(spellTabl)
      COLOR lred
      PRINT "(spell failed)"
      GOSUB spf
      COLOR grn
      wf = 3
      RETURN
    END IF
  END IF
  FX = Sfx(spellTabl)
  wf = 0
  IF FX >= 65535 THEN
    A = fnran(1, 100)
    IF A < 25 OR A > 75 THEN
        SELECT CASE fnran(1, 7)
            CASE 1: FX = 1: IF combat = 0 THEN FX = 64
            CASE 2: FX = 32: IF combat = 0 THEN FX = 128
            CASE 3: FX = 64
            CASE 4: FX = 128
            CASE 5: FX = 512: IF combat = 0 THEN FX = 0: Magic = Magic + (fnran(slo(spellTabl), shi(spellTabl)) * 2)
            CASE 6: FX = 1024: IF combat = 1 THEN FX = 2273
            CASE 7: FX = 2048: IF combat = 0 THEN FX = 192
        END SELECT
    ELSE
        FX = 0: wf = 1
    END IF
  END IF
  IF FX = 0 AND wf = 0 THEN COLOR lblu: PRINT "No noticeable effect...": RETURN
  IF (FX AND 64) THEN
    IF HitPoints >= mHits THEN
      wf = 1
    ELSE
      wf = 0
      aa = fnran(slo(spellTabl), shi(spellTabl))
      COLOR lblu: PRINT "You are healed: +";
      COLOR red: PRINT aa;
      COLOR lblu: PRINT " Hitpoints."
      HitPoints = HitPoints + aa
      IF HitPoints > mHits THEN HitPoints = mHits
    END IF
  END IF
  IF (FX AND 128) THEN
    wf = 0
    aa = fnran(slo(spellTabl), shi(spellTabl))
    COLOR lblu: PRINT "Armor Repaired."
    ArmQ = ArmQ + (aa * 10)
  END IF
  IF (FX AND 1024) THEN
    IF combat = 0 THEN
      wf = 0
      RangeX = shi(spellTabl)
      RangeY = slo(spellTabl)
      DrawPeer youX, youY, RangeX, RangeY
      GOSUB click
    ELSE
      wf = 2
      RETURN
    END IF
  END IF
  IF (FX AND 1) OR (FX AND 32) OR (FX AND 512) THEN
    IF combat = 0 THEN
      wf = 1
    ELSE
      wf = 0
      RETURN
    END IF
  END IF
  IF wf = 1 AND Sfx(spellTabl) < 65535 THEN
    COLOR red
    SELECT CASE fnran(1, 6)
        CASE 1: PRINT "Nice Job, Spell Waster!"
        CASE 2: PRINT "Are you having fun?"
        CASE 3: PRINT "Wow.  That WAS impressive."
        CASE 4: PRINT "Smooth Move!  Care to try again?"
        CASE 5: PRINT "<<<< Snap! Crackle! Pop! >>>>"
        CASE 6: PRINT "You should be proud of yourself..."
    END SELECT
    RETURN
  ELSEIF wf = 1 AND Sfx(spellTabl) = 65535 THEN
    PRINT spellfail$(spellTabl)
  ELSE
    SpXp = SpXp + Sxp(spellTabl)
    TimesCast(spellTabl) = TimesCast(spellTabl) + 1
    IF SpXp > MagVance THEN GOSUB MageLevel
  END IF
RETURN
 
Town:
  GOSUB SetWindow1
  CLS
  CenterText Town$, c%
  CLPrint c%, 2, yel, blk, Town$
  GOSUB Standards
  FOR g = 1 TO NoShops
    PRINT TAB(20); g; "   ";
    IF ShopCode(g) = 1 THEN PRINT "Go to the Weapon Shop"
    IF ShopCode(g) = 2 THEN PRINT "Go to the Armor Shop"
    IF ShopCode(g) = 3 THEN PRINT "Enter the Tavern"
    IF ShopCode(g) = 4 THEN PRINT "Visit the Mage's Guild"
    IF ShopCode(g) = 5 THEN PRINT "See the Healer"
    IF ShopCode(g) = 6 THEN PRINT "Visit the Adventurer's Guild"
    IF ShopCode(g) = 7 THEN PRINT "Fight a Gladiator in The Pit"
    IF ShopCode(g) = 8 THEN PRINT "Enter the Transport Emporium"
    IF ShopCode(g) = 9 THEN PRINT "Gamble at the Casino"
Specials:
    IF ShopCode(g) = 10 THEN PRINT "Check out the Lake"
    IF ShopCode(g) = 11 THEN PRINT "Explore the Ruins"
    IF ShopCode(g) = 12 THEN PRINT "Explore the Northern Caves"
    IF ShopCode(g) = 13 THEN PRINT "Enter an Unmarked Building"
    IF ShopCode(g) = 14 THEN PRINT "See the BoatWright"
    IF ShopCode(g) = 15 THEN PRINT "Speak to the Mystic"
    IF ShopCode(g) > 15 THEN PRINT "Go to the Inventor's Workshop"
  NEXT g
  COLOR org: PRINT
  PRINT TAB(16); "ENTER   ";
  COLOR lgr: PRINT "Leave the city."
  COLOR org: PRINT TAB(16); "SPACE   ";
  COLOR lgr: PRINT "Listen for Rumors."
  COLOR lyel: PRINT
  PRINT TAB(17); "What would you like to do?"
4 ukey xx$
  IF xx$ = "V" THEN GOSUB DisplayChar: goto Town
  IF xx$ = "S" THEN GOTO TownSave
  IF xx$ = "C" THEN GOSUB CCSpell: goto Town
  IF xx$ = CHR$(13) THEN youX = ExitX: youY = ExitY: GOTO Outside
  IF xx$ = " " THEN GOSUB TalkToMeBaby: goto Town
  A = VAL(xx$)
  IF A < 1 OR A > NoShops THEN BEEP: GOTO 4
  shn$ = shn$(A)
  IF ShopCode(A) > 9 THEN GOTO SpecialShop
  ON ShopCode(A) GOSUB WeaponShop, ArmorShop, Nprg, MageGuild, Healer, Guild, Pit, Nprg, Nprg
goto Town
SpecialShop:
Nprg:
  g = ShopCode(A)
  IF g = 10 THEN GOSUB Lake: goto Town
  IF g = 14 THEN GOSUB BoatWright: goto Town
  IF g = 15 THEN GOSUB Mystic: goto Town
NprgNs:
  CLS : COLOR lblu: PRINT
  PRINT "Alas, ";
  COLOR lred: PRINT shn$
  COLOR lblu: PRINT "could not be programed (See README.TXT)."
  PRINT
  HitAnyKey
goto Town

TalkToMeBaby:
  PRINT
  IF Rumors = 0 THEN
      COLOR lred
      PRINT " The city streets are deserted!  Everyone "
      PRINT " is in panic because of all the monsters! "
      HitAnyKey
      RETURN
  END IF
  tmp = 0
  FOR g = 1 TO Rumors
    IF ItsBeenSaid(g) = 0 THEN
       tmp = 1
       ItsBeenSaid(g) = 1
       SayIt = g
       g = Rumors
    END IF
  NEXT g
  IF tmp = 0 THEN SayIt = fnran(1, Rumors)
  COLOR lred
  PRINT who$(SayIt); " tells you:"
  COLOR lblu
  PRINT rumor$(SayIt)
  COLOR org
  HitAnyKey
RETURN

CheckTowns:
  tn = 0
  FOR g = 1 TO NoTowns
    IF TownX(g) = youX AND TownY(g) = youY THEN tn = g: g = NoTowns
  NEXT g
  A$ = UCASE$(RIGHT$(TFile$(tn), 4))
  IF A$ <> ".BTW" THEN
    IF A$ = ".TWN" THEN
      tmp = LEN(TFile$(tn))
      MID$(TFile$(tn), tmp - 3) = ".BTW"
    ELSE
      TFile$(tn) = TFile$(tn) + ".BTW"
    END IF
  END IF
  twn$ = TFile$(tn)
  GOSUB LoadTown
  IF erflag = 0 THEN
    GOTO Town
  ELSEIF erflag = 2 THEN
    sure$ = "Town " + CHR$(34) + Tmap$(tn) + CHR$(34) + "    (file:  " + twn$ + " )"
    sure1$ = "- File Type Incompatible -"
    sure2$ = "PRESS MOVEMENT KEY TO CONTINUE"
    GOSUB Attn
    xx$ = sure$
    A = TIMER
  ELSE
    sure$ = "Town " + CHR$(34) + Tmap$(tn) + CHR$(34) + "    (file:  " + twn$ + " )"
    GOSUB NoTDP
    A = TIMER
  END IF
GOTO ACC

NoTDP:
    sure1$ = "Could not be programmed (see README.TXT)"
    sure2$ = "PRESS MOVEMENT KEY TO CONTINUE"
    GOSUB Attn
    xx$ = sure$
RETURN

LoadTown:
  erflag = 0
  ON ERROR GOTO TownNotFound
  OPEN twn$ FOR INPUT AS #1
  IF erflag = 1 THEN RETURN
  INPUT #1, xx$
  IF UCASE$(xx$) <> "SHAL BTWN" THEN
    erflag = 2
    CLOSE #1
    ON ERROR GOTO 0
    RETURN
  END IF
  INPUT #1, tnam$, ExitX, ExitY, Town$
  INPUT #1, NoShops
  FOR g = 1 TO NoShops
    INPUT #1, shn$(g), ShopCode(g), spare, spare
  NEXT g
  tmp = 1: Rumors = 0: A$ = ""
checkForMore:
  IF NOT EOF(1) THEN
     LINE INPUT #1, A$
     IF A$ = "." THEN
       tmp = 0
     ELSE
       GOTO checkForMore
     END IF
  END IF
  IF tmp = 1 THEN GOTO DoneTown
LoadRumors:
  INPUT #1, A$
  IF A$ <> "RUMORS" THEN GOTO LoadRumors
  INPUT #1, Rumors
  FOR g = 1 TO Rumors
    INPUT #1, who$(g), rumor$(g)
    ItsBeenSaid(g) = 0
  NEXT g
DoneTown:
  CLOSE #1
  ON ERROR GOTO 0
RETURN

TownNotFound:
  PRINT "TOWN NOT FOUND OR FILE DATA ERROR!"
  CLOSE #1
  erflag = 1
RESUME NEXT

WeaponShop:
  CLS : COLOR lgr
  PRINT "Welcome to "; shn$
  PRINT : PRINT "You have "; : COLOR yel: PRINT Gold; : COLOR lgr: PRINT " gold pieces."
  PRINT : FOR g = 1 TO 10
  COLOR wht: PRINT TAB(15); CHR$(64 + g); "."; TAB(25);
  COLOR red: PRINT tbnam$(g); TAB(45); : COLOR yel: PRINT tbprc(g)
  NEXT g
  PRINT : COLOR lgr
  PRINT "How may I help you today?": PRINT
  COLOR mgr: PRINT "("; : COLOR red: PRINT "A"; : COLOR mgr: PRINT "-"; : COLOR red
  PRINT "J "; : COLOR mgr: PRINT "buy, "; : COLOR red: PRINT "S"; : COLOR mgr
  PRINT "ell, "; : COLOR blu: PRINT "RETURN"; : COLOR mgr: PRINT " leave)"
7 ukey xx$
  IF xx$ = CHR$(13) THEN RETURN
  IF xx$ = "S" THEN GOSUB WSell: GOTO WeaponShop
  A = ASC(xx$) - 64: IF A < 1 OR A > 10 THEN BEEP: GOTO 7
  COLOR brn: PRINT : PRINT "The "; tbnam$(A); "?   ";
  IF Gold >= tbprc(A) THEN
    PRINT "That costs "; tbprc(A); " gold, Will you buy?"
6   ukey xx$
    IF xx$ = "Y" THEN GOSUB WBought
    IF xx$ = "N" THEN COLOR lyel: PRINT "The merchant grumbles angrily and puts it away."
  ELSE
    GOSUB AngryMerchant
  END IF
  COLOR brn: HitAnyKey
GOTO WeaponShop
WBought:
  IF weap(1) > 0 AND weap(2) > 0 THEN GOTO 8
  IF weap(1) = 0 THEN b = 1
  IF weap(2) = 0 THEN b = 2
  COLOR lyel: PRINT "  DONE!!!   May it serve you well."
  Gold = Gold - tbprc(A)
  weap(b) = A: weap$(b) = tbnam$(A): wplo(b) = tblo(A): wphi(b) = tbhi(A)
  verbset(b) = tbverb(A)
RETURN

8 COLOR red: PRINT : PRINT "YOUR HANDS ARE FULL!"
GOSUB 9
COLOR lred: PRINT : PRINT "Do you still wish to buy the "; : COLOR grn
PRINT tbnam$(A); "?  (y/n)"
SitOnHands:
  ukey xx$
  IF xx$ = "Y" THEN GOTO WBought
  IF xx$ = "N" THEN RETURN
GOTO SitOnHands

WSell:
  CLS
9 COLOR lgr
  PRINT : PRINT "Will you sell me your "; : COLOR yel: PRINT "L"; : COLOR lgr
  PRINT "eft weapon or your "; : COLOR yel: PRINT "R"; : COLOR lgr: PRINT "ight weapon?"
  PRINT : PRINT "(LEFT = "; weap$(1); "   RIGHT = "; weap$(2); ")"
  PRINT : PRINT "("; : COLOR lred: PRINT "RETURN"; : COLOR lgr: PRINT " = Don't Sell)"
labA:
  ukey xx$
  IF xx$ = CHR$(13) THEN RETURN
  b = 0
  IF xx$ = "R" THEN b = 2
  IF xx$ = "L" THEN b = 1
  IF b = 0 THEN GOTO labA
  IF weap(b) = 0 THEN GOSUB labE: GOTO WSell
  IF weap(b) > NormWeap THEN GOSUB labF: GOTO WSell
  pr = INT(tbprc(weap(b)) / 2): PRINT
  COLOR lblu: PRINT "The merchant carefully looks over your "; : COLOR pur: PRINT weap$(b)
  COLOR lblu: PRINT "and offers "; : COLOR yel: PRINT pr; : COLOR lblu: PRINT " gold for it."
  PRINT : COLOR lgr: PRINT "Will you sell (y/n) ?"
labb:
  ukey xx$
  IF xx$ = "Y" THEN GOSUB labC: GOTO WSell
  IF xx$ = "N" THEN GOSUB labD: GOTO WSell
  GOTO labb
labC:
  COLOR org: PRINT : PRINT "NICE DOING BUISNESS.": Gold = Gold + pr
  ON b GOSUB ResetLeft, ResetRight
  COLOR lgrn: HitAnyKey
  RETURN
labD:
  COLOR org: PRINT : PRINT "YOU WOULDN'T KNOW A GOOD DEAL IF IT SLAPPED YOU IN THE FACE!"
  COLOR lgrn: HitAnyKey
  RETURN
labE:
  COLOR red: PRINT : PRINT "IF YOU WANT TO SELL YOUR "; : COLOR grn: PRINT weap$(b); : COLOR red
  PRINT ",": PRINT "GO FIND YOURSELF A MORGUE!!!!!!"
  HitAnyKey
  RETURN
labF:
  COLOR org: PRINT : PRINT "WE DON'T DEAL IN "; : COLOR grn: PRINT weap$(b); "s";
  COLOR org: PRINT " HERE!"
  RETURN

ArmorShop:
  CLS : COLOR lgr
  PRINT "Welcome to "; shn$
  PRINT : PRINT "You have "; : COLOR yel: PRINT Gold; : COLOR lgr: PRINT " gold pieces."
  PRINT
  FOR g = 1 TO 7
  COLOR wht: PRINT TAB(15); CHR$(64 + g); "."; TAB(25);
  COLOR red: PRINT anam$(g); TAB(45); : COLOR yel: PRINT apric(g)
  NEXT g
  PRINT : COLOR lgr
  PRINT "How may I help you today?": PRINT
  COLOR mgr: PRINT "("; : COLOR red: PRINT "A"; : COLOR mgr: PRINT "-"; : COLOR red
  PRINT "I "; : COLOR mgr: PRINT "buy, "; : COLOR red: PRINT "S"; : COLOR mgr
  PRINT "ell, "; : COLOR red: PRINT "R"; : COLOR mgr: PRINT "epair, ";
  COLOR blu: PRINT "RETURN"; : COLOR mgr: PRINT " leave)"
12 ukey xx$
  IF xx$ = CHR$(13) THEN RETURN
  IF xx$ = "S" THEN GOSUB ASell: GOTO ArmorShop
  IF xx$ = "R" THEN GOSUB Repair: GOTO ArmorShop
  A = ASC(xx$) - 64: IF A < 1 OR A > 7 THEN BEEP: GOTO 12
  COLOR brn: PRINT : PRINT "The "; anam$(A); "?   ";
  IF Gold >= apric(A) THEN
    PRINT "That costs "; apric(A); " gold, Will you buy?"
10  ukey xx$
    IF xx$ = "Y" THEN GOSUB ABought
    IF xx$ = "N" THEN COLOR lyel: PRINT "The merchant sadly puts it away."
  ELSE
    GOSUB AngryMerchant
  END IF
  COLOR brn: HitAnyKey
GOTO ArmorShop

ABought:
  IF ArmNo > 0 THEN GOTO 11
  COLOR lyel: PRINT "  DONE!!!   May it serve you well."
  Gold = Gold - apric(A)
  ArmNo = A: ArmName$ = anam$(A)
  ArmPro = atpro(A): ArmQ = fnran(270, 450)
RETURN

11 COLOR red: PRINT : PRINT "YOU ARE ALREADY WEARING ARMOR!"
GOSUB 13
COLOR lred: PRINT : PRINT "Do you still wish to buy the "; : COLOR grn
PRINT anam$(A); "?  (y/n)"
14 ukey xx$
  IF xx$ = "Y" THEN GOTO ABought
  IF xx$ = "N" THEN RETURN
GOTO 14

ASell:
  CLS
  IF ArmNo < 1 THEN GOTO 15
13 IF ArmQ <= 30 THEN GOTO 23
   IF ArmQ <= 80 THEN GOTO 17
   pr = INT(apric(ArmNo) / 2): PRINT
   IF ArmQ > 300 THEN pr = INT(pr * 1.2)
   IF ArmQ > 400 THEN pr = INT(pr * 1.6)
   IF ArmQ > 500 THEN pr = pr * 2
   COLOR lblu: PRINT "The merchant carefully examines your "; : COLOR pur: PRINT ArmName$
   COLOR lblu: PRINT "and offers "; : COLOR yel: PRINT pr; : COLOR lblu: PRINT " gold for it."
18 PRINT : COLOR lgr: PRINT "Will you sell it  (y/n) ?"
19 ukey xx$
   IF xx$ = "Y" THEN GOTO 20
   IF xx$ = "N" THEN GOTO 21
   GOTO 19
20 COLOR org: PRINT : PRINT "NICE DOING BUISNESS...": Gold = Gold + pr
22 GOSUB ResetArm
   COLOR lgrn: HitAnyKey
RETURN
21 COLOR org: PRINT : PRINT "HMMP!  Its the most you'll get for THAT thing!"
   COLOR lgrn: HitAnyKey
RETURN

15 COLOR red: PRINT : PRINT "YOUR "; : COLOR grn: PRINT ArmName$; : COLOR red
   PRINT " IS USELESS TO ME!!!"
   COLOR lblu
   HitAnyKey
RETURN
17 COLOR lgr:
   PRINT "Your "; : COLOR grn: PRINT ArmName$; : COLOR lgr: PRINT " is SCRAP!!!"
   COLOR lgr: PRINT
   PRINT "I'll give "; : COLOR yel: PRINT ArmNo; : COLOR lgr: PRINT " for it!"
   pr = ArmNo
   GOTO 18
23 COLOR pur: PRINT "As you take off your "; : COLOR lred: PRINT ArmName$; : PRINT ","
   COLOR pur: PRINT "It breaks and falls to the ground in MANY pieces!!!"
   COLOR org: PRINT : PRINT "The merchant, trying not to laugh, tells you that"
   PRINT "HIS armor is guaranteed not to break for 100 fights."
   GOSUB BrArm
GOTO 22

Repair:
   CLS
   IF (ArmNo < 1) OR (ArmNo > NormArm) THEN GOTO 16
   IF ArmQ <= 70 THEN GOTO 23
   IF ArmQ <= 200 THEN
     COLOR yel
     PRINT "The merchant asks, "; CHR$(34); "Where the hell'd you find this stuff?"; CHR$(34)
     GOSUB click
     PRINT
   END IF
   IF ArmQ > 430 THEN GOTO 24
   pr = ArmNo * 2
   IF ArmQ <= 200 THEN pr = ArmNo * 3
   COLOR brn
   IF ArmQ <= 130 THEN
     PRINT "I'll have my ArmorSmiths work on that scrapheap "
     pr = ArmNo * 4
   ELSE
     PRINT "I'll put my ArmorSmiths to work on your ";
     COLOR mgr: PRINT ArmName$: COLOR brn
   END IF
   IF ArmQ > 200 THEN
     PRINT "for a reasonable "; : COLOR yel: PRINT pr; : COLOR brn: PRINT " gold."
   ELSE
     PRINT "but it will cost "; : COLOR yel: PRINT pr; : COLOR brn
     PRINT " gold since your armor is so beat up."
   END IF
   PRINT : PRINT "Is that a deal?  (y/n)"
25 ukey xx$
   IF xx$ = "N" THEN GOTO 26
   IF xx$ = "Y" THEN GOTO 27
   IF xx$ = "1" THEN GOTO 29
   IF xx$ = "^" THEN GOTO 31
   BEEP
GOTO 25
26 COLOR lgrn: PRINT : PRINT "Suit yourself...": COLOR lgr: HitAnyKey: RETURN
27 IF pr > Gold THEN PRINT : GOSUB AngryMerchant: HitAnyKey: RETURN
   Gold = Gold - pr
   ArmQ = ArmQ + fnran(50, 100)
   IF ArmQ > 400 THEN GOTO 28
   PRINT : PRINT "DONE...  May it serve you all your days!"
   HitAnyKey
RETURN
28 COLOR lgr: PRINT : PRINT "GREAT NEWS, "; : COLOR pur: PRINT nam$;
   COLOR lgr: PRINT "!!!"
   PRINT : PRINT "We were able to strengthen your "; : COLOR grn: PRINT ArmName$;
   COLOR lgr: PRINT " beyond normal maximums!"
   COLOR org: HitAnyKey
RETURN
29 COLOR brn: PRINT
   IF ArmQ > 600 THEN
     PRINT "The merchant informs you that your Armor is already Mithril-Plated!"
     RETURN
   END IF
   PRINT "The merchant suddenly gets this smirk on his face."
   COLOR lgr: PRINT : PRINT "SO, YA WANT MITHRIL DO YA? ": PRINT
   pr = ArmNo * 10
   IF ArmQ <= 200 THEN pr = ArmNo * 15
   PRINT "Very well, but it will cost you "; : COLOR yel: PRINT pr;
   COLOR lgr: PRINT " gold, ";
   IF pr > Gold THEN GOTO 32
   IF ArmQ <= 200 THEN
     PRINT "since your armor is so beat up."
   ELSE
     PRINT
   END IF
   PRINT : PRINT "Do we have a deal?": PRINT
35 ukey xx$
   IF xx$ = "Y" THEN
     Gold = Gold - pr
     ArmQ = 599
     PRINT "Godspeed, friend!"
   ELSEIF xx$ = "N" THEN
     PRINT "OK, but its your loss..."
   ELSE
     GOTO 35
   END IF
   COLOR org: HitAnyKey
RETURN
16 COLOR org: PRINT : PRINT "We don't do "; : COLOR lgr: PRINT ArmName$; "s ";
   COLOR org: PRINT "here!!!"
   GOTO 30
24 COLOR lyel: PRINT : PRINT "I think you need your eyes checked.  This is one of"
   PRINT "the BEST "; : COLOR grn: PRINT ArmName$; "s "; : COLOR lyel: PRINT "I've ever seen!"
   GOTO 30
30 COLOR lgrn: HitAnyKey
   RETURN
31 COLOR brn: PRINT : PRINT "Yes sir, right away sir.  We will bill the royal treasury as usual."
   ArmQ = 800
   COLOR org: HitAnyKey
RETURN
32 PRINT "which you don't have!": COLOR brn: HitAnyKey: RETURN

AngryMerchant:
  AngryMerchantSub
RETURN

Mystic:
  CLS : COLOR lred: PRINT shn$
  COLOR lblu: PRINT
  PRINT "You enter a dimly-lit, smoke filled laboratory filled with odd"
  PRINT "flasks of colored, bubbling liquids.  Ornamented trays scattered"
  PRINT "throughout the strange room burn many different kinds of incense,"
  PRINT "giving the air a pugnent, but pleasant, aroma."
  PRINT : PRINT "A hooded figure motions you to a table and sits across from you..."
  IF (MisFlag AND 1) = 0 THEN
    MisFlag = MisFlag OR 1
    display "ShalMisn.1"
  ELSE
    GOTO NoMech
  END IF
MysHelpYa:
  CLS : COLOR lred: PRINT shn$
  COLOR lblu: PRINT
  PRINT "A hooded figure sits at a table before you.": PRINT
NoMech:
  PRINT
  Item org, "R", grn, "echarge Magic "
  Item org, "S", grn, "peak with the Mystic"
  IF Advance > 4 AND SpellAdv > 4 THEN
    Item org, "L", grn, "earn new Spells"
  END IF
  PRINT
  Item org, "RETURN", grn, " to exit."
  PRINT
MST:
  ukey xx$
  IF xx$ = CHR$(13) THEN RETURN
  IF xx$ = "R" THEN GOSUB Recharge: GOTO MysHelpYa
  IF xx$ = "L" THEN GOSUB LearnMysSpell: GOTO MysHelpYa
  IF xx$ = "S" THEN GOSUB Speak: GOTO MysHelpYa
GOTO MST
LearnMysSpell:
  GOSUB click
RETURN
Recharge:
  IF Magic = MMagic THEN
    COLOR yel
    PRINT "It is beyond my power to work miracles!"
    HitAnyKey
    RETURN
  END IF
  IF Magic > MMagic THEN
    COLOR yel
    PRINT "A RECHARGE?!?!  I should be asking you for one!"
    HitAnyKey
    RETURN
  END IF
  Cost = INT(ABS(MMagic - Magic) / 2) + 1
  COLOR brn: PRINT "A full recharge costs "; : COLOR yel: PRINT Cost;
  COLOR brn: PRINT " gold."
  COLOR lred: PRINT
  INPUT "How much will you pay"; xx$
  A = VAL(xx$)
  IF A < 1 THEN RETURN
  IF A > Cost THEN A = Cost
  IF A > Gold THEN
    COLOR grn
    PRINT : PRINT "Wouldn't it be nice if you really were that rich?"
    HitAnyKey
    RETURN
  END IF
  Magic = Magic + (A * 2)
  IF Magic > MMagic THEN Magic = MMagic
  Gold = Gold - A
  COLOR grn
  PRINT : PRINT "DONE!"
  HitAnyKey
RETURN

Speak:
  COLOR lblu: PRINT
  PRINT "The sage says:"
  COLOR grn
  A = 1
  FOR g = 1 TO NoSpells
    IF SpellNo(g) = 4 THEN A = 0
  NEXT g
  IF NoSpells = 0 THEN
    PRINT "Come back when you have learned the ways of magic."
  ELSEIF A = 1 THEN
    display "ShalSolv.1"
    NoSpells = NoSpells + 1
    SpellNo(NoSpells) = 4
    MisSolv = MisSolv OR 1
    MisFlag = MisFlag OR 2
    display "ShalMisn.2"
    HitAnyKey
  ELSE
    IF SpellAdv > 1 THEN
        A = 1
        FOR g = 1 TO NoSpells
            IF SpellNo(g) = 11 THEN A = 0
        NEXT g
        IF A = 1 THEN
            display "ShalSolv.2"
            NoSpells = NoSpells + 1
            SpellNo(NoSpells) = 11
            PRINT
            display "NoMore.0"
            MisSolv = MisSolv OR 2
            MisFlag = MisFlag OR 4
        ELSEIF A = 0 AND SpellAdv > 2 AND Advance > 3 AND (MisSolv AND 4) = 0 THEN
            display "NoMore.1"
            MisSolv = MisSolv OR 4
            MisFlag = MisFlag OR 8
        ELSEIF MisSolv < 4 THEN
            PRINT "There is little more I can do for you at this time."
            PRINT "Try again later..."
        ELSE
            PRINT "There is nothing more I can do for you, great warrior."
        END IF
    ELSE
        PRINT "Return again when you have advanced much in the ways of magic..."
    END IF
  END IF
  COLOR lblu: HitAnyKey
RETURN

BoatWright:
  CLS : COLOR lgr
  PRINT "Welcome to "; shn$
  PRINT : COLOR yel: PRINT "We offer Ferry Sevices to:": PRINT
  Item lred, "   T", lblu, "erracon"
  Item lred, "   R", lblu, "edWater Creek"
  Item lred, "   N", lblu, "orPort"
  Item lred, "   W", lblu, "hiteOak Glen"
  Item lred, "   C", lblu, "rystal City"
  PRINT
  Item lred, "   L", lblu, " The dungeon of Larn."
  Item lred, "   I", lblu, " Trinidad Island (Redbeard's Lair)."
  COLOR yel: PRINT : PRINT "Or you may...": PRINT
  Item lred, "   P", lblu, "urchace a Boat (200 gold)"
  Item lred, "   B", lblu, "uy Climbing Gear (30 gold)"
  COLOR yel: PRINT : PRINT "What'cha interested in?"
  COLOR mgr: PRINT "("; : COLOR org: PRINT "RETURN"; : COLOR mgr: PRINT " leave)"
  PRINT
  ukey A$
    IF A$ = CHR$(13) THEN RETURN
    IF A$ = "P" THEN GOSUB GetBoat: GOTO BoatWright
    IF A$ = "B" THEN GOSUB GetGear: GOTO BoatWright
    IF A$ = "A" THEN GOSUB PkAxe: GOTO BoatWright
    IF A$ = "'" THEN GOSUB GetIt: GOTO BoatWright
    IF A$ = "*" THEN GOSUB Ring: GOTO BoatWright
    PRINT "Not programmed!!!  Try another."
    HitAnyKey
GOTO BoatWright

GetIt:
  PRINT "You asked for it!!!"
  FOR g = 1 TO 11: AddItem g: NEXT g
  HitAnyKey
RETURN

PkAxe:
    PRINT "Use this PickAxe to tunnel your way through sandstone."
    AddItem 3
    HitAnyKey
RETURN

Ring:
    PRINT "SHHH!  Not so loud.  These magic rings are supposed to be a secret!"
    AddItem 10
    HitAnyKey
RETURN

GetBoat:
    IF Gold >= 200 THEN
        Gold = Gold - 200
        AddItem 1
        COLOR lred: PRINT "DONE!"
    ELSE
        GOSUB AngryMerchant
    END IF
    HitAnyKey
RETURN

GetGear:
    IF Gold >= 30 THEN
        Gold = Gold - 30
        AddItem 2
        COLOR lred: PRINT "DONE!"
    ELSE
        GOSUB AngryMerchant
    END IF
    HitAnyKey
RETURN

MageGuild:
  CLS
  SELECT CASE SpellAdv
    CASE IS <= 0: mage$ = "Adventurer"
    CASE IS < 2: mage$ = "Apprentice"
    CASE IS < 4: mage$ = "Magician"
    CASE IS < 6: mage$ = "Mage"
    CASE IS < 8: mage$ = "Wizard"
    CASE IS < 10: mage$ = "Master"
    CASE ELSE
        mage$ = "High Master"
  END SELECT
MGMenu:
  CLS : COLOR lgr
  PRINT shn$: PRINT
  COLOR lred: PRINT "Welcome, "; mage$; ", to our guild."
  PRINT : COLOR lblu
  PRINT "You can:": PRINT
  IF NoSpells <= 0 THEN
    Item org, "  E", grn, "nroll in a Beginner's Magic Class"
  ELSE
    Item org, "  E", grn, "nchant an item"
  END IF
  Item org, "  I", grn, "dentify Magical Items"
  Item org, "  R", grn, "echarge Magical Items"
  Item org, "  L", grn, "earn new spells"
  PRINT
  Item org, "RETURN", grn, " Leave the guild"
MG:
  ukey xx$
  IF xx$ = "E" THEN GOSUB TheEthing: GOTO MageGuild
  IF xx$ = "I" THEN GOSUB Identify: GOTO MGMenu
  IF xx$ = "R" THEN GOSUB ReItem: GOTO MGMenu
  IF xx$ = "L" THEN GOSUB LearnNewSpell: GOTO MGMenu
  IF xx$ = CHR$(13) THEN RETURN
GOTO MG
Enchant:
Identify:
ReItem:
  GOSUB click
RETURN
LearnNewSpell:
  CLS
  NewSpells = 0
FOR A = 0 TO 2
  FOR g = 1 TO NumSpells
    IF level(g) <= (SpellAdv + A) THEN
      HasSpell = 0
      FOR h = 1 TO NoSpells
        IF SpellNo(h) = g THEN HasSpell = 1
      NEXT h

      IF HasSpell = 0 AND (g <> 1 AND g <> 4 AND g <> 11 AND g <> 17) THEN
        FOR b = 1 TO NewSpells
          IF b > 10 THEN
            HasSpell = 1
          ELSE
            IF NewSpell(b) = g THEN HasSpell = 1
          END IF
        NEXT b
        IF HasSpell = 0 THEN
          NewSpells = NewSpells + 1
          IF NewSpells <= 10 THEN NewSpell(NewSpells) = g
        END IF
      END IF
    END IF
  NEXT g
NEXT A
  IF NewSpells > 10 THEN NewSpells = 10
  IF NoSpells <= 0 THEN
    PRINT "Well, It's obvious to me that you couldn't even pull a rabbit out"
    PRINT "of a hat!  I think the class you want to take is the one down the"
    PRINT "hall; the one that says BEGINNER'S MAGIC CLASS on the door!!!"
    HitAnyKey
    RETURN
  END IF
  IF NewSpells = 0 THEN
    PRINT "We can teach you nothing more at this time."
    PRINT "Return when your magical abilities have increased."
    HitAnyKey
    RETURN
  END IF
  PRINT "We can teach you the following spells:"
  COLOR mgr: PRINT " #"; TAB(6); "Code:"; TAB(12); "Name:"; TAB(35); "MPs";
  PRINT TAB(40); "LVL"; TAB(45); "Cost:"
  FOR g = 1 TO NewSpells
    h = NewSpell(g)
    Cost = (level(h) + 1) * 15
    COLOR lgr: PRINT (g - 1);
    COLOR yel: PRINT TAB(6); SCode$(h);
    COLOR org: PRINT TAB(12); spellName$(h);
    COLOR lblu: PRINT TAB(35); Mpoints(h);
    COLOR org: PRINT TAB(40); level(h);
    COLOR grn: PRINT TAB(45); Cost
    COLOR brn: PRINT TAB(6); Sdec$(h)
  NEXT g
  PRINT : PRINT "Which spell interests you?   (RETURN for none)"
spellintr:
  ukey xx$
  IF xx$ = CHR$(13) THEN RETURN
  g = VAL(xx$)
  IF g > 0 THEN GOTO spelllrn
  IF xx$ = "0" THEN g = 0: GOTO spelllrn
GOTO spellintr
spelllrn:
  h = NewSpell(g + 1)
  Cost = (level(h) + 1) * 15
  COLOR lgrn: PRINT
  IF level(h) > SpellAdv THEN
     PRINT spellName$(h); " is above your skill level, "; mage$; "."
     PRINT "You will fail to properly cast it much of the time..."
     PRINT "If you are still interested, we can teach you it for"
     GOSUB click
  ELSE
     PRINT "We will teach you "; spellName$(h); " for"
  END IF
  PRINT "a reasonable "; Cost; " gold."
  COLOR lblu
  PRINT : PRINT "Still Interested? (y/n)"
  xx$ = ""
  WHILE (xx$ <> "Y" AND xx$ <> "N")
  ukey xx$
  WEND
  IF xx$ = "N" THEN
    RETURN
  ELSE
    IF Gold < Cost THEN
      COLOR red
      PRINT "Knowledge does not come cheaply!!!"
      COLOR lblu: HitAnyKey
    ELSE
      Gold = Gold - Cost
      NoSpells = NoSpells + 1
      SpellNo(NoSpells) = h
      TimesCast(h) = 0
      COLOR lgrn
      PRINT "You learn quickly, "; mage$; "..."
    END IF
  END IF
RETURN
TheEthing:
  IF NoSpells = 0 THEN GOTO BegClass ELSE GOTO Enchant
BegClass:
  COLOR lgrn
  PRINT : PRINT "We will teach you the basics of the Magical Arts, plus 3 useful spells,"
  PRINT "for a reasonable "; : COLOR lred: PRINT "25";
  COLOR lgrn: PRINT " gold."
  PRINT : PRINT "Would you like to Enroll?  (y/n)"
BCyn:
  ukey xx$
  IF xx$ = "Y" THEN GOTO BCyes
  IF xx$ = "N" THEN
    COLOR red
    PRINT "I didn't think so...!"
    COLOR lblu: HitAnyKey
    RETURN
  END IF
GOTO BCyn
BCyes:
  IF Gold < 25 THEN
    COLOR red
    PRINT "Knowledge does not come cheaply!!!"
    COLOR lblu: HitAnyKey
    RETURN
  END IF
  Gold = Gold - 25
  PRINT "The Mages teach you the following spells:"
  NoSpells = 3
  FOR g = 1 TO 3
    SpellNo(g) = g
    TimesCast(g) = 0
    COLOR yel: PRINT SCode$(g); "  ";
    COLOR org: PRINT spellName$(g)
    COLOR brn: PRINT TAB(7); Sdec$(g)
  NEXT g
  HitAnyKey
RETURN

Healer:
  CLS
  COLOR lgr: PRINT shn$: PRINT
  COLOR org: PRINT "You approach the Temple.  The fire at the Altars is burning."
  COLOR lyel: PRINT
  dam = mHits - HitPoints
  IF dam < 1 THEN
    price = 0
    PRINT "One of the priests appraches you and asks for an offering..."
  ELSE
    price = INT(dam / 2) + 1
    PRINT "Several priests come over to you, ";
    IF (Advance < 1) AND (dam > (mHits / 1.5)) THEN
      PRINT " one of them speaks:"
      PRINT CHR$(34); "Child, the light of destiny shines brightly upon thee."
      PRINT " Thou art healed, go forth and let the inner voice be thy guide."; CHR$(34)
      HitPoints = mHits + 2
      GOTO ExitTemple
    ELSE
      PRINT "one of them informs you that it will cost"
      COLOR lred: PRINT price;
      COLOR lyel: PRINT " gold to completely heal your wounds."
    END IF
  END IF
  COLOR blu: PRINT : PRINT "(you have "; Gold; " gold pieces)"
AskOffer:
  COLOR lred: PRINT : PRINT "How much will you give ("; : COLOR grn
  PRINT "0"; : COLOR lred: PRINT " to leave)? ":
  INPUT A: A = INT(A)
  IF A = 0 THEN COLOR lyel: PRINT "Please...  The needs are great!": GOTO ExitTemple
  IF A < 0 THEN COLOR red: PRINT "YOU CAN'T CHEAT THE ALMIGHTY ONE!!!": GOTO ExitTemple
  IF A > Gold THEN COLOR mgr: PRINT : PRINT "YOU DON'T HAVE THAT MUCH!": GOTO AskOffer
  Gold = Gold - A: b = 0
  IF price > 1 THEN
    heal = A * 2
    HitPoints = HitPoints + heal
    IF HitPoints > mHits THEN HitPoints = mHits
  ELSE
    heal = 0
  END IF
  IF A > price THEN
    COLOR yel: PRINT
    PRINT "God bless you, my child!"
    b = A - price
    IF b < 15 THEN
170   h = fnran(1, Fams)
      WpFam(h) = WpFam(h) + (INT(b / 5) + 1)
    ELSEIF b < 30 THEN
      h = fnran(1, 2)
      IF h = 1 THEN HitPoints = HitPoints + INT(b / 5) + 1
      IF h = 2 THEN Magic = Magic + INT(b / 5) + 1
    ELSEIF b < 60 THEN
       HitPoints = HitPoints + INT(b / 6) + 1
       Magic = Magic + INT(b / 6) + 1
       h = fnran(1, Fams)
       WpFam(h) = WpFam(h) + INT(b / 6) + 1
    ELSEIF b < 120 THEN
      FOR g = 1 TO Fams
        WpFam(g) = WpFam(g) + INT(b / 7) + 1
      NEXT g
      HitPoints = HitPoints + INT(b / 7) + 1
      Magic = Magic + INT(b / 7) + 1
    ELSE
      xp = xp + INT(uplevel / 2)
      FOR g = 1 TO Fams
        WpFam(g) = WpFam(g) + INT(b / 8) + 1
      NEXT g
      HitPoints = HitPoints + INT(b / 8) + 1
      Magic = Magic + INT(b / 8) + 1
    END IF
  END IF
  COLOR brn: PRINT
  PRINT "The priests lay hands on you and speak in strange languages..."
  IF price <> 0 THEN PRINT "...You are healed!"
  IF b > 0 THEN
    PRINT : PRINT "From within you hear a voice:"
    IF b <= 60 THEN
      PRINT CHR$(34); "Child, your sacrifice shall not go unnoticed.  Recieve the blessing."; CHR$(34)
    ELSE
      PRINT CHR$(34); "Child, such great sacrifice shall be rewarded.  Recieve the annointing!"; CHR$(34)
    END IF
  END IF
  IF b >= 200 THEN
    PRINT "...YOUR SKIN BEGINS TO GLOW LIKE FIRE AS YOU ARE FILLED"
    PRINT "   POWER FROM ON HIGH!!"
  ELSEIF b >= 100 THEN
    PRINT "...AND YOU ARE FILLED WITH POWER FROM ON HIGH!";
  ELSEIF b > 60 THEN
    PRINT "...And you feel a great warm tingling sensation.";
  ELSEIF b > 30 THEN
    PRINT "...And you feel a great inner peace."
  ELSEIF b > 0 THEN
    PRINT "...And you feel a soothing warmth from within."
  END IF
171 PRINT
ExitTemple:
  HitAnyKey
RETURN

Guild:
  COLOR org
  CLS : PRINT "Welcome to "; shn$
  PRINT : PRINT "The guildmaster looks you over and informs you that you'll"
  PRINT "need "; : COLOR yel: PRINT (uplevel - xp);
  COLOR org: PRINT " experience in order for you to advance."
  PRINT
  Item lred, "   E", lblu, "nroll in a Weapons Training class"
  Item lred, "   S", lblu, "eek emplyoment"
  Item lred, "   R", lblu, "emove cursed items"
  PRINT : PRINT "Select E, S, R, or ENTER to exit."
GuildWait:
  ukey A$
  IF A$ = CHR$(13) OR A$ = CHR$(10) OR A$ = CHR$(27) THEN RETURN
  SELECT CASE A$
     CASE "E": BEEP
     CASE "S": GOSUB Employ: GOTO Guild
     CASE "R": BEEP
  END SELECT
GOTO GuildWait

Employ:
  COLOR org: PRINT
  PRINT "SELECT JOB TYPE:": PRINT
  Item lred, "   S", lblu, "trenuous Labor  (highest paying)"
  Item lred, "   D", lblu, "emanding Work   (midranged pay)"
  Item lred, "   L", lblu, "ight Labor      (low paying)"
  Item lred, "   E", lblu, "asy Work        (peanuts)"
  COLOR org: PRINT
  PRINT "or press ENTER to wimp out."
EmpWait:
  ukey A$
  IF A$ = CHR$(13) OR A$ = CHR$(10) OR A$ = CHR$(27) THEN RETURN
  SELECT CASE A$
     CASE "S": fac = .9: GOSUB WORK: GOTO Employ
     CASE "L": fac = .4: GOSUB WORK: GOTO Employ
     CASE "E": fac = .15: GOSUB WORK: GOTO Employ
     CASE "D": fac = .65: GOSUB WORK: GOTO Employ
  END SELECT
GOTO EmpWait

WORK:
  PRINT
  dam = INT(mHits * fac)
  IF dam < 1 THEN dam = 1
  IF (HitPoints - dam) < 4 THEN
     COLOR lred
     PRINT "You are in no condition for such work!!!"
     PRINT "Come back when you are stronger and more rested."
     GOSUB click
  ELSE
     COLOR grn
     gd = INT(dam * .75)
     IF gd < 1 THEN gd = 1
     Gold = Gold + gd
     HitPoints = HitPoints - dam
     PRINT "  While working you sustained ";
     COLOR yel: PRINT dam; : COLOR grn
     PRINT " hit points of injury,"
     PRINT "  but you earned ";
     COLOR yel: PRINT gd; : COLOR grn
     PRINT " gold pieces."
  END IF
RETURN

Lake:
  CLS : COLOR blu
  PRINT "The water is cool and clear.  You notice something shining at the bottom."
  PRINT "If only you had some way to breathe underwater..."
  COLOR red
  HitAnyKey
RETURN

Pit:
  CLS : COLOR red
  PRINT "   Slaves are still digging the pit!!!"
  COLOR yel: PRINT
  PRINT "A town official tells you that when the pit is finished, people will"
  PRINT "be able to fight for fame and fortune..."
  COLOR grn
  HitAnyKey
RETURN

Standards:
  ItemAt 20, 4, org, "V", lgr, "iew your character"
  ItemAt 20, 5, org, "S", lgr, "ave the game"
  IF NoSpells > 0 THEN ItemAt 20, 6, org, "C", lgr, "ast a spell"
  PRINT : PRINT
RETURN

LoadGame:
  Twindow 0, 0, "LOAD GAME:"
  errFlag = 0
  CHDIR "Saves"
165 CLS : COLOR red: PRINT "LOAD GAME:"
  COLOR grn: PRINT
  PRINT "Enter character name to load"
  PRINT "(DO NOT include  .SCH  suffix)"
  PRINT "or hit RETURN for directory."
  PRINT : GOSUB GetFile
DoLoad:
  ON ERROR GOTO BadFile
  OPEN file$ FOR INPUT AS #1
  INPUT #1, xx$: xx$ = UCASE$(xx$)
  IF xx$ = "SHAL 1C" THEN
    INPUT #1, FileVer
    IF FileVer > VERSION THEN
      COLOR red: PRINT "WARNING!!!  WARNING!!!"
      PRINT "Information used in version "
      PRINT USING "#.##"; FileVer;
      PRINT "may be lost if you save this!"
      PRINT : HitAnyKey
    END IF
    FileVer = VERSION
    INPUT #1, nam$, youX, youY, Moves, Advance, xp, SpellAdv, SpXp
  ELSE
    COLOR red
    PRINT "FILE IS NOT COMPATIBLE WITH THIS"
    PRINT "VERSION OF SCEPTRE OF SHALIMAR!"
    PRINT
    PRINT "(File Format is: "; xx$; ".  This"
    PRINT "version only accepts SHAL 1C files."
    CLOSE #1: HitAnyKey: GOTO Restart
  END IF
  INPUT #1, Strength, HitPoints, mHits, WeapSkill, Magic, MMagic, Tough, Gold, Spir, Spir, Spir
  INPUT #1, weap(1), weap(2)
  FOR g = 1 TO 2
    h = weap(g)
    weap$(g) = tbnam$(h): verbset(g) = tbverb(h)
    wplo(g) = tblo(h): wphi(g) = tbhi(h)
  NEXT g
  INPUT #1, ArmNo, ArmQ
  ArmPro = atpro(ArmNo): ArmName$ = anam$(ArmNo)
  INPUT #1, NoFams
  FOR g = 0 TO NoFams: INPUT #1, WpFam(g): NEXT g
  FOR g = NoFams TO Fams: WpFam(g) = 0: NEXT g
  INPUT #1, NoSpells: IF NoSpells = 0 THEN GOTO 167
  FOR g = 1 TO NoSpells
    INPUT #1, SpellNo(g), TimesCast(g), tmp%
  NEXT g
167 INPUT #1, noItems: IF noItems = 0 THEN GOTO 168
    FOR g = 1 TO noItems
      INPUT #1, ItemNo(g), ItemChg(g), tmp%, tmp%, tmp%
    NEXT g
168 INPUT #1, tmp%
    MisFlag = 0
    MisSolv = 0
    IF tmp% = 0 THEN
      GOTO closeloadfile
    END IF
    IF tmp% <= 2 THEN INPUT #1, MisFlag
    IF tmp% > 1 THEN INPUT #1, MisSolv
    IF tmp% > 2 THEN GOSUB UhOh
    INPUT #1, tmp%
    IF tmp% <> 0 THEN
      GOSUB UhOh
      FOR g = 1 TO tmp%
        INPUT #1, b%, b%, b%, b%, xx$
      NEXT g
    END IF
    INPUT #1, A, b: IF A <> 0 THEN GOSUB UhOh
closeloadfile:
  CLOSE #1
  ON ERROR GOTO 0
  uplevel = 25
  FOR g = 1 TO Advance
    uplevel = uplevel + (g * 25)
  NEXT g
  GOSUB MonSel
  NewChar = 0
  IF MisFlag = 1 THEN MisSolv = 0 ELSE MisSolv = INT(MisFlag / 2)
  TwindowClose
  GOSUB DoMapDraw
  CHDIR ".."
RETURN

UhOh:
  PRINT "WARNING -- Some information stored in this file will be ignored!"
RETURN

TownSave:
  CLS : PRINT
  CHDIR "Saves"
  file$ = nam$: GOSUB Parse
  COLOR mgr: PRINT "Saving "; UCASE$(file$); "...";
  GOSUB DoSave
  GOSUB SetWindow1
goto Town

Parse:
  g = LEN(file$)
  IF g > 8 THEN g = 8
  FOR x = 1 TO g
    xx$ = MID$(file$, x, 1)
    IF xx$ = "." OR xx$ = "\" OR xx$ = "*" OR xx$ = "?" THEN
      MID$(file$, x, 1) = "_"
    END IF
  NEXT x
  file$ = LEFT$(file$, 8) + ".SCH"
RETURN

SaveGame:
  Twindow 0, 0, "SAVE GAME:"
  file$ = nam$: GOSUB Parse
  CHDIR "Saves"
162 CLS : COLOR mgr: PRINT
  PRINT "Saving game as "; UCASE$(file$); "...";
DoSave:
  ON ERROR GOTO BadFile
  OPEN file$ FOR OUTPUT AS #1
  PRINT #1, "SHAL 1C"
  PRINT #1, VERSION
  WRITE #1, nam$, youX, youY, Moves, Advance, xp, SpellAdv, SpXp
  WRITE #1, Strength, HitPoints, mHits, WeapSkill, Magic, MMagic, Tough, Gold, Spir, 0, 0
  WRITE #1, weap(1), weap(2)
  WRITE #1, ArmNo, ArmQ
  WRITE #1, Fams
  FOR g = 0 TO Fams
    WRITE #1, WpFam(g)
  NEXT g
  PRINT #1, NoSpells: IF NoSpells = 0 THEN 160
  FOR g = 1 TO NoSpells
    PRINT #1, SpellNo(g), TimesCast(g), 0
  NEXT g
160 PRINT #1, noItems: IF noItems = 0 THEN 161
  FOR g = 1 TO noItems
    WRITE #1, ItemNo(g), ItemChg(g), 0, 0, 0
  NEXT g
161 PRINT #1, 2
  PRINT #1, MisFlag
  PRINT #1, MisSolv
  PRINT #1, 0
  PRINT #1, 0, 0
CLOSE #1
ON ERROR GOTO 0
  PRINT "Done!"
  COLOR lblu
  HitAnyKey
  TwindowClose
  GOSUB DoMapDraw
  CHDIR ".."
RETURN

BadFile:
  CLOSE #1
  CHDIR ".."
  GOSUB click
  COLOR lgr
  PRINT : PRINT
  PRINT " -  FILE NOT FOUND!!!  - ": PRINT
  PRINT ERR
  COLOR lblu
  GOSUB click
  HitAnyKey
RESUME Restart

GetFile:
  xx$ = "": COLOR grn
  PRINT : INPUT "Enter Filename: ", xx$
  IF xx$ = "" THEN COLOR lblu: PRINT : FILES: GOTO GetFile
  file$ = xx$
  GOSUB Parse
RETURN

AreYouSure:
  Twindow 0, 0, "W A R N I N G :"
  center = 15 - INT(LEN(sure$) / 2)
  CLS : COLOR red: PRINT : PRINT SPC(center); sure$
  COLOR yel: PRINT : PRINT SPC(6); "ARE YOU SURE? (y/n)"
49 ukey sure$
  IF sure$ = "Y" THEN GOTO ExitAYS
  IF sure$ = "N" THEN GOTO ExitAYS
  BEEP: GOTO 49
ExitAYS:
  TwindowClose
  GOSUB DoMapDraw
RETURN

Attn:
  Twindow 0, 0, "Attention :"
  center = 15 - INT(LEN(sure$) / 2)
  CLS : COLOR red: PRINT
  PRINT SPC(center); sure$
  center = 15 - INT(LEN(sure1$) / 2)
  PRINT SPC(center); sure1$
  center = 15 - INT(LEN(sure2$) / 2)
  PRINT SPC(center); sure2$
  ukey sure$
GOTO ExitAYS

GenStats:
  NewChar = 1
  Strength = fnran(1, 5)
  WeapSkill = fnran(5, 15)
  Magic = fnran(3, 8)
  MMagic = Magic
  Tough = fnran(1, 3)
  HitPoints = fnran(6, 14)
  mHits = HitPoints
  Gold = fnran(5, 15)
  nam$ = "(new character)"
  FOR g = 0 TO Fams: WpFam(g) = 0: NEXT g
  NoSpells = 0: noItems = 0: MisFlag = 0: MisSolv = 0
  ex = 0: wpl = 0: wph = 0: wpf = 0: Moves = 0: youX = 15: youY = 15
  Advance = 0: xp = 0: uplevel = 25: SpXp = 0: SpellAdv = 0: MagVance = 25
  GOSUB ResetLeft: GOSUB ResetRight: GOSUB ResetArm
  A = fnran(1, 9)
  IF A > 7 THEN
    Magic = Magic + fnran(5, 8)
    MMagic = Magic
    Gold = Gold + fnran(3, 6)
    GOTO StatsDone
  END IF
  b = fnran(20, 40)
  g = 0
  IF (A AND 1) THEN g = g + 1: GOSUB Check
  IF (A AND 2) THEN g = g + 1: GOSUB Check
  IF (A AND 4) THEN g = g + 1: GOSUB Check
  g = 0: GOSUB Check
StatsDone:
  GOSUB DisplayChar: COLOR wht
  PRINT : PRINT TAB(8); "SPACE to Re-Roll, any other key to keep."
1 GetKey xx$
  IF xx$ = " " THEN GOTO GenStats
  GOSUB MonSel
  COLOR lyel: PRINT : INPUT "Enter Character Name: ", nam$
RETURN

Check:
  WpFam(g) = fnran(5, 25) + b
RETURN

ResetLeft:
  weap$(1) = "Bare Fist": wplo(1) = 1: wphi(1) = 3: weap(1) = 0: verbset(1) = 1
RETURN

ResetRight:
  weap$(2) = "Bare Fist": wplo(2) = 1: wphi(2) = 3: weap(2) = 0: verbset(2) = 1
RETURN

ResetArm:
  ArmName$ = "Clothing": ArmNo = 0: ArmPro = 0: ArmQ = 10
RETURN

DisplayChar:
  GOSUB SetWindow1
  CLS
  CLPrint 2, 2, lblu, blk, "NAME: ": COLOR mgr: LOCATE 2, 8: PRINT nam$;
  CLPrint 35, 2, lblu, blk, "Level: ": COLOR mgr: LOCATE 2, 41: PRINT Advance;
  CLPrint 50, 2, lblu, blk, "Experience: ": COLOR mgr: LOCATE 2, 61: PRINT xp
  COLOR lblu: PRINT
  PRINT TAB(10); "Str:"; TAB(17); : COLOR lgr: PRINT Strength; TAB(30);
  hc = yel: IF HitPoints < (mHits * .2) THEN hc = red
  IF HitPoints = mHits THEN hc = grn
  IF HitPoints > mHits THEN hc = wht
  COLOR lblu: PRINT "Hit Points:"; TAB(45); : COLOR hc: PRINT HitPoints;
  COLOR lblu: PRINT "/"; : COLOR lgr: PRINT mHits
  COLOR lblu: PRINT TAB(10); "WSkill:"; TAB(17); : COLOR lgr: PRINT WeapSkill; TAB(30);
  hc = grn: IF Magic < (MMagic * .25) THEN hc = yel
  IF Magic > MMagic THEN hc = wht
  COLOR lblu: PRINT "Magic Points:"; TAB(45); : COLOR hc: PRINT Magic;
  COLOR lblu: PRINT "/"; : COLOR lgr: PRINT MMagic: COLOR lblu
  PRINT TAB(10); "Tough:"; TAB(17); : COLOR lgr: PRINT Tough; TAB(30);
  COLOR lblu: PRINT "Gold Coins: "; : COLOR brn: PRINT TAB(45); Gold: COLOR lblu
  PRINT : PRINT " Left Weapon: "; : COLOR lyel: PRINT weap$(1);
  COLOR lblu: PRINT TAB(40); "Right Weapon: "; : COLOR lyel: PRINT weap$(2)
  GetQuality ArmQ, qt$, f
  COLOR lblu: PRINT : PRINT TAB(10); "Armor:  "; : COLOR pur: PRINT qt$; " "; ArmName$
  COLOR lgrn: PRINT
  IF NewChar = 0 THEN GOTO OldChar
  PRINT " Weapon Familiarities:"
  flag = 0: LOCATE 14, 1
  FOR g = 0 TO 4
  IF WpFam(g) <> 0 THEN
    COLOR lred
    PRINT " "; tbnam$(g), : COLOR lgrn: PRINT WpFam(g);
    COLOR lred: PRINT "%"
    flag = 1
  END IF
  NEXT g
  IF flag = 0 THEN COLOR lgr: PRINT SPC(5); "NONE!"
RETURN

OldChar:
  PRINT SPC(26); "Weapon Familiarities:"
  flag1 = 0: LOCATE 14, 1: FOR g = INT(Fams / 2) + 1 TO Fams
  IF WpFam(g) <> 0 THEN
    COLOR lred
    PRINT TAB(40); tbnam$(g); TAB(55); : COLOR lgrn: PRINT INT(WpFam(g));
    COLOR lred: PRINT "%"
    flag1 = 1
  END IF
  NEXT g
  flag = 0: LOCATE 14, 1
  FOR g = 0 TO INT(Fams / 2)
  IF WpFam(g) <> 0 THEN
    COLOR lred
    PRINT TAB(5); tbnam$(g); TAB(20); : COLOR lgrn: PRINT INT(WpFam(g));
    COLOR lred: PRINT "%"
    flag = 1
  END IF
  NEXT g
  IF (flag = 0 AND flag1 = 0) THEN COLOR lgr: PRINT SPC(34); "NONE!"
  PRINT : HitAnyKey
  IF noItems > 0 THEN
    CLS : COLOR lred
    PRINT SPC(5); "Items Carried:": PRINT : COLOR lblu
    FOR g = 1 TO noItems
        PRINT ItemName$(ItemNo(g)); TAB(25); ItemDesc$(ItemNo(g))
    NEXT g
    PRINT
    HitAnyKey
  END IF
  IF NoSpells > 0 THEN
    CLS
    CLPrint 1, 1, lred, blk, "SPELLS KNOWN:"
    CLPrint 30, 1, lblu, blk, "Mage Level: ": COLOR mgr: LOCATE 1, 42: PRINT SpellAdv;
    CLPrint 50, 1, lblu, blk, "Mage Experience: ": COLOR mgr: LOCATE 1, 67: PRINT SpXp
    PRINT : GOSUB SpellList
  END IF
  IF MisFlag > 0 THEN
    CLS : COLOR lred
    PRINT SPC(31); "Current Quests:": PRINT
    IF (MisFlag AND 1) = 1 THEN
       IF (MisSolv AND 1) = 0 THEN
         COLOR mgr: PRINT SPC(5);
       ELSE
         COLOR lblu: PRINT "  *  ";
       END IF
       PRINT "Speak to The Mystic after you learn the ways of Magic."
    END IF
    IF (MisFlag AND 2) = 2 THEN
      IF (MisSolv AND 2) = 0 THEN
        COLOR mgr: PRINT SPC(5);
      ELSE
        COLOR lblu: PRINT "  *  ";
      END IF
      PRINT "Speak to The Mystic after you advance in the ways of Magic."
      COLOR mgr: PRINT SPC(5); "Go Forth and rid the land of monsters."
    END IF
    IF (MisFlag AND 4) = 4 THEN
      PRINT : PRINT : PRINT SPC(10); "(no further quests have been programmed)"
    END IF
    COLOR lred: PRINT : HitAnyKey
  END IF
RETURN

SpellList:
  PRINT "Code"; TAB(6); "Name"; TAB(30); "MPs"; TAB(35); "Lvl"; TAB(40); "Cast"; TAB(50); "Effect"
  PRINT
  FOR g = 1 TO NoSpells
    errFlag = 0
    h = SpellNo(g)
    COLOR yel: PRINT SCode$(h);
    COLOR org: PRINT TAB(6); spellName$(h);
    COLOR lblu: PRINT TAB(30); Mpoints(h);
    COLOR org: PRINT TAB(35); level(h);
    COLOR grn: PRINT TAB(40); TimesCast(h);
    COLOR grn: PRINT TAB(50); slo(h); " - "; shi(h)
    COLOR brn: PRINT TAB(6); Sdec$(h)
    IF INT(g / 8) = g / 8 THEN
      COLOR lgr
      HitAnyKey
      errFlag = 1
      PRINT
    END IF
  NEXT g
  IF errFlag = 0 THEN COLOR lgr: PRINT : HitAnyKey
RETURN

Death:
  GOSUB SetWindow1
  CLS : COLOR lred
  PRINT : PRINT "You were killed "; dead$; "!!!"
  d = fnran(1, 9)
  COLOR org: PRINT
  ON d GOSUB 130, 131, 132, 133, 134, 135, 136, 137, 138
  GOTO 139
130 PRINT "Your remains were eaten by a wandering ";
    d = fnran(1, NoMon): PRINT mnam$(d); ".": RETURN
131 PRINT "Your remains were used for experiments by black magi.": RETURN
132 PRINT "Your remains were found by local peasantry and buried.": RETURN
133 PRINT "Wild dogs use your remains as a tasty snack.": RETURN
134 PRINT "Over the years, your remains rot into nothingness.": RETURN
135 PRINT "Your remains are buried by a landslide.": RETURN
136 PRINT "You were cremated by a forest fire.": RETURN
137 PRINT "A psycho comes by and tears your remains to tiny pieces.": RETURN
138 PRINT "Your remains were found by the local peasantry and cremated."
    RETURN
139 PRINT : COLOR lblu
   d = fnran(1, 4)
   file$ = "shalobit" + RIGHT$(STR$(d), 1)
ReadObituary:
   OPEN file$ FOR INPUT AS #1
   WHILE NOT EOF(1)
     xx$ = INPUT$(1, 1)
     PRINT xx$;
   WEND
   CLOSE #1
EndGame:
  PRINT : COLOR mgr
  PRINT nam$; " lasted "; Moves; " moves,"
  PRINT "having reached level "; Advance; " with "; xp; " experience points."
  COLOR brn
  PRINT : PRINT "Press any key to restart the game..."
149 xx$ = INKEY$: IF xx$ <> "" THEN BEEP: GOTO 149
148 GetKey xx$
  GOTO Restart

QuitGame:
  CLS
  SCREEN 0
  WIDTH 80
SYSTEM

SoundFX:

HiLf:
  FOR GGG = 1 TO 4
    FOR HHH = 500 TO 420 STEP -10
      SOUND HHH, .5
      SOUND HHH, .5
    NEXT HHH
  NEXT GGG
RETURN

LoLf:
  FOR GGG = 1 TO 4
    FOR HHH = 300 TO 220 STEP -10
      SOUND HHH, .5
      SOUND HHH, .5
    NEXT HHH
  NEXT GGG
RETURN

Rave:
  HHH = 40: GGG = 1
s1:
  HHH = HHH + GGG: GGG = GGG + (HHH / 100): IF HHH > 5000 THEN RETURN
  SOUND HHH, .2
GOTO s1

buzz:
  SOUND 250, .5
RETURN

click:
  SOUND 2000, .1
RETURN

OpenChest:
  FOR GGG = 100 TO 200 STEP 5: SOUND GGG, .2
  NEXT GGG
  FOR GGG = 200 TO 100 STEP -10: SOUND GGG, .2
  NEXT GGG
RETURN

spf:
  FOR GGG = 500 TO 100 STEP -100
    FOR HHH = GGG TO 40 STEP -100
      SOUND GGG + HHH, .1
    NEXT HHH
  NEXT GGG
RETURN

spak:
  FOR GGG = 500 TO 100 STEP -50
    FOR HHH = 40 TO (GGG / 2) STEP 50
      SOUND HHH, .1
    NEXT HHH
    SOUND GGG, .1
  NEXT GGG
RETURN

spl:
  FOR HHH = 40 TO 255 STEP 5
    A = RND(1) * 250
    SOUND A + HHH, .3
  NEXT HHH
RETURN

Mspl:
  FOR GGG = 1 TO 8
    FOR HHH = 50 TO 300 STEP 50
      SOUND HHH, .2
    NEXT HHH
  NEXT GGG
RETURN

YouHit:
  FOR GGG = 500 TO 250 STEP -25: SOUND GGG, .2
  NEXT GGG
RETURN

RYouHit:
  FOR GGG = 500 TO 250 STEP -25: SOUND GGG, .2
  NEXT GGG
RETURN

ItDies:
  FOR GGG = 400 TO 50 STEP -10: SOUND GGG, .2
  NEXT GGG
  FOR GGG = 60 TO 40 STEP -5: SOUND GGG, .4
  NEXT GGG
RETURN

ItHit:
  FOR GGG = 500 TO 100 STEP -50: SOUND GGG, .2
  NEXT GGG
RETURN

Missed:
  FOR GGG = 400 TO 600 STEP 20: SOUND GGG, .2
  NEXT GGG
RETURN

rmiss:
  FOR GGG = 400 TO 600 STEP 20: SOUND GGG, .2
  NEXT GGG
RETURN

tuf:
  FOR GGG = 150 TO 50 STEP -10: SOUND GGG, .2
  NEXT GGG
RETURN

asf:
  FOR GGG = 1200 TO 900 STEP -50
    SOUND GGG, .2
  NEXT GGG
RETURN

aab:
  FOR GGG = 700 TO 1100 STEP 50
    SOUND GGG, .2
    SOUND GGG, .2
  NEXT GGG
RETURN

BrArm:
  FOR GGG = 600 TO 1500 STEP 25
    SOUND GGG, .2
    SOUND 1600 - GGG, .2
  NEXT GGG
RETURN

TitleScreen:
  CLS : PRINT
  COLOR blu: PRINT "   T h e   S c e p t r e   o f   S h a l i m a r"
  COLOR red: LOCATE 4, 3
  PRINT "A Fantasy Role Playing game created by: "; : COLOR grn: PRINT "Seth Hopkinson"
  LOCATE 6, 10: COLOR mgr: PRINT "PRE-RELEASE #1"
  LOCATE 9, 1: COLOR lblu
  PRINT SPC(18); "Press "; : COLOR lred: PRINT "L"; : COLOR lblu: PRINT " to load a previously-saved game,"
  PRINT SPC(20); "Press "; : COLOR lred: PRINT "V"; : COLOR lblu: PRINT " to view the README.TXT file,"
  PRINT SPC(26); "Press "; : COLOR lred: PRINT "S"; : COLOR lblu: PRINT " to view storyline,"
  PRINT SPC(8); "or hit any other key to start the game and make a NEW character."
  PRINT : PRINT : PRINT : COLOR pur
  PRINT SPC(14); "Copyright 1993 Seth Hopkinson All Rights Reserved."
  PRINT : COLOR dgr
  PRINT SPC(14); "Program version ";
  PRINT USING "#.##"; VERSION;
  PRINT "  --  Revision "; lastmod$;
3 IF ABS(TIMER - A) > .1 THEN
    A = TIMER
    IF c = red THEN
      c = lred
    ELSE
      c = red
    END IF
    COLOR c: LOCATE 23, 21
    PRINT "Press  L, V, S, or ENTER  to continue"
  END IF
  xx$ = INKEY$
  IF xx$ = "" THEN 3
RETURN

LoadMap:
  OPEN "shalwrap.sma" FOR INPUT AS #2
  PrintAt 1, 1, "Loading..."
  INPUT #2, xx$, b
  IF xx$ <> "SMAP" THEN Erx "Bad Map Format!"
  INPUT #2, MapName$
  INPUT #2, xx$, xx$
  INPUT #2, XMapSize, YMapSize
  IF XMapSize > 60 OR YMapSize > 22 THEN Erx "Map too large!"
blow:
  INPUT #2, xx$
  IF UCASE$(xx$) <> "TOWNS" THEN GOTO blow
  PrintAt 1, 1, "Towns...    "
  INPUT #2, NoTowns
  IF NoTowns = 0 THEN GOTO LDung
  FOR x = 1 TO NoTowns
    INPUT #2, TownX(x), TownY(x), TFile$(x), Tmap$(x)
    land%(TownX(x), TownY(x)) = Town
  NEXT x
LDung:
  INPUT #2, xx$
  IF UCASE$(xx$) <> "DUNGEONS" THEN GOTO LDung
  PrintAt 1, 1, "Dungeons..."
  INPUT #2, NoDung
  IF NoDung = 0 THEN GOTO LMap
  FOR x = 1 TO NoDung
    INPUT #2, DungX(x), DungY(x), DFile$(x), Dmap$(x)
    land%(DungX(x), DungY(x)) = Dungeon
  NEXT x
LMap:
  INPUT #2, xx$
  IF UCASE$(xx$) <> "MAP ARRAY" THEN GOTO LMap
  LOCATE 1, 1: PRINT "Main Map:  22"
  FOR y = 1 TO YMapSize
    FOR x = 1 TO XMapSize
      land%(x, y) = ASC(INPUT$(1, #2))
    NEXT x
    LOCATE 1, 16: PRINT y
  NEXT y
LDone:
  CLOSE #2
RETURN

LoadMonsters:
  OPEN "Shalimar.MON" FOR INPUT AS #2
  INPUT #2, NoMon
  IF NoMon = 0 THEN GOTO DoneLoad
  FOR g = 1 TO NoMon
    LOCATE 7, 49: PRINT g;
    INPUT #2, mnam$(g), MStr(g), MHitPer(g), MTough(g), MNHit(g), MNMag(g), LGold(g), HGold(g), noweap(g)
    IF noweap(g) = 0 THEN PRINT "SHIT!": GOTO DoneWeap
    IF noweap(g) > 1 THEN
      FOR h = 1 TO noweap(g)
        INPUT #2, MWeap$(g, h), Vrb$(g, h), LoWeap(g, h), HiWeap(g, h)
      NEXT h
    END IF
    IF noweap(g) = 1 THEN INPUT #2, MWeap$(g, 1), Vrb$(g, 1), LoWeap(g, 1), HiWeap(g, 1)
DoneWeap:
    INPUT #2, MArm$(g), MPro(g), MLevel(g), Mxp(g), mter(g), Morale(g)
  NEXT g
DoneLoad:
  CLOSE #2
RETURN

NewMon:
  OPEN "Shalimar.MON" FOR INPUT AS #2
    INPUT #2, xx$: xx$ = UCASE$(xx$)
    IF xx$ <> "SHAL1M" THEN
      COLOR 3: PRINT "WARNING: File may be incompatible!"
      NoMon = VAL(xx$)
      IF NoMon = 0 THEN INPUT #2, NoMon
    ELSE
      INPUT #2, NoMon
    END IF
    IF NoMon = 0 THEN 150
    FOR g = 1 TO NoMon
      LOCATE 7, 49: PRINT g;
      INPUT #2, mnam$(g), MStr(g), MHitPer(g), MTough(g), MNHit(g), MNMag(g), LGold(g), HGold(g)
      INPUT #2, noweap(g)
      FOR h = 1 TO noweap(g)
        INPUT #2, MWeap$(g, h), Vrb$(g, h), LoWeap(g, h), HiWeap(g, h)
      NEXT h
      INPUT #2, MArm$(g), MPro(g), MLevel(g), Mxp(g), mter(g), Morale(g), Disp(g)
      INPUT #2, MnSpells(g)
      IF MnSpells(g) = 0 THEN 151
      FOR h = 1 TO MnSpells(g)
        INPUT #2, Mverb$(g, h), Mvt(g, h), mmp(g, h), mfx(g, h), mlo(g, h), mhi(g, h)
      NEXT h
151 NEXT g
150 CLOSE #2
RETURN

LoadSpells:
  COLOR yel
  OPEN "Shalimar.SPL" FOR INPUT AS #2
    INPUT #2, xx$: xx$ = UCASE$(xx$)
    IF xx$ <> "SHAL1S" THEN
      COLOR 3: PRINT "WARNING: File may be incompatible!"
      NumSpells = VAL(xx$)
      IF NumSpells = 0 THEN INPUT #2, NumSpells
    ELSE
      INPUT #2, NumSpells
    END IF
    IF NumSpells = 0 THEN 155
    FOR g = 1 TO NumSpells
      LOCATE 8, 49: PRINT g;
      INPUT #2, spellName$(g), Verb$(g), VerbType(g), Mpoints(g), SCode$(g)
      INPUT #2, Sfx(g), slo(g), shi(g), level(g), spadl(g), spadh(g), Sxp(g)
      INPUT #2, spellfail$(g), Sdec$(g)
    NEXT g
155 CLOSE #2
RETURN

LoadItems:
  COLOR yel
  OPEN "Shalimar.ITM" FOR INPUT AS #2
    INPUT #2, xx$: xx$ = UCASE$(xx$)
    IF xx$ <> "SHAL1I" THEN
      COLOR 3: PRINT "WARNING: File may be incompatible!"
      NumItems = VAL(xx$)
      IF NumItems = 0 THEN INPUT #2, NumItems
    ELSE
      INPUT #2, NumItems
    END IF
    IF NumItems = 0 THEN GOTO NoItms
    FOR g = 1 TO NumItems
      LOCATE 9, 44: PRINT g;
      INPUT #2, ItemName$(g), ItemCost(g), ItemDesc$(g)
    NEXT g
NoItms:
    CLOSE #2
RETURN

DATA Bare Fist,0,1,3,1
DATA Dagger,3,1,5,2,Club,4,2,6,3
DATA Mace,5,1,7,3,Short Sword,10,3,9,2
DATA Broad Sword,25,1,10,2,Shingaza,40,5,12,3
DATA Long Sword,65,4,15,2,Naginata,95,1,20,3
DATA Avenger,125,7,25,3,Great Sword,160,10,30,2
DATA Wand,300,15,45,5
DATA Sword of the Elements,500,20,60,2
DATA Sceptre of Shalimar,1000,50,100,5

DATA Clothing,0,0,0
DATA Hide,5,1,10,Leather,20,2,9
DATA Ring Mail,50,3,8,Chain Mail,85,4,9
DATA Scale Mail,125,5,7,Brigandine,175,6,6
DATA Plate Mail,230,7,5
DATA Displacer Cloak,350,8,0
DATA Shadrack's Robe of Invulnerability,1000,15,0

DATA 1,Chops,Attacks,Punches,Strikes,Smites,Slams
DATA 2,Stabs,Tears at,Scrapes,Slashes,Pokes,Smites
DATA 3,Wallops,Slams,Thunks,Hits,Cracks,Knocks
DATA 4,Claws,Bites,Lashes,Attacks,Strikes,Slams
DATA 5,Fritzs,Blasts,Fries,Zaps,Steams,Drains

ColorTest:
  PRINT
  COLOR brn: PRINT TAB(20); " Brown  "; : COLOR red: PRINT "  Red   ";
  COLOR org: PRINT " Orange "; : COLOR yel: PRINT " Yellow "
  COLOR grn: PRINT TAB(20); " Green  "; : COLOR blu: PRINT "  Blue  ";
  COLOR pur: PRINT " Purple "; : COLOR wht: PRINT " White  "
  COLOR lgr: PRINT TAB(20); " Lgrey  "; : COLOR mgr: PRINT " Mgrey  ";
  COLOR dgr: PRINT " Dgrey  "; : COLOR lred: PRINT " LtRed  "
  COLOR lyel: PRINT TAB(20); " LtYel  "; : COLOR lgrn: PRINT " LtGrn  ";
  COLOR lblu: PRINT " LtBlu  "; : COLOR blk: PRINT " Screen "
  PRINT
RETURN

Editor:
  GOSUB SetWindow1
WriteUp:
  CLS
  xx$ = "   "
  PRINT : PRINT "Beta Test Copy EDITOR"
  ItemAt 3, 4, yel, "G", lgr, "old"
  PRINT xx$; Gold
  ItemAt 33, 4, yel, "H", lgr, "it Points"
  PRINT xx$; HitPoints
  ItemAt 3, 6, yel, "M", lgr, "agic Points"
  PRINT xx$; Magic
  ItemAt 33, 6, yel, "A", lgr, "rmor Quality"
  PRINT xx$; ArmQ
  ItemAt 3, 8, yel, "O", lgr, " Coordinates:"
  PRINT xx$; coord
  ItemAt 33, 8, yel, "E", lgr, "ncounters:"
  PRINT xx$; encount
  ItemAt 3, 10, yel, "X", lgr, " Experience:"
  PRINT xx$; xp
  ItemAt 33, 10, yel, "S", lgr, " Magic Exp:"
  PRINT xx$; SpXp
  ItemAt 3, 12, yel, "C", lgr, "olor Test"
  ItemAt 33, 12, yel, "T", lgr, "ile Test"
  ItemAt 3, 14, yel, "R", lgr, "estricted Terrain"
  PRINT xx$; Rstr
  ItemAt 33, 14, yel, "I", lgr, "tem checking"
  PRINT xx$; ItemChFlag
  ItemAt 33, 16, yel, "RETURN", lgr, " to game"
  PRINT : COLOR mgr
EdKey:
  ukey xx$
  IF xx$ = "" THEN GOTO EdKey
  IF xx$ = CHR$(27) OR xx$ = CHR$(13) THEN RETURN
  IF xx$ = "G" THEN INPUT "Ok, Greedy, how much: "; Gold
  IF xx$ = "A" THEN INPUT "Enter Armor Quality, -1000 to 1000: "; ArmQ
  IF xx$ = "M" THEN INPUT "Umm, gimmie a number.  Any number...", Magic
  IF xx$ = "E" THEN Toggle encount
  IF xx$ = "S" THEN INPUT "How wizardly are you? ", SpXp
  IF xx$ = "R" THEN Toggle Rstr
  IF xx$ = "H" THEN INPUT "How strong is superman? ", HitPoints
  IF xx$ = "O" THEN Toggle coord
  IF xx$ = "T" THEN GOSUB TileTest
  IF xx$ = "X" THEN INPUT "How experienced are you? ", xp
  IF xx$ = "I" THEN Toggle ItemChFlag
  IF xx$ = "C" THEN
    LOCATE 15, 1: GOSUB ColorTest: COLOR mgr
    HitAnyKey
  END IF
GOTO WriteUp

TileTest:
  SCREEN 7
  FOR g% = 1 TO NumTiles
    y = 2 + (INT(g% / 8) * 2)
    x = ((g% AND 7) + 1) * 2
    tileAt x, y, g%
  NEXT g%
  LOCATE 1, 1
  GetKey A$
  GOSUB SetWindow1
RETURN

SUB AddItem (Number)
   noItems = noItems + 1
   IF noItems > Items THEN noItems = noItems - 1
   ItemNo(noItems) = Number
END SUB

SUB AngryMerchantSub
  A = fnran(1, 14)
  SOUND 2000, .1
  ON A GOSUB 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113
  GOTO TheEnd
100 PRINT "Lets not waste eachother's time...": RETURN
101 PRINT "HA HA HA!  Ask for something you can afford!": RETURN
102 PRINT "Git outa my shop, SCUM!": RETURN
103 PRINT "Quit screwing around or I'll try this out on your head!": RETURN
104 PRINT "Where's the money?!?!?!?": RETURN
105 PRINT "Do you suffer from CRANIAL RECTITIS?": RETURN
106 PRINT "Is this some kind of joke?": RETURN
107 PRINT "This ain't the welfare house!": RETURN
108 PRINT "You can't pay?  LEAVE NOW!": RETURN
109 PRINT "What are you trying to pull?": RETURN
110 PRINT "This isn't goodwill, you know!": RETURN
111 PRINT "That's a luxury for you, fella!": RETURN
112 PRINT "GET OUT!!!": RETURN
113 PRINT "ILLITERATE?  Write for free help!": RETURN
TheEnd:
END SUB

SUB CenterText (text$, posn%)
  posn% = 38 - INT(LEN(text$) / 2)
END SUB

SUB CLPrint (px%, py%, cpen, paper, msg$)
  COLOR cpen, paper: LOCATE py%, px%: PRINT msg$
END SUB

SUB ClPrintr (px%, py%, cpen, paper, msg$)
  COLOR cpen, paper: LOCATE py%, px%: PRINT msg$;
END SUB

SUB display (file$)
    OPEN file$ FOR INPUT AS #1
        WHILE NOT EOF(1)
            xx$ = INPUT$(1, 1)
            IF xx$ <> "~" THEN
                PRINT xx$;
            ELSE
                A$ = INPUT$(1, 1)
                A = VAL(A$)
                SELECT CASE A
                    CASE 0: COLOR lblu
                    CASE 1: COLOR grn
                    CASE 2: COLOR pur
                    CASE 3: COLOR brn
                    CASE 8: PRINT "boy";
                    CASE 9: PRINT : HitAnyKey
                END SELECT
            END IF
        WEND
    CLOSE #1
END SUB

SUB DrawMap (xm, ym)
  SCREEN 7, , aft, fore
  tmp = fore
  fore = aft
  aft = tmp
  IF curMap = 0 THEN
    MaxX = MapX
    MaxY = MapY
  ELSEIF curMap = 1 THEN
    MaxX = townXsize
    MaxY = townYsize
  ELSE
    MaxX = dungXsize
    MaxY = dungYsize
  END IF
  FOR yd = -ViewY TO ViewY
    FOR xd = -ViewX TO ViewX
      tmpx = xm + xd
      tmpy = ym + yd
      IF curMap = 0 THEN
        IF tmpx < 1 THEN tmpx = MaxX + tmpx
        IF tmpx > MaxX THEN tmpx = tmpx - MaxX
        IF tmpy < 1 THEN tmpy = MaxY + tmpy
        IF tmpy > MaxY THEN tmpy = tmpy - MaxY
        til% = land%(tmpx, tmpy)
      ELSE
        GOSUB NoWrap
      END IF
      PUT ((xd + ViewX) * tileXsize, (yd + ViewY) * tileYsize), tile%(0, til%), PSET
    NEXT xd
  NEXT yd
GOTO DoneDeal

NoWrap:
  IF tmpx < 1 THEN tmpx = 1
  IF tmpx > MaxX THEN tmpx = MaxX
  IF tmpy < 1 THEN tmpy = 1
  IF tmpy > MaxY THEN tmpy = MaxY
  IF curMap = 1 THEN
    til% = Town%(tmpx, tmpy)
  ELSE
    til% = dungmap%(dlvl, tmpx, tmpy)
  END IF
RETURN

DoneDeal:
  SCREEN 7, , fore, fore
END SUB

SUB DrawPeer (xm, ym, xdir, ydir)
  CLS
  SCREEN 7, , fore, fore
  COLOR lblu: LOCATE 3, 4
  PRINT "On the ground beneath your feet"
  LOCATE 4, 7
  PRINT "you see a glowing image..."
  tmp = fore
  fore = aft
  aft = tmp
  IF curMap = 0 THEN
    MaxX = MapX
    MaxY = MapY
  ELSEIF curMap = 1 THEN
    MaxX = townXsize
    MaxY = townYsize
  ELSE
    MaxX = dungXsize
    MaxY = dungYsize
  END IF
  FOR yd = -ydir TO ydir
    FOR xd = -xdir TO xdir
      tmpx = xm + xd
      tmpy = ym + yd
      IF curMap = 0 THEN
        IF tmpx < 1 THEN tmpx = MaxX + tmpx
        IF tmpx > MaxX THEN tmpx = tmpx - MaxX
        IF tmpy < 1 THEN tmpy = MaxY + tmpy
        IF tmpy > MaxY THEN tmpy = tmpy - MaxY
        til% = (land%(tmpx, tmpy) - 1) AND 7
      ELSE
        GOSUB PNoWrap
      END IF
      SELECT CASE til%
          CASE 0: tmp = yel
          CASE 1: tmp = blu
          CASE 2: tmp = grn
          CASE 3: tmp = lgr
          CASE 4: tmp = red
          CASE 5: tmp = brn
          CASE 6: tmp = pur
          CASE 7: tmp = wht
      END SELECT
      GOSUB SetPixel
    NEXT xd
  NEXT yd
  LOCATE 22, 7: COLOR mgr: PRINT "Hit any key when finished."
  til% = POINT(160, 100)
  xd = 0: yd = 0
  GOTO dpWait

SetPixel:
    PSET (((xd * 2) + 160), ((yd * 2) + 100)), tmp
    PSET (((xd * 2) + 161), ((yd * 2) + 100)), tmp
    PSET (((xd * 2) + 160), ((yd * 2) + 101)), tmp
    PSET (((xd * 2) + 161), ((yd * 2) + 101)), tmp
RETURN

PNoWrap:
  IF tmpx < 1 THEN tmpx = 1
  IF tmpx > MaxX THEN tmpx = MaxX
  IF tmpy < 1 THEN tmpy = 1
  IF tmpy > MaxY THEN tmpy = MaxY
  IF curMap = 1 THEN
    til% = Town%(tmpx, tmpy)
  ELSE
    til% = dungmap%(dlvl, tmpx, tmpy)
  END IF
RETURN

dpWait:
  IF A = TIMER THEN GOTO dpWait
  IF POINT(160, 100) = 0 THEN
    tmp = til%: GOSUB SetPixel
  ELSE
    tmp = 0: GOSUB SetPixel
  END IF
  A = TIMER
  IF INKEY$ = "" THEN GOTO dpWait
END SUB

SUB Erx (zxc$)
  Twindow 0, 0, "FATAL ERROR!"
  PRINT zxc$
  STOP
END SUB

SUB GetKey (zxc$)
getkeyloop:
  zxc$ = INKEY$
  IF zxc$ = "" THEN GOTO getkeyloop
END SUB

SUB GetQuality (Quality, qt$, FX)
  SELECT CASE Quality
    CASE IS >= 1000: qt$ = "MAGICAL!": FX = 1.8
    CASE IS > 600: qt$ = "Legendary": FX = 1.4
    CASE IS > 500: qt$ = "Superbly Crafted": FX = 1.2
    CASE IS > 400: qt$ = "Good": FX = 1.1
    CASE IS > 300: qt$ = "Average": FX = 1
    CASE IS > 200: qt$ = "Rather Used": FX = 1
    CASE IS > 150: qt$ = "Shoddy": FX = .95
    CASE IS > 100: qt$ = "Breaking": FX = .9
    CASE IS > 50: qt$ = "Broken": FX = .8
    CASE IS >= 0: qt$ = "Worthless": FX = .4
    CASE ELSE
        qt$ = "CURSED!": FX = .2
  END SELECT
END SUB

SUB HelpScreen
  Twindow 0, 1, "Sceptre of Shalimar Help Screen    (PRE-RELEASE VERSION)"
  COLOR lgr: PRINT : PRINT
  PRINT SPC(23); "Movement:  Use NUMBER PAD."
  COLOR lred: PRINT
  PRINT : PRINT SPC(15); "S  Save game"; TAB(45); "Q  Quit (exit)"
  PRINT : PRINT SPC(15); "L  Load game"; TAB(45); "R  Restart"
  PRINT : PRINT SPC(15); "C  Cast spell"; TAB(45); "V  View Character"
  PRINT : COLOR lblu
  PRINT : PRINT "NOTES:  ";
  COLOR lblu: PRINT "Number 5 can also be used to Cast Spell."
  PRINT : PRINT SPC(8); "SPACE passses 1 turn (good for re-generating HPs or MPs)."
  COLOR lred: LOCATE 24, 1: A = 0
hs:
  IF ABS(TIMER - A) > .1 THEN
    A = TIMER
    IF c = grn THEN
      c = lgrn
    ELSE
      c = grn
    END IF
    COLOR c: LOCATE 22, 23
    PRINT "MAKE SURE  NUM LOCK  IS ON!!!"
  END IF
  A$ = INKEY$
  IF A$ = "" THEN GOTO hs
  TwindowClose
END SUB

SUB HitAnyKey
  PRINT : PRINT SPC(10); "Hit any key to continue..."
5 IF INKEY$ = "" THEN 5
END SUB

SUB InitTiles
  TileSize% = 66
  tileXsize = 16
  tileYsize = 16
END SUB

SUB Item (fore, fore$, aft, aft$)
  COLOR fore: PRINT fore$;
  COLOR aft: PRINT aft$
END SUB

SUB ItemAt (px%, py%, fore, fore$, aft, aft$)
  LOCATE py%, px%
  COLOR fore: PRINT fore$;
  COLOR aft: PRINT aft$;
END SUB

SUB LoadGfx
  loadTile 1, "sand"
  loadTile 2, "water"
  loadTile 3, "tree"
  loadTile 4, "grass"
  loadTile 5, "lava"
  loadTile 6, "mountain"
  loadTile 7, "dungeon"
  loadTile 8, "town"
  loadTile 9, "player"
  loadTile 10, "brick"
  loadTile 11, "sandston"
  loadTile 12, "treasure"
  loadTile 13, "weapon"
  loadTile 14, "armor"
  loadTile 15, "item"
  loadTile 16, "table"
  loadTile 17, "Door"
  loadTile 18, "LockDoor"
  loadTile 19, "Person0"
  loadTile 20, "Person1"
  loadTile 21, "Person2"
  loadTile 22, "Person3"
  loadTile 23, "Person4"
  loadTile 24, "Person5"
  loadTile 25, "Merchant"
  loadTile 26, "Potion"
  loadTile 27, "Wall"
  loadTile 28, "Gold"
  loadTile 29, "wood"
  loadTile 30, "fountain"
  loadTile 31, "key"
  loadTile 32, "pickaxe"
  loadTile 33, "boat"
  loadTile 34, "sworelem"
  loadTile 35, "shadrack"
  loadTile 36, "sceptre"
  loadTile 37, "crstatue"
  loadTile 38, "gravelfl"
  loadTile 39, "stonwall"
  loadTile 40, "magicxtl"
  loadTile 41, "setenc"
  loadTile 42, "torch"
  loadTile 43, "message"
  loadTile 44, "lamp"
  loadTile 45, "barrel"
END SUB

SUB loadTile (tileNo, fm$)
  ff$ = fm$ + ".T16"
  OPEN ff$ FOR INPUT AS #2
     FOR x = 0 TO TileSize%
       INPUT #2, tile%(x, tileNo)
    NEXT x
  CLOSE 2
END SUB

SUB MsgOut (A$)
IF fore > aft THEN
    lo = aft: hi = fore
ELSE
    hi = aft: lo = fore
END IF
FOR g = lo TO hi
    SCREEN 7, , g
    LOCATE 16, 32: PRINT LEFT$(A$, 8);
    IF LEN(A$) > 8 THEN
        LOCATE 17, 32: PRINT MID$(A$, 9, 8);
    END IF
    IF LEN(A$) > 16 THEN
        LOCATE 18, 32: PRINT MID$(A$, 17, 8);
    END IF
    IF LEN(A$) > 24 THEN
        LOCATE 19, 32: PRINT MID$(A$, 25, 8);
    END IF
    IF LEN(A$) > 32 THEN
        LOCATE 20, 32: PRINT MID$(A$, 33, 8);
    END IF
NEXT g
SCREEN 7, , fore, fore
END SUB

SUB PrintAt (px%, py%, msg$)
  LOCATE py%, px%: PRINT msg$;
END SUB

SUB readMe (finam$, co, hi)
  CLS : COLOR co
  lines = 0
  bytes = 0
  OPEN finam$ FOR INPUT AS #1
    flen = LOF(1)
    WHILE NOT EOF(1)
      A$ = INPUT$(1, 1)
      bytes = bytes + 1
      IF A$ = CHR$(13) THEN
        lines = lines + 1
        y = CSRLIN
        x = POS(1)
        COLOR hi
        LOCATE 25, 27: PRINT "Percent Read: ";
        PRINT USING "###.#%"; (bytes / flen) * 100;
        COLOR co: LOCATE y, x
      END IF
      IF A$ = CHR$(10) THEN A$ = ""
      PRINT A$;
      IF lines > 20 THEN
        COLOR hi: HitAnyKey
        PRINT : lines = 0: COLOR co
      END IF
    WEND
  CLOSE #1
  IF lines <> 0 THEN PRINT : COLOR hi: HitAnyKey
  LOCATE 25, 1: PRINT SPACE$(79);
END SUB

SUB ScanItem (n)
  True = 0
  IF ItemChFlag = 1 THEN
    FOR g = 1 TO noItems
      IF ItemNo(g) = n THEN True = 1
    NEXT g
  ELSE
    True = 1
  END IF
END SUB

SUB SetGlobals
   NumTiles = 45: fore = 0: aft = 1
   curMap = 0: ViewX = 7: ViewY = 5: MapX = 60: MapY = 22
   Dlvls = 5: dungXsize = 15: dungYsize = 15: townXsize = 25: townYsize = 25
   black = 0: blk = black: brn = 6: red = 4
   yel = 14: grn = 2: blu = 1: pur = 5
   wht = 15: org = 11: lgr = 3: mgr = 7
   dgr = 8: lred = 12: lyel = 13: lgrn = 10: lblu = 9
END SUB

SUB tileAt (xt, yt, tileNo%)
  PUT ((xt - 1) * tileXsize, (yt - 1) * tileYsize), tile%(0, tileNo%), PSET
END SUB

SUB Toggle (var)
  IF var = 0 THEN
    var = 1
  ELSE
    var = 0
  END IF
END SUB

SUB Twindow (num, clr, title$)
    SCREEN 0, , num, num
    WIDTH 80, 25
    IF clr > 0 THEN
        CLS
    END IF
    IF title$ <> "" THEN
        LOCATE 1, 1: COLOR 15
        PRINT title$
    END IF
END SUB

SUB TwindowClose
    SCREEN 7, , aft, fore
END SUB

SUB ukey (zxc$)
ukeyloop:
  zxc$ = UCASE$(INKEY$): IF zxc$ = "" THEN GOTO ukeyloop
END SUB

SUB WaitNSec (n)
  A = TIMER
wnse:
  IF (TIMER - A) < n AND (TIMER - A) > 0 THEN GOTO wnse
END SUB

