' Sceptre of Shalimar Spell Maker Version 0.7    (for Shalimar Pre-Release 1)
' Created by Seth Hopkinson on April 23, 1996  Last Modification June 8, 1996
' (adapted from the Monster Maker)

DECLARE SUB item (a!, a$, B!, B$)
DECLARE SUB ukey (a$)
DECLARE SUB GetKey (a$)
CLS : GOSUB Title
PRINT : PRINT : PRINT "Please Wait, Inititializing..."
GOSUB MapFKeys

'Max number of Spells
'DO NOT CHANGE THIS VALUE UNLESS YOU ALSO CHANGE IT IN THE MAIN PROGRAM!!!
MaxSpells = 51

'Number of Spells currently in Memory.
NumSpells = 0

DIM SpellName$(MaxSpells), verb$(MaxSpells), VerbType(MaxSpells)
DIM MPoints(MaxSpells), SFx(MaxSpells), sLo(MaxSpells), sHi(MaxSpells)
DIM level(MaxSpells), spAdL(MaxSpells), spAdH(MaxSpells), SCode$(MaxSpells)
DIM Sxp(MaxSpells), SpellFail$(MaxSpells), sDec$(MaxSpells)
DIM SpellNo(MaxSpells), TimesCast(MaxSpells)
SplFile$ = "Shalimar.SPL"

RANDOMIZE TIMER
DEF FNran (Low, High) = INT(RND(1) * ((High + 1) - Low)) + Low

black = 0: brn = 6: red = 4: org = 13: yel = 14: grn = 2: blu = 1: pur = 5: wht = 15
lgr = 7: mgr = 3: dgr = 8: lred = 12: lyel = 11: lgrn = 10: Lblu = 9

MainMenu:
  CLS : GOSUB Title
  COLOR lgr
  IF NumSpells = 0 THEN
    COLOR lred
    PRINT "There aren't any spells in the current SpellSet!"
  ELSEIF NumSpells = 1 THEN
    PRINT "There is  ";
    COLOR lgrn: PRINT "1  ";
    COLOR lgr: PRINT "spell in the current SpellSet."
  ELSEIF NumSpells > (MaxSpells - 1) THEN
    COLOR lred: PRINT "THERE ARE "; (NumSpells); " SPELLS IN THIS SPELLSET.";
    COLOR blu: PRINT TAB(55); "Filename:  "; UCASE$(SplFile$)
    COLOR lgrn: PRINT "This is the maximum number of spells you can have in"
    PRINT "memory.  Please SAVE your spells and exit the program."
  ELSE
    PRINT "There are ";
    COLOR lgrn: PRINT NumSpells;
    COLOR lgr: PRINT "  spells the current SpellSet.";
    COLOR blu: PRINT TAB(55); "Filename:  "; UCASE$(SplFile$)
  END IF
  PRINT
  item yel, "  L", mgr, "oad SpellSet"
  IF NumSpells >= 1 THEN
    COLOR yel: PRINT "  S"; : COLOR mgr: PRINT "ave current SpellSet (in file "; UCASE$(SplFile$); ")"
    COLOR mgr: PRINT "  Save "; : COLOR yel: PRINT "A"; : : COLOR mgr: PRINT "s... (save SpellSet under different filename)"
    PRINT
    item yel, "  V", mgr, "iew All Spells (Spell Table)"
    COLOR mgr: PRINT "  View "; : item yel, "O", mgr, "ne Spell"
    COLOR mgr: PRINT "  View "; : item yel, "B", mgr, "y level"
    COLOR mgr: PRINT "  V"; : item yel, "i", mgr, "ew Detailed Listing"
    PRINT
    item yel, "  P", mgr, "rintout (send one of above views to printer)"
  END IF
  PRINT
  IF NumSpells < (MaxSpells - 1) THEN
     item yel, "  C", mgr, "reate New Spell"
  END IF
  IF NumSpells >= 1 THEN
     item yel, "  E", mgr, "dit Spell"
     item yel, "  D", mgr, "elete Spell"
     item yel, "  M", mgr, "ake a copy (Duplicate Spell)"
  END IF
  PRINT
  item yel, "  Q", mgr, "uit program"
  PRINT
  COLOR lgry: PRINT "Press the letter of your Selection...";
Choose:
  ukey a$
  IF a$ = "L" THEN GOSUB LoadSpells: GOTO MainMenu
  IF a$ = "Q" OR a$ = CHR$(27) THEN GOTO Quit
  IF NumSpells < (MaxSpells - 1) THEN
    IF a$ = "C" THEN GOSUB Create: GOTO MainMenu
  END IF
  IF NumSpells >= 1 THEN
    IF a$ = "E" THEN GOSUB Edit: GOTO MainMenu
    IF a$ = "A" THEN GOSUB SaveSpells: GOTO MainMenu
    IF a$ = "S" THEN GOSUB SaveCurSpells: GOTO MainMenu
    IF a$ = "V" THEN GOSUB ViewSpl: GOTO MainMenu
    IF a$ = "O" THEN GOSUB LookAtMe: GOTO MainMenu
    IF a$ = "D" THEN GOSUB DelSpl: GOTO MainMenu
    IF a$ = "B" THEN GOSUB LevSpl: GOTO MainMenu
    IF a$ = "P" THEN GOSUB PrintOUT: GOTO MainMenu
    IF a$ = "I" THEN GOSUB Detail: GOTO MainMenu
    IF a$ = "M" THEN GOSUB CopySpl: GOTO MainMenu
  END IF
GOTO Choose

Title:
  COLOR lgr
  LOCATE 23, 1
  PRINT " The Sceptre of Shalimar Spell Maker             by Seth Hopkinson 23-Apr-1996"
  LOCATE 24, 17
  COLOR dgr
  PRINT "Version 1.0  --  Date of last revision 8-Jun-1996"
  LOCATE 1, 1
RETURN

PrintOUT:
  CLS : COLOR yel: PRINT "PRINT OUT MENU:"
  PRINT
  item yel, "  S", mgr, "pell Table (view all spells)"
  item yel, "  O", mgr, "ne Spell"
  item yel, "  B", mgr, "y Level"
  item yel, "  D", mgr, "etailed Listing"
  PRINT
  COLOR yel: PRINT "Choose print method, or ENTER to abort."
9 ukey a$
  IF a$ = CHR$(13) OR a$ = CHR$(10) OR a$ = CHR$(27) THEN RETURN
  IF a$ = "S" THEN GOSUB PRtable: GOSUB PRdone: GOTO PrintOUT
  IF a$ = "O" THEN GOSUB PRone: GOSUB PRdone: GOTO PrintOUT
  IF a$ = "B" THEN GOSUB PRlevel: GOSUB PRdone: GOTO PrintOUT
  IF a$ = "D" THEN GOSUB PRdetail: GOSUB PRdone: GOTO PrintOUT
GOTO 9

PRdone:
  LPRINT : LPRINT
  PRINT : PRINT
  PRINT "FILE SENT TO PRINTER   --   Hit any Key."
  ukey a$
RETURN

PRone:
  CLS : COLOR wht
  PRINT : PRINT "Enter spell CODE or number to print, or 0 for menu."
  INPUT "Which Spell to print"; Num$
  Num = VAL(Num$)
  tmp = 1
  IF Num < 1 OR Num > NumSpells THEN GOSUB CheckCodes
  IF tmp = 0 THEN RETURN
  SplNum = Num
  PRINT : PRINT "Sending Spell Info to printer..."
  LPRINT
  LPRINT
  LPRINT "Spell #"; STR$(SplNum); "  of file  "; SplFile$
  LPRINT
  LPRINT
  LPRINT "  Name   : "; SpellName$(SplNum);
  LPRINT TAB(40); "  CODE   : "; SCode$(SplNum)
  LPRINT "  Verb   : "; verb$(SplNum)
  LPRINT "  Style  : "; : tmp = VerbType(SplNum): VB$ = verb$(SplNum): GOSUB GetVerbs: LPRINT Action$
  LPRINT "  MP to cast     : "; MPoints(SplNum);
  LPRINT TAB(40); "  XP for casting : "; Sxp(SplNum)
  LPRINT "  Level  : "; level(SplNum);
  LPRINT TAB(40); "  Damage : "; sLo(SplNum); " - "; sHi(SplNum)
  LPRINT "  Description: "; sDec$(SplNum)
  LPRINT "  Failure: "; SpellFail$(SplNum)
  LPRINT "  Effects: ";
  fx = SFx(SplNum)
  IF fx = 0 THEN LPRINT TAB(15); "NO EFFECTS -- Special spell used in Quests or Other..."
  IF fx >= 65535 THEN
    LPRINT TAB(15); "PRAYER -- "; MPoints(SplNum) * 5; "% CHANCE TO CAUSE ONE OR MORE OF THE FOLLOWING:"
    fx = 4095: REM 4095=all below bit-values added together...
  END IF
    IF (fx AND 1) THEN LPRINT TAB(15); "Damage target for "; sLo(SplNum); " - "; sHi(SplNum)
    IF (fx AND 32) THEN LPRINT TAB(14); sHi(SplNum); "% chance distroy target's armor ("; sLo(SplNum); " protection or under)"
    IF (fx AND 64) THEN LPRINT TAB(15); "Heal caster for "; sLo(SplNum); " - "; sHi(SplNum)
    IF (fx AND 128) THEN LPRINT TAB(15); "Repair caster's armor "; sLo(SplNum) * 10; " - "; sHi(SplNum) * 10; " points"
    IF (fx AND 512) THEN LPRINT TAB(15); "Instant run from fight (addrenalin boost)"
    IF (fx AND 1024) THEN LPRINT TAB(15); "Overhead Map:  "; sHi(SplNum)*2; "X  by "; sLo(SplNum)*2; "Y"
    IF (fx AND 2048) THEN LPRINT TAB(14); sHi(SplNum); "% chance target cannot fight for "; sLo(SplNum); " rounds (ONE in Demo)"
RETURN

PRlevel:
  CLS : COLOR mgr
  PRINT : PRINT "Enter  FROM,TO  levels to print (example 0,10)": PRINT
  INPUT "Print levels: ", a, B
  PRINT : PRINT "Sending Level List to printer..."
  LPRINT
  LPRINT
  LPRINT "SCEPTRE OF SHALIMAR SPELL MAKER LISTING"
  LPRINT
  LPRINT "Spell Level listing for file "; UCASE$(SplFile$)
  LPRINT
  LPRINT
  FOR g = a TO B
    SELECT CASE g
      CASE IS <= 0: mage$ = "Adventurer"
      CASE IS < 2: mage$ = "Apprentice"
      CASE IS < 4: mage$ = "Magician"
      CASE IS < 6: mage$ = "Mage"
      CASE IS < 8: mage$ = "Wizard"
      CASE IS < 10: mage$ = "Master"
      CASE ELSE
          mage$ = "High Master"
    END SELECT
    LPRINT : LPRINT mage$; " Spells  (Level"; g; ")"
    FOR h = 1 TO NumSpells
      IF level(h) = g THEN
         LPRINT "#"; h; TAB(8); SCode$(h); TAB(15); SpellName$(h); TAB(45);
         LPRINT MPoints(h); TAB(51); level(h); TAB(57); Sxp(h);
         IF sHi(h) <= 0 AND sLo(h) <= 0 THEN
            LPRINT TAB(65); " NONE "
         ELSE
            LPRINT TAB(65); sLo(h); "-"; sHi(h)
         END IF
      END IF
    NEXT h
  NEXT g
RETURN

PRtable:
  PRINT : PRINT "Sending Spell Table to printer..."
  LPRINT
  LPRINT
  LPRINT "SCEPTRE OF SHALIMAR SPELL MAKER LISTING"
  LPRINT
  LPRINT "Spell Table listing for file "; UCASE$(SplFile$)
  LPRINT
  LPRINT
  LPRINT "Number"; TAB(8); "CODE"; TAB(15); "Name"; TAB(45); "Magic"; TAB(51);
  LPRINT "Level"; TAB(57); "Mage XP"; TAB(66); "Damage"
  FOR g = 1 TO NumSpells
    LPRINT "#"; g; TAB(8); SCode$(g); TAB(15); SpellName$(g); TAB(45);
    LPRINT MPoints(g); TAB(51); level(g); TAB(57); Sxp(g);
    IF sHi(g) <= 0 AND sLo(g) <= 0 THEN
      LPRINT TAB(65); " NONE "
    ELSE
      LPRINT TAB(65); sLo(g); "-"; sHi(g)
    END IF
  NEXT g
RETURN

PRdetail:
  PRINT : PRINT "Sending Spell Book (Detailed Listing) to printer..."
  LPRINT
  LPRINT
  LPRINT "SCEPTRE OF SHALIMAR SPELL MAKER LISTING"
  LPRINT
  LPRINT " Detailed listing of file "; UCASE$(SplFile$)
  LPRINT
  LPRINT
  LPRINT "Num:"; TAB(7); "Code:"; TAB(15); "Name:"; TAB(32); "Verb:"
  LPRINT
  FOR g = 1 TO NumSpells
    LPRINT g;
    LPRINT TAB(7); SCode$(g); TAB(15); SpellName$(g)
    LPRINT "Level:"; TAB(7); level(g);
    LPRINT TAB(12); "MPs:"; TAB(16); MPoints(g);
    LPRINT TAB(22); "SpXp:"; TAB(27); Sxp(g);
    LPRINT TAB(32); verb$(g)
    LPRINT "DESC: "; sDec$(g)
    SELECT CASE VerbType(g)
       CASE 0: tmp$ = verb$(g)
       CASE 1: tmp$ = "CASTER " + verb$(g) + " TARGET"
       CASE 2: tmp$ = "CASTER " + verb$(g)
       CASE 3: tmp$ = "TARGET " + verb$(g)
       CASE 4: tmp$ = "TARGET " + verb$(g) + " CASTER"
       CASE ELSE
          tmp$ = "No Verb": Action$ = "<no verb>"
    END SELECT
    LPRINT "VERBS: "; tmp$
    LPRINT "FAIL: "; SpellFail$(g)
    LPRINT "EFFECTS:";
    fx = SFx(g)
    IF fx = 0 THEN LPRINT TAB(15); "NO EFFECTS -- Special spell used in Quests or Other..."
    IF fx >= 65535 THEN
      COLOR yel
      LPRINT TAB(15); "PRAYER -- "; MPoints(g) * 5; "% CHANCE TO CAUSE ONE OR MORE OF THE FOLLOWING:"
      fx = 4095
    END IF
    IF (fx AND 1) THEN LPRINT TAB(15); "Damage target for "; sLo(g); " - "; sHi(g)
    IF (fx AND 32) THEN LPRINT TAB(14); sHi(g); "% chance distroy target's armor ("; sLo(g); " protection or under)"
    IF (fx AND 64) THEN LPRINT TAB(15); "Heal caster for "; sLo(g); " - "; sHi(g)
    IF (fx AND 128) THEN LPRINT TAB(15); "Repair caster's armor "; sLo(g) * 10; " - "; sHi(g) * 10; " points"
    IF (fx AND 512) THEN LPRINT TAB(15); "Instant run from fight (addrenalin boost)"
    IF (fx AND 1024) THEN LPRINT TAB(15); "Overhead Map:  "; sHi(g)*2; "X  by "; sLo(g)*2; "Y"
    IF (fx AND 2048) THEN LPRINT TAB(14); sHi(g); "% chance target cannot fight for "; sLo(g); " rounds (not in Demo)"
    LPRINT
  NEXT g
RETURN

Detail:
  CLS
  COLOR mgr
  PRINT "SCEPTRE OF SHALIMAR SPELL MAKER LISTING"
  PRINT " Detailed listing of file "; UCASE$(SplFile$)
  PRINT
  COLOR grn
  PRINT "Num:"; TAB(7); "Code:"; TAB(15); "Name:"; TAB(32); "Verb:"
  PRINT
  FOR g = 1 TO 7: GOSUB scrollcheck: NEXT g
  FOR g = 1 TO NumSpells
    COLOR lred: PRINT g;
    COLOR org: PRINT TAB(7); SCode$(g); TAB(15); SpellName$(g)
    GOSUB scrollcheck
    COLOR yel: PRINT "Level:"; : COLOR Lblu: PRINT TAB(7); level(g);
    COLOR yel: PRINT TAB(12); "MPs:"; : COLOR org: PRINT TAB(16); MPoints(g);
    COLOR yel: PRINT TAB(22); "SpXp:"; : COLOR pur: PRINT TAB(27); Sxp(g);
    COLOR grn: PRINT TAB(32); verb$(g)
    GOSUB scrollcheck
    COLOR yel: PRINT "DESC: "; : COLOR brn: PRINT sDec$(g)
    SELECT CASE VerbType(g)
       CASE 0: tmp$ = verb$(g)
       CASE 1: tmp$ = "CASTER " + verb$(g) + " TARGET"
       CASE 2: tmp$ = "CASTER " + verb$(g)
       CASE 3: tmp$ = "TARGET " + verb$(g)
       CASE 4: tmp$ = "TARGET " + verb$(g) + " CASTER"
       CASE ELSE
          tmp$ = "No Verb": Action$ = "<no verb>"
    END SELECT
    GOSUB scrollcheck
    COLOR yel: PRINT "VERBS: "; : COLOR mgr: PRINT tmp$
    GOSUB scrollcheck
    COLOR yel: PRINT "FAIL: "; : COLOR red: PRINT SpellFail$(g)
    COLOR yel: PRINT "EFFECTS:";
    COLOR Lblu
    fx = SFx(g)
    IF fx = 0 THEN PRINT TAB(15); "NO EFFECTS -- Special spell used in Quests or Other...": GOSUB scrollcheck
    IF fx >= 65535 THEN
      COLOR yel
      PRINT TAB(15); "PRAYER -- "; MPoints(g) * 5; "% CHANCE TO CAUSE ONE OR MORE OF THE FOLLOWING:"
      fx = 4095: GOSUB scrollcheck
      COLOR Lblu
    END IF
    IF (fx AND 1) THEN PRINT TAB(15); "Damage target for "; sLo(g); " - "; sHi(g): GOSUB scrollcheck
    IF (fx AND 32) THEN PRINT TAB(14); sHi(g); "% chance distroy target's armor ("; sLo(g); " protection or under)": GOSUB scrollcheck
    IF (fx AND 64) THEN PRINT TAB(15); "Heal caster for "; sLo(g); " - "; sHi(g): GOSUB scrollcheck
    IF (fx AND 128) THEN PRINT TAB(15); "Repair caster's armor "; sLo(g) * 10; " - "; sHi(g) * 10; " points": GOSUB scrollcheck
    IF (fx AND 512) THEN PRINT TAB(15); "Instant run from fight (addrenalin boost)": GOSUB scrollcheck
    IF (fx AND 1024) THEN PRINT TAB(15); "Overhead Map:  "; sHi(g)*2; "X  by "; sLo(g)*2; "Y": GOSUB scrollcheck
    IF (fx AND 2048) THEN PRINT TAB(14); sHi(g); "% chance target cannot fight for "; sLo(g); " rounds (not in Demo)": GOSUB scrollcheck
    PRINT : GOSUB scrollcheck
  NEXT g
  PRINT : PRINT "Hit Any Key": GetKey a$
  lines = 0
RETURN

scrollcheck:
  lines = lines + 1
  IF lines >= 20 THEN
    PRINT : PRINT "   <<< Hit any key to continue >>>"
    GetKey a$
    CLS
    lines = 0
  END IF
RETURN

LevSpl:
  COLOR mgr
  CLS : lines = 4
  PRINT : PRINT "Enter  FROM,TO  levels to list (example 0,10)": PRINT
  INPUT "List levels: ", a, B
  PRINT
  FOR g = a TO B
    SELECT CASE g
      CASE IS <= 0: mage$ = "Adventurer"
      CASE IS < 2: mage$ = "Apprentice"
      CASE IS < 4: mage$ = "Magician"
      CASE IS < 6: mage$ = "Mage"
      CASE IS < 8: mage$ = "Wizard"
      CASE IS < 10: mage$ = "Master"
      CASE ELSE
          mage$ = "High Master"
    END SELECT
    COLOR lred: PRINT mage$; " Spells  (Level"; : COLOR yel: PRINT g; : COLOR lred: PRINT ")"
    GOSUB scrollcheck: COLOR lgr
    FOR h = 1 TO NumSpells
      IF level(h) = g THEN
         GOSUB scrollcheck
         PRINT "#"; h; TAB(8); SCode$(h); TAB(15); SpellName$(h); TAB(45);
         PRINT MPoints(h); TAB(51); level(h); TAB(57); Sxp(h);
         IF sHi(h) <= 0 AND sLo(h) <= 0 THEN
            PRINT TAB(65); " NONE "
         ELSE
            PRINT TAB(65); sLo(h); "-"; sHi(h)
         END IF
      END IF
    NEXT h
  NEXT g
  PRINT
  PRINT "Press any key to continue..."
  GetKey a$
  lines = 0
RETURN

ViewSpl:
  CLS
  COLOR lgr: lines = 2
  PRINT "Number"; TAB(8); "CODE"; TAB(15); "Name"; TAB(45); "Magic"; TAB(51);
  PRINT "Level"; TAB(57); "Mage XP"; TAB(66); "Damage"
  COLOR mgr
  FOR g = 1 TO NumSpells
    PRINT "#"; g; TAB(8); SCode$(g); TAB(15); SpellName$(g); TAB(45);
    PRINT MPoints(g); TAB(51); level(g); TAB(57); Sxp(g);
    IF sHi(g) <= 0 AND sLo(g) <= 0 THEN
      PRINT TAB(65); " NONE "
    ELSE
      PRINT TAB(65); sLo(g); "-"; sHi(g)
    END IF
    GOSUB scrollcheck
  NEXT g
  PRINT
  PRINT "Press any key to continue..."
  GetKey a$
  lines = 0
RETURN

Create:
  CLS : COLOR 15
  NumSpells = NumSpells + 1
  head$ = "Create Spell #" + STR$(NumSpells)
  SplNum = NumSpells
GOTO DoSpell

CopySpl:
  CLS : COLOR wht: PRINT "DUPLICATE Spell": PRINT
  PRINT "Enter Spell code or number to DUPLICATE, or 0 for menu."
  INPUT "Which Spell to duplicate"; Num$
  Num = VAL(Num$)
  tmp = 1
  IF Num < 1 OR Num > NumSpells THEN GOSUB CheckCodes
  IF tmp = 0 THEN RETURN
  COLOR lred: PRINT
  NumSpells = NumSpells + 1
  src = Num
  dest = NumSpells
  GOSUB DupSpl
RETURN

DelSpl:
  CLS : COLOR wht: PRINT "DELETE Spell": PRINT
  PRINT "Enter Spell code or number to DELETE, or 0 for menu."
  INPUT "Which Spell to delete"; Num$
  Num = VAL(Num$)
  tmp = 1
  IF Num < 1 OR Num > NumSpells THEN GOSUB CheckCodes
  IF tmp = 0 THEN RETURN
  COLOR lred: PRINT
  PRINT "Delete Spell #" + STR$(Num) + " -- " + SpellName$(Num)
  COLOR yel: PRINT
  PRINT " Are you sure?  (y/n) "
  ukey a$
  IF a$ <> "Y" THEN RETURN
  IF Num = NumSpells THEN
    NumSpells = NumSpells - 1
  ELSE
    src = Num
    dest = NumSpells
    GOSUB SwapSpl
    NumSpells = NumSpells - 1
  END IF
RETURN

SwapSpl:
  tmp$ = SpellName$(src): SpellName$(src) = SpellName$(dest): SpellName$(dest) = tmp$
  tmp$ = verb$(src): verb$(src) = verb$(dest): verb$(dest) = tmp$
  tmp = VerbType(src): VerbType(src) = VerbType(dest): VerbType(dest) = tmp
  tmp = MPoints(src): MPoints(src) = MPoints(dest): MPoints(dest) = tmp
  tmp = SFx(src): SFx(src) = SFx(dest): SFx(dest) = tmp
  tmp = sLo(src): sLo(src) = sLo(dest): sLo(dest) = tmp
  tmp = sHi(src): sHi(src) = sHi(dest): sHi(dest) = tmp
  tmp = spAdL(src): spAdL(src) = spAdL(dest): spAdL(dest) = tmp
  tmp = spAdH(src): spAdH(src) = spAdH(dest): spAdH(dest) = tmp
  tmp = level(src): level(src) = level(dest): level(dest) = tmp
  tmp = Sxp(src): Sxp(src) = Sxp(dest): Sxp(dest) = tmp
  tmp = SpellNo(src): SpellNo(src) = SpellNo(dest): SpellNo(dest) = tmp
  tmp = TimesCast(src): TimesCast(src) = TimesCast(dest): TimesCast(dest) = tmp
  tmp$ = SCode$(src): SCode$(src) = SCode$(dest): SCode$(dest) = tmp$
  tmp$ = SpellFail$(src): SpellFail$(src) = SpellFail$(dest): SpellFail$(dest) = tmp$
  tmp$ = sDec$(src): sDec$(src) = sDec$(dest): sDec$(dest) = tmp$
RETURN

DupSpl:
  SpellName$(dest) = SpellName$(src)
  verb$(dest) = verb$(src)
  VerbType(dest) = VerbType(src)
  MPoints(dest) = MPoints(src)
  SFx(dest) = SFx(src)
  sLo(dest) = sLo(src)
  sHi(dest) = sHi(src)
  spAdL(dest) = spAdL(src)
  spAdH(dest) = spAdH(src)
  level(dest) = level(src)
  Sxp(dest) = Sxp(src)
  SpellNo(dest) = SpellNo(src)
  TimesCast(dest) = TimesCast(src)
  SCode$(dest) = SCode$(src)
  SpellFail$(dest) = SpellFail$(src)
  sDec$(dest) = sDec$(src)
RETURN

Edit:
  CLS : COLOR wht
  PRINT : PRINT "Enter spell CODE or number to work on, or 0 for menu."
  INPUT "Which Spell to Work on"; Num$
  Num = VAL(Num$)
  tmp = 1
  IF Num < 1 OR Num > NumSpells THEN GOSUB CheckCodes
  IF tmp = 0 THEN RETURN
  CLS
  SplNum = Num
  head$ = "Editing Spell #" + STR$(SplNum) + " -- " + SpellName$(SplNum)
GOTO DoSpell

CheckCodes:
  REM ***  TMP returns NonZero if spell found
  REM ***  NUM returns Spell Number if found
  tmp = 0
  FOR g = 1 TO NumSpells
    IF UCASE$(SCode$(g)) = UCASE$(Num$) THEN
      tmp = 1
      Num = g
      g = NumSpells
    END IF
  NEXT g
RETURN

LookAtMe:
  CLS : COLOR wht
  PRINT : PRINT "Enter spell CODE or number to look at, or 0 for menu."
  INPUT "Which Spell to view"; Num$
  Num = VAL(Num$)
  tmp = 1
  IF Num < 1 OR Num > NumSpells THEN GOSUB CheckCodes
  IF tmp = 0 THEN RETURN
  CLS
  SplNum = Num
  head$ = "Viewing Spell #" + STR$(SplNum) + " -- " + SpellName$(SplNum)
GOTO VwSpell

MapFKeys:
  REM We must remap the  F  keys since QBasic will
  REM not let us read extended KeyCodes..
    KEY 1, "A"
    KEY 2, "B"
    KEY 3, "C"
    KEY 4, "D"
    KEY 5, "E"
    KEY 6, "F"
    KEY 7, "G"
    KEY 8, "H"
    KEY 9, "I"
    KEY 10, "J"
    KEY 30, CHR$(9): REM Make F11 look like TAB key
    KEY 31, CHR$(27): REM Make F12 look like ESC key
RETURN

VwSpell:
  CLS : COLOR wht: PRINT head$
  LOCATE 2, 1: COLOR lyel: PRINT "  Name   : "; : COLOR lred: PRINT SpellName$(SplNum); SPACE$(20)
  LOCATE 3, 1: COLOR lyel: PRINT "  CODE   : "; : COLOR lred: PRINT SCode$(SplNum); SPACE$(20)
  LOCATE 4, 1: COLOR lyel: PRINT "  Verb   : "; : COLOR lred: PRINT verb$(SplNum); SPACE$(20)
  LOCATE 5, 1: COLOR lyel: PRINT "  Style  : "; : COLOR lred: tmp = VerbType(SplNum): VB$ = verb$(SplNum): GOSUB GetVerbs: PRINT Action$; SPACE$(20)
  LOCATE 6, 1: COLOR lyel: PRINT "  MP to cast     : "; : COLOR lred: PRINT MPoints(SplNum); SPACE$(20)
  LOCATE 7, 1: COLOR lyel: PRINT "  XP for casting : "; : COLOR lred: PRINT Sxp(SplNum); SPACE$(25)
  LOCATE 8, 1: COLOR lyel: PRINT "  Level  : "; : COLOR lred: PRINT level(SplNum)
  LOCATE 9, 1: COLOR lyel: PRINT "  Damage : "; : COLOR lred: PRINT sLo(SplNum); " - "; sHi(SplNum)
  LOCATE 10, 1: COLOR lyel: PRINT "  Description: "; : COLOR lred: PRINT sDec$(SplNum)
  LOCATE 11, 1: COLOR lyel: PRINT "  Failure: "; : COLOR lred: PRINT SpellFail$(SplNum)
  LOCATE 13, 1: COLOR lyel: PRINT "  Effects: "; : COLOR lred
  fx = SFx(SplNum)
  IF fx = 0 THEN COLOR wht: PRINT TAB(15); "NO EFFECTS -- Special spell used in Quests or Other..."
  IF fx >= 65535 THEN
    PRINT TAB(15); "PRAYER -- "; MPoints(SplNum) * 5; "% CHANCE TO CAUSE ONE OR MORE OF THE FOLLOWING:"
    fx = 4095: REM 4095=all below bit-values added together...
    COLOR Lblu
  END IF
    IF (fx AND 1) THEN PRINT TAB(15); "Damage target for "; sLo(SplNum); " - "; sHi(SplNum)
    IF (fx AND 32) THEN PRINT TAB(14); sHi(SplNum); "% chance distroy target's armor ("; sLo(SplNum); " protection or under)"
    IF (fx AND 64) THEN PRINT TAB(15); "Heal caster for "; sLo(SplNum); " - "; sHi(SplNum)
    IF (fx AND 128) THEN PRINT TAB(15); "Repair caster's armor "; sLo(SplNum) * 10; " - "; sHi(SplNum) * 10; " points"
    IF (fx AND 512) THEN PRINT TAB(15); "Instant run from fight (addrenalin boost)"
    IF (fx AND 1024) THEN PRINT TAB(15); "Overhead Map:  "; sHi(SplNum)*2; "X  by "; sLo(SplNum)*2; "Y"
    IF (fx AND 2048) THEN PRINT TAB(14); sHi(SplNum); "% chance target cannot fight for "; sLo(SplNum); " rounds (ONE in Demo)"
  PRINT
  COLOR yel
  PRINT " When you are finshed, press ENTER."
  COLOR grn
  ukey a$
RETURN

DoSpell:
  REM Make sure you have ran MapFkeys subroutine first!!!
  CLS : COLOR wht: PRINT head$
  LOCATE 2, 1: COLOR yel: PRINT "F1"; : COLOR lyel: PRINT "  Name   : "; : COLOR lred: PRINT SpellName$(SplNum); SPACE$(20)
  LOCATE 3, 1: COLOR yel: PRINT "F2"; : COLOR lyel: PRINT "  CODE   : "; : COLOR lred: PRINT SCode$(SplNum); SPACE$(20)
  LOCATE 4, 1: COLOR yel: PRINT "F3"; : COLOR lyel: PRINT "  Verb   : "; : COLOR lred: PRINT verb$(SplNum); SPACE$(20)
  LOCATE 5, 1: COLOR yel: PRINT "F4"; : COLOR lyel: PRINT "  Style  : "; : COLOR lred: tmp = VerbType(SplNum): VB$ = verb$(SplNum): GOSUB GetVerbs: PRINT Action$; SPACE$(20)
  LOCATE 6, 1: COLOR yel: PRINT "F5"; : COLOR lyel: PRINT "  MP to cast     : "; : COLOR lred: PRINT MPoints(SplNum); SPACE$(20)
  LOCATE 7, 1: COLOR yel: PRINT "F6"; : COLOR lyel: PRINT "  XP for casting : "; : COLOR lred: PRINT Sxp(SplNum); SPACE$(25)
  LOCATE 8, 1: COLOR yel: PRINT "F7"; : COLOR lyel: PRINT "  Level  : "; : COLOR lred: PRINT level(SplNum)
  LOCATE 9, 1: COLOR yel: PRINT "F8"; : COLOR lyel: PRINT "  Damage : "; : COLOR lred: PRINT sLo(SplNum); " - "; sHi(SplNum)
  LOCATE 10, 1: COLOR yel: PRINT "F9"; : COLOR lyel: PRINT "  Description: "; : COLOR lred: PRINT sDec$(SplNum)
  LOCATE 11, 1: COLOR yel: PRINT "F10"; : COLOR lyel: PRINT "  Failure: "; : COLOR lred: PRINT SpellFail$(SplNum)
  LOCATE 13, 1: COLOR yel: PRINT "TAB"; : COLOR lyel: PRINT " Effects: "; : COLOR lred
  fx = SFx(SplNum)
  IF fx = 0 THEN COLOR wht: PRINT TAB(15); "NO EFFECTS -- Special spell used in Quests or Other..."
  IF fx >= 65535 THEN
    PRINT TAB(15); "PRAYER -- "; MPoints(SplNum) * 5; "% CHANCE TO CAUSE ONE OR MORE OF THE FOLLOWING:"
    fx = 4095: REM 4095=all below bit-values added together...
    COLOR Lblu
  END IF
    IF (fx AND 1) THEN PRINT TAB(15); "Damage target for "; sLo(SplNum); " - "; sHi(SplNum)
    IF (fx AND 32) THEN PRINT TAB(14); sHi(SplNum); "% chance distroy target's armor ("; sLo(SplNum); " protection or under)"
    IF (fx AND 64) THEN PRINT TAB(15); "Heal caster for "; sLo(SplNum); " - "; sHi(SplNum)
    IF (fx AND 128) THEN PRINT TAB(15); "Repair caster's armor "; sLo(SplNum) * 10; " - "; sHi(SplNum) * 10; " points"
    IF (fx AND 512) THEN PRINT TAB(15); "Instant run from fight (addrenalin boost)"
    IF (fx AND 1024) THEN PRINT TAB(15); "Overhead Map:  "; sHi(SplNum)*2; "X  by "; sLo(SplNum)*2; "Y"
    IF (fx AND 2048) THEN PRINT TAB(14); sHi(SplNum); "% chance target cannot fight for "; sLo(SplNum); " rounds (not in Demo)"
  PRINT
  COLOR yel
  PRINT " Press the key of the field you wish to edit."
  PRINT " When you are finshed, press ENTER."
  COLOR grn
1 ukey a$
  IF a$ = CHR$(27) OR a$ = CHR$(13) THEN RETURN
  IF a$ = CHR$(9) THEN x = SplNum: GOSUB Effects: GOTO DoSpell
  SELECT CASE a$
     CASE "A": GOSUB NameEdit: GOTO DoSpell
     CASE "B": GOSUB CodeEdit: GOTO DoSpell
     CASE "C": GOSUB VerbEdit: GOTO DoSpell
     CASE "D": x = SplNum: GOSUB Verbs: GOTO DoSpell
     CASE "E": GOSUB MPEdit: GOTO DoSpell
     CASE "F": GOSUB XPEdit: GOTO DoSpell
     CASE "G": GOSUB LevelEdit: GOTO DoSpell
     CASE "H": GOSUB DamageEdit: GOTO DoSpell
     CASE "I": GOSUB DescEdit: GOTO DoSpell
     CASE "J": GOSUB FailEdit: GOTO DoSpell
  END SELECT
GOTO 1

DamageEdit:
  LOCATE 9, 1: PRINT SPACE$(40);
  LOCATE 9, 1: INPUT "Low Damage "; sLo(SplNum)
  LOCATE 9, 20: INPUT "High Damage "; sHi(SplNum)
  IF sHi(SplNum) < sLo(SplNum) THEN sHi(SplNum) = sLo(SplNum)
RETURN

FailEdit:
  LOCATE 11, 1: PRINT SPACE$(40);
  LOCATE 11, 1: INPUT "Enter Spell Failure Phrase: ", SpellFail$(SplNum)
RETURN

DescEdit:
  LOCATE 10, 1: PRINT SPACE$(40);
  LOCATE 10, 1: INPUT "Enter Description of Spell: ", sDec$(SplNum)
RETURN

NameEdit:
  LOCATE 2, 1: PRINT SPACE$(40);
  LOCATE 2, 1: INPUT "Enter Spell Name: ", SpellName$(SplNum)
RETURN

CodeEdit:
  LOCATE 3, 1: PRINT SPACE$(50);
  LOCATE 3, 1: INPUT "Enter 4 Letter Spell Code: ", a$
  SCode$(SplNum) = LEFT$(a$, 4)
RETURN

VerbEdit:
  LOCATE 4, 1: PRINT SPACE$(50);
  LOCATE 4, 1: INPUT "Enter action verb or sentance: ", verb$(SplNum)
RETURN

MPEdit:
  LOCATE 6, 1: PRINT SPACE$(40);
  LOCATE 6, 1: INPUT "Magic points"; MPoints(SplNum)
RETURN

XPEdit:
  LOCATE 7, 1: PRINT SPACE$(40);
  LOCATE 7, 1: INPUT "Mage Experience"; Sxp(SplNum)
RETURN

LevelEdit:
  LOCATE 8, 1: PRINT SPACE$(40);
  LOCATE 8, 1: INPUT "Spell Level"; level(SplNum)
RETURN

Verbs:
' X = Spell #
  CLS
  COLOR lgr: PRINT "Choose verb type for  #"; x; " -- "; SpellName$(x)
  tmp = VerbType(x)
  GOSUB GetVerbs
  PRINT : PRINT "Current verb type is: "; tmp; " "; tmp$
  PRINT
  FOR g = 1 TO 5
    tmp = g - 1
    GOSUB GetVerbs
    PRINT TAB(5); g; TAB(10); tmp$
  NEXT g
  PRINT : PRINT "Select verb type or press ENTER for menu."
SelVerb:
  GetKey a$
  IF a$ = CHR$(13) THEN RETURN
  a = VAL(a$)
  IF a < 1 OR a > 5 THEN GOTO SelVerb
  VerbType(x) = a - 1
RETURN

GetVerbs:
' VB$ = Verb          (input)
' TMP  = Verb Number  (input)
' TMP$ = Verb String (returned)
' ACTION$ = String with Verb (returned)
  SELECT CASE tmp
    CASE 0: tmp$ = "<verb>": Action$ = VB$
    CASE 1: tmp$ = "Caster <verb> Target": Action$ = "CASTER " + VB$ + " TARGET"
    CASE 2: tmp$ = "Caster <verb>": Action$ = "CASTER " + VB$
    CASE 3: tmp$ = "Target <verb>": Action$ = "TARGET " + VB$
    CASE 4: tmp$ = "Target <verb> Caster": Action$ = "TARGET " + VB$ + " CASTER"
    CASE ELSE
      tmp$ = "No Verb": Action$ = "<no verb>"
  END SELECT
RETURN

Effects:
' X = Spell #
  CLS
  COLOR lgr: PRINT "Choose spell effects for  #"; x; " -- "; SpellName$(x)
  tmp = 0
'Convert SFX binary (16 bit) into TMP (8 bit) for menu...
  IF (SFx(x) AND 1) THEN tmp = tmp + 1
  IF (SFx(x) AND 64) THEN tmp = tmp + 2
  IF (SFx(x) AND 32) THEN tmp = tmp + 4
  IF (SFx(x) AND 128) THEN tmp = tmp + 8
  IF (SFx(x) AND 512) THEN tmp = tmp + 16
  IF (SFx(x) AND 1024) THEN tmp = tmp + 32
  IF (SFx(x) AND 2048) THEN tmp = tmp + 64
  IF (SFx(x) >= 65535) THEN tmp = 128
FXMenu:
  LOCATE 3, 3: item org, "1 ", yel, " Harm Target:"
  LOCATE 4, 3: item org, "2 ", Lblu, " Heal Caster:"
  LOCATE 5, 3: item org, "3 ", lgrn, " Distroy Target's Armor:"
  LOCATE 6, 3: item org, "4 ", grn, " Repair Caster's Armor:"
  LOCATE 7, 3: item org, "5 ", lred, " Instant Run From Fight:"
  LOCATE 8, 3: item org, "6 ", mgr, " Bring up Overhead Map:"
  LOCATE 9, 3: item org, "7 ", pur, " Confusion:"
  LOCATE 9, 40: COLOR lgr: PRINT "(not fully implemented in Demo)"
  LOCATE 10, 3: item org, "8 ", wht, " Prayer:"
  LOCATE 10, 40: COLOR lgr: PRINT "(picks random effects from this list)"
  COLOR yel: PRINT
  PRINT "Use Number keys to pick spell effects,"
  PRINT "press ENTER when done."
  FOR g = 3 TO 10
  LOCATE g, 32
    bit = (g - 3)
    IF (tmp >= 128) THEN
      IF g < 10 THEN
         COLOR dgr: PRINT "-- "
      ELSE
         COLOR grn: PRINT "YES"
      END IF
    ELSEIF (tmp AND (2 ^ bit)) THEN
      COLOR grn: PRINT "YES"
    ELSE
      COLOR red: PRINT "NO "
    END IF
  NEXT g
Num:
  GetKey a$
  IF a$ = CHR$(13) THEN GOTO WereDone
  a = VAL(a$)
  IF a < 1 OR a > 8 THEN GOTO Num
  bit = (a - 1)
  IF (tmp AND (2 ^ bit)) THEN
    tmp = tmp - (2 ^ bit)
  ELSE
    tmp = tmp OR (2 ^ bit)
  END IF
GOTO FXMenu
WereDone:
'Convert TMP 8bit binary back to SFX 16bit binary
  SFx(x) = 0
  IF (tmp AND 1) THEN SFx(x) = SFx(x) + 1
  IF (tmp AND 4) THEN SFx(x) = SFx(x) + 32
  IF (tmp AND 2) THEN SFx(x) = SFx(x) + 64
  IF (tmp AND 8) THEN SFx(x) = SFx(x) + 128
  IF (tmp AND 16) THEN SFx(x) = SFx(x) + 512
  IF (tmp AND 32) THEN SFx(x) = SFx(x) + 1024
  IF (tmp AND 64) THEN SFx(x) = SFx(x) + 2048
  IF (tmp >= 128) THEN SFx(x) = 65535
RETURN

Quit:
    COLOR mgr: PRINT : PRINT : PRINT "Exiting Program...": PRINT : PRINT
    IF NumSpells > 0 THEN
        PRINT "There are "; NumSpells; " Spells in memory right now."
        PRINT "Would you like to SAVE them before you quit?"
        ukey a$
        IF a$ = "Y" THEN GOSUB SaveSpells
    END IF
SYSTEM

LoadSpells:
  CLS : COLOR red: PRINT "  LOAD SPELLSET ";
  COLOR blu: PRINT TAB(45); "Previous Filename:  "; UCASE$(SplFile$)
  File$ = SplFile$
  COLOR grn: PRINT
  GOSUB GetFile
  ON ERROR GOTO BadFile
  OPEN File$ FOR INPUT AS #2
  PRINT : PRINT "Loading..."; File$
    INPUT #2, xx$: xx$ = UCASE$(xx$)
    IF xx$ <> "SHAL1S" THEN
      COLOR 3: PRINT "WARNING: File may be incompatible!"
      NumSpells = VAL(xx$)
      IF NumSpells = 0 THEN INPUT #2, NumSpells
    ELSE
      INPUT #2, NumSpells
    END IF
    IF NumSpells = 0 THEN GOTO DoneLoad
    LOCATE 13, 9: PRINT " of "; NumSpells
    FOR g = 1 TO NumSpells
      LOCATE 13, 5: PRINT g;
      INPUT #2, SpellName$(g), verb$(g), VerbType(g), MPoints(g), SCode$(g)
      INPUT #2, SFx(g), sLo(g), sHi(g), level(g), spAdL(g), spAdH(g), Sxp(g)
      INPUT #2, SpellFail$(g), sDec$(g)
    NEXT g
DoneLoad:
  SplFile$ = File$
  CLOSE #2
  ON ERROR GOTO 0
RETURN

SaveCurSpells:
  File$ = SplFile$
GOTO DoSpSave

SaveSpells:
  CLS : COLOR red: PRINT "  SAVE SPELLSET ";
  COLOR blu: PRINT TAB(45); "Previous Filename:  "; UCASE$(SplFile$)
  File$ = SplFile$
  COLOR grn: PRINT
  GOSUB GetFile
  ON ERROR GOTO BadFile
DoSpSave:
  OPEN File$ FOR OUTPUT AS #2
    PRINT : COLOR lgr
    PRINT "Saving..."; File$
    LOCATE 13, 9: PRINT " of "; NumSpells
    PRINT #2, "SHAL1S"
    PRINT #2, NumSpells
    IF NumSpells = 0 THEN GOTO DoneSave
    LOCATE 13, 5: PRINT NumSpells;
    FOR g = 1 TO NumSpells
      LOCATE 13, 5: PRINT g
      WRITE #2, SpellName$(g), verb$(g), VerbType(g), MPoints(g), SCode$(g)
      WRITE #2, SFx(g), sLo(g), sHi(g), level(g), spAdL(g), spAdH(g), Sxp(g)
      WRITE #2, SpellFail$(g), sDec$(g)
    NEXT g
DoneSave:
  SplFile$ = File$
  CLOSE #2
  ON ERROR GOTO 0
RETURN

BadFile:
  CLOSE #1
  COLOR lgr
  PRINT : PRINT
  PRINT " -  FILE ERROR  - ": PRINT
  PRINT ERR
  COLOR Lblu
  GetKey a$
RESUME MainMenu

GetFile:
  COLOR yel: PRINT "Enter filename for SpellSet."
  PRINT : COLOR grn
  PRINT "Type  '  to use previous filename,"; TAB(45); "NOTE:  The ' key is right next"
  PRINT "or press ENTER for directory."; TAB(52); "to ENTER on most keyboards."
  PRINT
  xx$ = "": COLOR yel
  PRINT : INPUT "Enter Filename: ", xx$
  IF xx$ = "" THEN
     COLOR Lblu
     PRINT
     FILES "*.spl"
     GOTO GetFile
  END IF
  IF xx$ = "'" THEN
    File$ = SplFile$
  ELSE
    File$ = xx$
  END IF
  GOSUB Parse
  SplFile$ = File$
RETURN

Parse:
  g = LEN(File$)
  IF g > 8 THEN g = 8
  FOR x = 1 TO g
    xx$ = MID$(File$, x, 1)
    IF xx$ = "." OR xx$ = "\" OR xx$ = "*" OR xx$ = "?" THEN
      MID$(File$, x, 1) = "_"
    END IF
  NEXT x
  File$ = LEFT$(File$, 8) + ".SPL"
RETURN

SUB GetKey (a$) STATIC
999 a$ = INKEY$
  IF a$ = "" THEN 999
END SUB

SUB item (a, a$, B, B$) STATIC
  COLOR a
  PRINT a$;
  COLOR B
  PRINT B$
END SUB

SUB ukey (a$) STATIC
998 a$ = UCASE$(INKEY$)
  IF a$ = "" THEN 998
END SUB

