DECLARE SUB Range (var!, low!, hi!)
DECLARE SUB dec (a!)
DECLARE SUB inc (a!)
DECLARE SUB blot (a$, c)
DECLARE SUB Toggle (var!)
DECLARE SUB CLPrint (px%, py%, cpen!, paper!, msg$)
DECLARE SUB CenterText (text$, posn%)
DECLARE SUB PrintAt (px%, py%, msg$)
DECLARE SUB HitAnyKey ()
DECLARE SUB ukey (zxc$)
DECLARE SUB WaitNSec (n!)
DECLARE SUB Item (fore!, fore$, aft!, aft$)
DECLARE SUB ItemAt (px%, py%, fore!, fore$, aft!, aft$)
DECLARE SUB GetKey (zxc$)
DECLARE SUB Erx (zxc$)
DECLARE SUB GraphTile (x, y)
DECLARE SUB InitTiles ()
DECLARE SUB SaveTile (x!, y!, tileno, fm$)
DECLARE SUB LoadTile (tileno, fm$)
DECLARE SUB tileat (xt!, yt!, tileno)
DECLARE SUB gettile (x, y, tileno)


DEF fnran (low, High) = INT(RND(1) * ((High + 1) - low)) + low

DIM SHARED tilesize%, tileXsize, tileYsize, numtiles, fore, aft
  tileXsize = 16
  tileYsize = 16
  tilesize% = 66
  numtiles = 50
DIM SHARED tile%(tilesize%, numtiles), tilegraph%(tileXsize, tileYsize)
DIM SHARED blk, brn, red, yel, grn, blu, pur, wht, groffsetx, groffsety
DIM SHARED org, lgr, mgr, dgr, lred, lyel, lgrn, lblu
blk = 0: brn = 6: red = 4: yel = 14: grn = 2: blu = 1: pur = 5: wht = 15
org = 11: lgr = 3: mgr = 7: dgr = 8: lred = 12: lyel = 13: lgrn = 10: lblu = 9
xdot = 8: ydot = 8: groffsetx = 52: groffsety = 2: oldx = xdot: oldy = ydot
grafx = 16: grafy = 16: xtil = 2: ytil = 2: xmul = 1: ymul = 4
NoTiles = 0: curtile = 0: modevar = 1: curcol = 0
RANDOMIZE TIMER
SCREEN 0

TitleScreen:
    CLS : COLOR yel
    CenterText "Shalimar Tile Edit Version 0.5", 1
    CenterText "By Seth Hopkinson, 11-Jun-1995  (last mod 15-Jul-1995)", 2
    COLOR org
    CenterText "Currently supporting  16 x 16  tiles in  16  colors.", 4
    ItemAt 10, 7, red, "L", blu, "oad a tile"
    ItemAt 10, 8, red, "E", blu, "dit a tile (or design new ones)"
    ItemAt 10, 9, red, "D", blu, "ebug"
    ItemAt 10, 10, red, "C", blu, "onvert all to .B16"
    ItemAt 10, 12, red, "Q", blu, "uit and return to DOS"
    PRINT : PRINT
0   ukey a$
    IF a$ = "L" THEN GOSUB LoadATile: GOTO Editor
    IF a$ = "E" THEN GOSUB NewTile: GOTO Editor
    IF a$ = "C" THEN GOSUB BigJob: GOTO TitleScreen
    IF a$ = "D" THEN GOSUB Debug: GOTO Editor
    IF a$ = "Q" THEN SYSTEM
GOTO 0

Editor:
    SCREEN 8
    CLS : COLOR mgr: LOCATE 22, 1
    PRINT "There are "; NoTiles; " in memory out of a possible of "; numtiles
    LOCATE 23, 2
    PRINT "You are currently editing tile number "; curtile
    GOSUB DispTile
    GraphTile grafx, grafy
    modevar = 1
    GOSUB moveDot
    COLOR mgr
    LOCATE 2, 12: PRINT "Use NUMBER PAD to move."
    ItemAt 12, 4, red, "/ *", blu, " Next/Prev tile"
    ItemAt 12, 5, red, "5", blu, " Place a dot ("
    COLOR red: PRINT "ENTER"; : COLOR blu: PRINT " clears a dot)"
    ItemAt 12, 6, red, "0", blu, " Change Mode"
    ItemAt 12, 7, red, "+ -", blu, " change color (Current    )"
    ItemAt 12, 8, red, "L", blu, "oad tile"
    ItemAt 12, 9, red, "S", blu, "ave Tile (.T16 for Basic)"
    LOCATE 10, 12: PRINT "Save "; : Item red, "A", blu, "s .B16 (for C)"
    ItemAt 12, 11, red, "N", blu, "ew tile"
    ItemAt 12, 12, red, "D", blu, "elete current tile from memory"
    ItemAt 12, 13, red, "V", blu, "iew all tiles in memory"
    ItemAt 12, 14, red, "P", blu, "ick tile to edit"
    ItemAt 12, 15, red, "M", blu, "ove Tile (or H,V flip)"
    ItemAt 12, 16, red, "Q", blu, "uit to Title Screen"
DispMode:
    LOCATE 19, 12: COLOR org: PRINT "Mode: "; : COLOR mgr
    IF modevar = 0 THEN PRINT "DRAW" ELSE PRINT "MOVE"
DispColor:
    LOCATE 7, 38: blot "  ", curcol
    COLOR mgr
CheckKeys:
    ukey a$
    IF a$ = CHR$(13) THEN
        tmp = modevar: modevar = 0
        oc = curcol: curcol = 0
        GOSUB moveDot
        modevar = tmp: curcol = oc
    END IF
    SELECT CASE a$
        CASE "L": GOSUB LoadATile: GOTO Editor
        CASE "Q": GOTO TitleScreen
        CASE "+": GOSUB IncColor: GOTO DispColor
        CASE "-": GOSUB DecColor: GOTO DispColor
        CASE "/": GOSUB IncTile: GOTO Editor
        CASE "*": GOSUB DecTile: GOTO Editor
        CASE "V": GOSUB ViewTiles: HitAnyKey: GOTO Editor
        CASE "P": GOSUB ViewTiles: GOSUB PickOne: GOTO Editor
        CASE "N": GOSUB NewTile: GOTO Editor
        CASE "A": GOSUB SaveB16: GOTO Editor
        CASE "S": GOSUB SaveATile: GOTO Editor
        CASE "0": Toggle modevar: GOTO DispMode
        CASE "5": tmp = modevar: modevar = 0: GOSUB moveDot: modevar = tmp
        CASE "1": dec xdot: inc ydot: GOSUB moveDot
        CASE "3": inc xdot: inc ydot: GOSUB moveDot
        CASE "7": dec xdot: dec ydot: GOSUB moveDot
        CASE "9": inc xdot: dec ydot: GOSUB moveDot
        CASE "2": inc ydot: GOSUB moveDot
        CASE "8": dec ydot: GOSUB moveDot
        CASE "4": dec xdot: GOSUB moveDot
        CASE "6": inc xdot: GOSUB moveDot
        CASE "M": GOSUB specialFunc: GOTO Editor
    END SELECT
GOTO CheckKeys

specialFunc:
  COLOR lred: LOCATE 19, 8: PRINT "PRESS DIRECTION KEY..."
  LOCATE 20, 8: PRINT "OR  H  OR  V  FOR FLIP"
  xc = (xtil - 1) * tileXsize
  yc = (ytil - 1) * tileYsize
  ukey a$
  SELECT CASE a$
        CASE "8": inc yc: GOSUB moveDot
        CASE "2": dec yc: GOSUB moveDot
        CASE "6": dec xc: GOSUB moveDot
        CASE "4": inc xc: GOSUB moveDot
        CASE "9": dec xc: inc yc: GOSUB moveDot
        CASE "7": inc xc: inc yc: GOSUB moveDot
        CASE "3": dec xc: dec yc: GOSUB moveDot
        CASE "1": inc xc: dec yc: GOSUB moveDot
        CASE "H": GOSUB horflip
        CASE "V": GOSUB verflip
  END SELECT
  GET (xc, yc)-(xc + (tileXsize - 1), yc + (tileYsize - 1)), tile%(0, curtile)
RETURN

horflip:
    CLS
    tileat xtil, ytil, curtile
    GraphTile grafx, grafy
    xc = (xtil - 1) * tileXsize
    yc = (ytil - 1) * tileYsize
    FOR y = 1 TO tileYsize
        FOR g = 1 TO tileXsize / 2
          x1 = g
          lf = POINT(x1 + xc - 1, y + yc - 1)
          x2 = 16 - g
          rt = POINT(x2 + xc - 1, y + yc - 1)
          tilegraph%(x1, y) = rt
          tilegraph%(x2, y) = lf
          PSET (x1 + xc - 1, y + yc - 1), rt
          PSET (x2 + xc - 1, y + yc - 1), lf
        NEXT g
    NEXT y
    gettile xtil, ytil, tileno
RETURN

verflip:
    CLS
    tileat xtil, ytil, curtile
    GraphTile grafx, grafy
    xc = (xtil - 1) * tileXsize
    yc = (ytil - 1) * tileYsize
    FOR x = 1 TO tileXsize
        FOR g = 1 TO tileYsize / 2
          y1 = g
          lf = POINT(x + xc - 1, y1 + yc - 1)
          y2 = 16 - g
          rt = POINT(x + xc - 1, y2 + yc - 1)
          tilegraph%(x, y1) = rt
          tilegraph%(x, y2) = lf
          PSET (x + xc - 1, y1 + yc - 1), rt
          PSET (x + xc - 1, y2 + yc - 1), lf
        NEXT g
    NEXT x
    gettile xtil, ytil, tileno
RETURN

DispTile:
    tileat xtil, ytil, curtile
    FOR f = xmul TO xmul + 2
        FOR g = ymul TO ymul + 2
            tileat f, g, curtile
        NEXT g
    NEXT f
RETURN

moveDot:
    Range xdot, 1, 16
    Range ydot, 1, 16
    xoff = ((groffsetx + xdot - 1) * 8) + 4
    yoff = ((groffsety + ydot - 1) * 8) + 4
    xo = ((groffsetx + oldx - 1) * 8) + 4
    yo = ((groffsety + oldy - 1) * 8) + 4
    PSET (xo, yo), tilegraph%(oldx, oldy)
    oldx = xdot
    oldy = ydot
    IF modevar = 0 THEN
        tilegraph%(xdot, ydot) = curcol
        LOCATE (groffsety + ydot), (groffsetx + xdot)
        blot " ", curcol
        PSET (((xtil - 1) * 16) + xdot - 1, ((ytil - 1) * 16) + ydot - 1), curcol
        gettile 2, 2, curtile
        GOSUB DispTile
    END IF
    PSET (xoff, yoff), 15 - tilegraph%(xdot, ydot)
RETURN

IncColor:
    inc curcol
    IF curcol > 15 THEN curcol = 0
RETURN

DecColor:
    dec curcol
    IF curcol < 0 THEN curcol = 15
RETURN

IncTile:
    inc curtile
    IF curtile > NoTiles THEN curtile = 1
RETURN

DecTile:
    dec curtile
    IF curtile < 1 THEN curtile = NoTiles
RETURN

ViewTiles:
    SCREEN 7
    COLOR mgr
    FOR t = 1 TO NoTiles
        c = t - 1
        y = INT(c / 10)
        x = (c - (y * 10)) * 2
        x = x + 1
        y = (y * 2) + 1
        tileat x, y, t
        IF x < 2 THEN xx = 1 ELSE xx = (x * 2) - 2
        LOCATE 1 + (y * 2), xx
        COLOR mgr: PRINT t;
    NEXT t
    PRINT : PRINT
RETURN

PickOne:
    PRINT
    INPUT "Which tile to edit: ", x
    IF x < 1 OR x > NoTiles THEN BEEP: x = 1
    curtile = x
RETURN

NewTile:
    inc NoTiles
    IF NoTiles < numtiles THEN
        tile%(0, NoTiles) = tileXsize
        tile%(1, NoTiles) = tileXsize
        FOR g = 2 TO tilesize%
            tile%(g, NoTiles) = 0
        NEXT g
        curtile = NoTiles
    ELSE
        PRINT "Memory is full.  Delete tiles if you want to load more...!"
        dec NoTiles
        HitAnyKey
    END IF
RETURN

BigJob:
    SCREEN 8
    GOSUB Debug
    RESTORE
    LOCATE 5, 1: PRINT NoTiles; " have been loaded..."
    FOR g = 1 TO NoTiles
        curtile = g
        READ nam$
        LOCATE 7, 1: PRINT SPACE$(50);
        LOCATE 7, 1
        PRINT "Saving tile "; g; " - "; nam$; ".T16 > "; nam$; ".B16";
        tileat 2, 2, curtile
        GraphTile grafx, grafy
        GOSUB justDoIt
    NEXT g
    LOCATE 10, 1: PRINT "DONE!"
    HitAnyKey
RETURN

SaveB16:
    CLS
    tileat 2, 2, curtile
    GraphTile grafx, grafy
    INPUT "Enter 8-character filename: ", nam$
justDoIt:
    finam$ = LEFT$(nam$, 8) + ".B16"
    OPEN finam$ FOR OUTPUT AS #2
        FOR y = 1 TO tileXsize
            FOR x = 1 TO tileYsize
                PRINT #2, CHR$(tilegraph%(x, y));
            NEXT x
        NEXT y
    CLOSE 2
REM X and Y backwards rotates tile 90 degrees...
RETURN

SaveATile:
    CLS
    tileat 2, 2, curtile
    INPUT "Enter 8-character filename: ", nam$
    finam$ = LEFT$(nam$, 8) + ".T16"
    SaveTile 2, 2, curtile, finam$
RETURN


LoadATile:
    SCREEN 0
    NoTiles = NoTiles + 1
    IF NoTiles < numtiles THEN
        INPUT "Tile to load: ", nam$
        LoadTile NoTiles, nam$
        curtile = NoTiles
    ELSE
        PRINT "Memory is full.  Delete tiles if you want to load more...!"
        HitAnyKey
    END IF
RETURN

Debug:
    CLS : COLOR mgr
    PRINT : PRINT " Making a mess..."
    RESTORE
    FOR g = 1 TO numtiles
        READ a$
        LoadTile g, a$
    NEXT g
    NoTiles = numtiles
    curtile = 1
RETURN

DATA sand,water,tree,grass,lava,mountain,dungeon,town,player
DATA ARMOR,BOAT,BOAT1,BRICK,CRSTATUE,DOOR
DATA FOUNT2,FOUNTAIN,GOLD,GRAVELFL,ITEM,KEY,LAMP
DATA LOCKDOOR,MAGICXTL,MERCHANT,MESSAGE,PERSON0,PERSON1,PERSON2
DATA PERSON3, PERSON4, PERSON5, PICKAXE, POTION, SANDSTON, SCEPTRE
DATA SETENC,SHADRACK,STONWAL1,STONWAL2,STONWAL3,STONWALL,SWORELEM
DATA TABLE,TORCH,TREASURE,WALL,WBRICK,WEAPON,WOOD

SUB blot (a$, c)
    x = (POS(0) - 1) * 8
    y = (CSRLIN - 1) * 8
    z = LEN(a$) * 8
    LINE (x, y)-(x + z, y + 8), c, BF
END SUB

SUB CenterText (text$, posn%)
  p = 40 - INT(LEN(text$) / 2)
  LOCATE posn%, p
  PRINT text$
END SUB

SUB CLPrint (px%, py%, cpen, paper, msg$)
  COLOR cpen, paper: LOCATE py%, px%: PRINT msg$
END SUB

SUB dec (a)
    a = a - 1
END SUB

SUB Erx (zxc$)
  COLOR lred
  PRINT : PRINT : PRINT "FATAL ERROR!"
  PRINT zxc$
  STOP
END SUB

SUB GetKey (zxc$)
getkeyloop:
  zxc$ = INKEY$
  IF zxc$ = "" THEN GOTO getkeyloop
END SUB

SUB gettile (x, y, tileno)
  xc = (x - 1) * tileXsize
  yc = (y - 1) * tileYsize
  GET (xc, yc)-(xc + (tileXsize - 1), yc + (tileYsize - 1)), tile%(0, tileno)
END SUB

SUB GraphTile (x, y)
  FOR tmpy = 1 TO tileYsize
    FOR tmpx = 1 TO tileXsize
      tmp = POINT(tmpx + x - 1, tmpy + y - 1)
      tilegraph%(tmpx, tmpy) = tmp
      GOSUB SetChar
    NEXT tmpx
  NEXT tmpy
  GOTO dpWait

SetChar:
    LOCATE tmpy + groffsety, tmpx + groffsetx
    blot " ", tmp
RETURN

dpWait:
    FOR tmpy = 1 TO tileYsize + 1
        LINE (groffsetx * 8, (tmpy + groffsety - 1) * 8)-((tileXsize + groffsetx) * 8, (tmpy + groffsety - 1) * 8), dgr
    NEXT tmpy
    FOR tmpx = 1 TO tileXsize + 1
        LINE ((tmpx + groffsetx - 1) * 8, groffsety * 8)-((tmpx + groffsetx - 1) * 8, (tileYsize + groffsety) * 8), dgr
    NEXT tmpx
END SUB

SUB HitAnyKey
  PRINT : PRINT SPC(10); "Hit any key to continue..."
5 IF INKEY$ = "" THEN 5
END SUB

SUB inc (a)
    a = a + 1
END SUB

SUB Item (fore, fore$, aft, aft$)
  COLOR fore: PRINT fore$;
  COLOR aft: PRINT aft$
END SUB

SUB ItemAt (px%, py%, fore, fore$, aft, aft$)
  LOCATE py%, px%
  COLOR fore: PRINT fore$;
  COLOR aft: PRINT aft$;
END SUB

SUB LoadTile (tileno, fm$)
  ff$ = fm$ + ".T16"
  OPEN ff$ FOR INPUT AS #2
     FOR x = 0 TO tilesize%
       INPUT #2, tile%(x, tileno)
    NEXT x
  CLOSE 2
END SUB

SUB PrintAt (px%, py%, msg$)
  LOCATE py%, px%: PRINT msg$;
END SUB

SUB Range (var, low, hi)
    IF var > hi THEN var = hi
    IF var < low THEN var = low
END SUB

SUB SaveTile (x, y, tileno, fm$)
  xc = (x - 1) * tileXsize
  yc = (y - 1) * tileYsize
  GET (xc, yc)-(xc + (tileXsize - 1), yc + (tileYsize - 1)), tile%(0, tileno)
    OPEN fm$ FOR OUTPUT AS #2
    FOR x = 0 TO tilesize%
      PRINT #2, tile%(x, tileno)
    NEXT x
  CLOSE 2
END SUB

SUB tileat (xt, yt, tileno)
  PUT ((xt - 1) * tileXsize, (yt - 1) * tileYsize), tile%(0, tileno), PSET
END SUB

SUB Toggle (var)
  IF var = 0 THEN
    var = 1
  ELSE
    var = 0
  END IF
END SUB

SUB ukey (zxc$)
ukeyloop:
  zxc$ = UCASE$(INKEY$): IF zxc$ = "" THEN GOTO ukeyloop
END SUB

SUB WaitNSec (n)
  a = TIMER
wnse:
  IF (TIMER - a) < n AND (TIMER - a) > 0 THEN GOTO wnse
END SUB

