' Sceptre of Shalimar Town Maker Version 0.7     (for Shalimar Pre-Release 1)
' Created by Seth Hopkinson on 31-May-1996    Last Modification:  9-Jun-1996
' (adapted from the Monster Maker and Spell Maker)

DECLARE SUB item (a!, a$, B!, B$)
DECLARE SUB UKey (a$)
DECLARE SUB GetKey (a$)

RANDOMIZE TIMER
DEF FNran (Low, High) = INT(RND(1) * ((High + 1) - Low)) + Low

CLS : LOCATE 12, 25
PRINT "Please Wait, Inititializing..."
GOSUB MapFKeys

'Max number of Shops and Rumors
'DO NOT CHANGE THESE VALUES UNLESS YOU ALSO CHANGE THEM IN SHALIMAR!!!
MaxShops = 9
MaxRumors = 9

'Number of Shops and Rumors currently in Memory.
Shops = 0
Rumors = 0

DIM ShopName$(MaxShops), ShopCode(MaxShops), XPos(MaxShops), YPos(MaxShops)
DIM Rumor$(MaxRumors), Who$(MaxRumors)
DIM FKey$(12)
 
'Default FileName
TwnFile$ = "NEWTOWN.BTW"
tNam$ = ""

'To make colors easier to remember...
Black = 0: brn = 6: red = 4: org = 13: yel = 14: grn = 2: blu = 1: pur = 5: wht = 15
lgr = 7: mgr = 3: dgr = 8: lred = 12: lyel = 11: lgrn = 10: lblu = 9

MainMenu:
  CLS : GOSUB Title
  IF tNam$ <> "" THEN
    COLOR mgr: PRINT "Currently working on:  ";
    COLOR lred: PRINT tNam$
    COLOR mgr: PRINT "Exits to surface at:  "; : COLOR lred: PRINT exitX; ","; exitY;
    COLOR mgr: PRINT TAB(55); "Filename:  "; : COLOR lblu: PRINT UCASE$(TwnFile$)
    COLOR mgr: PRINT "Description:  ";
    COLOR lred: PRINT Town$
    COLOR mgr: PRINT TAB(55); : PRINT "Rum: "; Rumors; "  Shp: "; Shops
    PRINT
  END IF
  item yel, "  L", mgr, "oad Town"
  IF tNam$ <> "" THEN
    COLOR yel: PRINT "  S"; : COLOR mgr: PRINT "ave Town (in file "; UCASE$(TwnFile$); ")"
    COLOR mgr: PRINT "  Save "; : COLOR yel: PRINT "A"; : : COLOR mgr: PRINT "s... (save town under different filename)"
  END IF
  PRINT
  item yel, "  E", mgr, "xit coordinates"
  item yel, "  D", mgr, "escription"
  item yel, "  N", mgr, "ame"
  PRINT
  COLOR mgr: PRINT "  Work on s"; : COLOR yel: PRINT "H"; : : COLOR mgr: PRINT "ops"
  COLOR mgr: PRINT "  Work on "; : COLOR yel: PRINT "R"; : : COLOR mgr: PRINT "umors"
  PRINT
  item yel, "  Q", mgr, "uit program"
1 UKey a$
  IF a$ = "L" THEN GOSUB LoadTown: GOTO MainMenu
  IF tNam$ <> "" THEN
    IF a$ = "S" THEN GOSUB SaveCurTown: GOTO MainMenu
    IF a$ = "A" THEN GOSUB SaveTown: GOTO MainMenu
  END IF
  IF a$ = "E" THEN GOSUB ExitCoord: GOTO MainMenu
  IF a$ = "D" THEN GOSUB Descr: GOTO MainMenu
  IF a$ = "N" THEN GOSUB MapName: GOTO MainMenu
  IF a$ = "H" THEN GOSUB DoShops: GOTO MainMenu
  IF a$ = "R" THEN GOSUB DoRumors: GOTO MainMenu
  IF a$ = "Q" OR a$ = CHR$(27) THEN SYSTEM
  GOTO 1
END

ExitCoord:
  CLS
  PRINT : COLOR org
  PRINT "Current exit coordinates are "; exitX; ","; exitY
  COLOR grn
  a = 0
  INPUT "Enter new X coordinate (or enter to keep current): ", a
  IF a > 0 THEN exitX = a
  a = 0
  INPUT "Enter new Y coordinate (or enter to keep current): ", a
  IF a > 0 THEN exitY = a
RETURN

Descr:
  CLS
  PRINT : COLOR org
  PRINT "Current description is "; Town$
  COLOR grn
  a$ = ""
  INPUT "Enter new description (or enter to keep current): ", a$
  IF a$ <> "" THEN Town$ = a$
RETURN

MapName:
  CLS
  PRINT : COLOR org
  PRINT "Current town name is "; tNam$
  COLOR grn
  a$ = ""
  INPUT "Enter new town name (or enter to keep current): ", a$
  IF a$ <> "" THEN tNam$ = a$
RETURN

DoShops:
  CLS
  PRINT : COLOR org
  PRINT "Work on SHOPS"
  PRINT TAB(30); "SHOPS: "; Shops
  IF Shops >= MaxShops THEN
      item brn, "  A", dgr, "dd new shop"
  ELSE
      item yel, "  A", mgr, "dd new shop"
  END IF
  IF Shops >= 1 THEN
      item yel, "  E", mgr, "dit/view shops"
      item yel, "  D", mgr, "elete shop"
      item yel, "  R", mgr, "emove last shop"
  END IF
  PRINT
  item yel, " ENTER ", mgr, " return to main menu."
5 UKey a$
  IF a$ = CHR$(13) OR a$ = CHR$(27) OR a$ = CHR$(10) THEN RETURN
  SELECT CASE a$
    CASE "D": GOSUB DeleteShop: GOTO DoShops
    CASE "A": GOSUB AddShop: GOTO DoShops
    CASE "V": GOSUB EditShop: GOTO DoShops
    CASE "E": GOSUB EditShop: GOTO DoShops
    CASE "R": GOSUB RemShop: GOTO DoShops
  END SELECT
GOTO 5

DoRumors:
  CLS
  PRINT : COLOR org
  PRINT "Work on RUMORS"
  PRINT TAB(30); "RUMORS: "; Rumors
  IF Rumors >= MaxRumors THEN
      item brn, "  A", dgr, "dd new rumor"
  ELSE
      item yel, "  A", mgr, "dd new rumor"
  END IF
  IF Rumors >= 1 THEN
      item yel, "  E", mgr, "dit/view rumors"
      item yel, "  D", mgr, "elete rumor"
      item yel, "  R", mgr, "emove last rumor"
  END IF
  PRINT
  item yel, " ENTER ", mgr, " return to main menu."
2 UKey a$
  IF a$ = CHR$(13) OR a$ = CHR$(27) OR a$ = CHR$(10) THEN RETURN
  SELECT CASE a$
    CASE "D": GOSUB DeleteRumor: GOTO DoRumors
    CASE "A": GOSUB AddRumor: GOTO DoRumors
    CASE "V": GOSUB EditRumor: GOTO DoRumors
    CASE "E": GOSUB EditRumor: GOTO DoRumors
    CASE "R": GOSUB RemRumor: GOTO DoRumors
  END SELECT
GOTO 2

RemShop:
  Shops = Shops - 1
RETURN

RemRumor:
  Rumors = Rumors - 1
RETURN

DeleteShop:
  CLS : GOSUB DispShops
  COLOR yel: PRINT "Which shop to DELETE?   ( ENTER for menu )"
6 GetKey a$
  IF a$ = CHR$(13) OR a$ = CHR$(27) OR a$ = CHR$(10) THEN RETURN
  IF a$ < "A" OR a$ > "J" THEN 6
  a = ASC(a$) - 64
  tmp$ = ShopName$(Shops): ShopName$(Shops) = ShopName$(a): ShopName$(a) = tmp$
  tmp = ShopCode(Shops): ShopCode(Shops) = ShopCode(a): ShopCode(a) = tmp
  tmp = XPos(Shops): XPos(Shops) = XPos(a): XPos(a) = tmp
  tmp = YPos(Shops): YPos(Shops) = YPos(a): YPos(a) = tmp
  Shops = Shops - 1
RETURN

DeleteRumor:
  CLS : GOSUB DispRumors
  COLOR yel: PRINT "Which rumor to DELETE?   ( ENTER for menu )"
4 GetKey a$
  IF a$ = CHR$(13) OR a$ = CHR$(27) OR a$ = CHR$(10) THEN RETURN
  IF a$ < "A" OR a$ > "J" THEN 4
  a = ASC(a$) - 64
  tmp$ = Rumor$(Rumors): Rumor$(Rumors) = Rumor$(a): Rumor$(a) = tmp$
  tmp$ = Who$(Rumors): Who$(Rumors) = Who$(a): Who$(a) = tmp$
  Rumors = Rumors - 1
RETURN

EditRumor:
  CLS : GOSUB DispRumors
  COLOR yel: PRINT "Which rumor to edit?   ( ENTER for menu )"
3 GetKey a$
  IF a$ = CHR$(13) OR a$ = CHR$(27) OR a$ = CHR$(10) THEN RETURN
  IF a$ < "A" OR a$ > "J" THEN 3
  a = ASC(a$) - 64
  GOSUB EnterRumor
GOTO EditRumor

EditShop:
  CLS : GOSUB DispShops
  COLOR yel: PRINT "Which shop to edit?   ( ENTER for menu )"
7 GetKey a$
  IF a$ = CHR$(13) OR a$ = CHR$(27) OR a$ = CHR$(10) THEN RETURN
  IF a$ < "A" OR a$ > "J" THEN 7
  a = ASC(a$) - 64
  GOSUB EnterShop
GOTO EditShop
 
DispShops:
  COLOR lgrn: PRINT "Current Shops:"
  PRINT
  FOR g = 1 TO Shops
      IF ShopCode(g) = 1 THEN tmp$ = "Weapon Shop"
      IF ShopCode(g) = 2 THEN tmp$ = "Armor Shop"
      IF ShopCode(g) = 3 THEN tmp$ = "Tavern"
      IF ShopCode(g) = 4 THEN tmp$ = "Mage's Guild"
      IF ShopCode(g) = 5 THEN tmp$ = "Healer"
      IF ShopCode(g) = 6 THEN tmp$ = "Adventurer's Guild"
      IF ShopCode(g) = 7 THEN tmp$ = "Gladiator Pit"
      IF ShopCode(g) = 8 THEN tmp$ = "Transport Emporium"
      IF ShopCode(g) = 9 THEN tmp$ = "Casino"
      IF ShopCode(g) = 10 THEN tmp$ = "Lake (Special)"
      IF ShopCode(g) = 11 THEN tmp$ = "Ruins (Special)"
      IF ShopCode(g) = 12 THEN tmp$ = "Caves (Special)"
      IF ShopCode(g) = 13 THEN tmp$ = "Black Market"
      IF ShopCode(g) = 14 THEN tmp$ = "BoatWright"
      IF ShopCode(g) = 15 THEN tmp$ = "Mystic (Special)"
      IF ShopCode(g) > 15 THEN tmp$ = "Inventor's Workshop"
      COLOR mgr: PRINT FKey$(g);
      COLOR lred: PRINT TAB(5); tmp$;
      COLOR lblu: PRINT TAB(25); ShopName$(g)
  NEXT g
  PRINT
RETURN

DispRumors:
  COLOR lgrn: PRINT "Current Rumors:"
  PRINT
  FOR g = 1 TO Rumors
      COLOR mgr: PRINT FKey$(g);
      COLOR lred: PRINT TAB(5); Who$(g);
      COLOR mgr: PRINT " says: ";
      COLOR lblu: PRINT Rumor$(g)
  NEXT g
  PRINT
RETURN

EnterRumor:
  COLOR grn: PRINT
  PRINT "Enter new character description, or press ENTER to keep current one"
  PRINT "("; Who$(a); ")"
  INPUT "Enter character description: ", a$
  IF a$ <> "" THEN Who$(a) = a$
  PRINT
  PRINT "Enter new rumor, or press ENTER to keep current one"
  PRINT "("; Rumor$(a); ")"
  INPUT "Enter rumor: ", a$
  IF a$ <> "" THEN Rumor$(a) = a$
RETURN

AddRumor:
  IF Rumors >= MaxRumors THEN
    COLOR red: PRINT : PRINT "MAXIMUM OF "; MaxRumors; " RUMORS PER CITY!"
    BEEP
    RETURN
  END IF
  CLS : GOSUB DispRumors
  Rumors = Rumors + 1
  a = Rumors: GOSUB EnterRumor
RETURN

AddShop:
  IF Shops >= MaxShops THEN
    COLOR red: PRINT : PRINT "MAXIMUM OF "; MaxShops; " SHOPS PER CITY!"
    BEEP
    RETURN
  END IF
  CLS : GOSUB DispShops
  Shops = Shops + 1
  a = Shops: GOSUB EnterShop
RETURN

EnterShop:
    CLS : GOSUB GetShopName
    COLOR yel: PRINT "A"; : COLOR mgr: PRINT TAB(5); "Weapon Shop"
    COLOR yel: PRINT "B"; : COLOR mgr: PRINT TAB(5); "Armor Shop"
    COLOR yel: PRINT "C"; : COLOR mgr: PRINT TAB(5); "Tavern"
    COLOR yel: PRINT "D"; : COLOR mgr: PRINT TAB(5); "Mage's Guild"
    COLOR yel: PRINT "E"; : COLOR mgr: PRINT TAB(5); "Healer"
    COLOR yel: PRINT "F"; : COLOR mgr: PRINT TAB(5); "Adventurer's Guild"
    COLOR yel: PRINT "G"; : COLOR mgr: PRINT TAB(5); "Gladiator Pit"
    COLOR yel: PRINT "H"; : COLOR mgr: PRINT TAB(5); "Transport Emporium"
    COLOR yel: PRINT "I"; : COLOR mgr: PRINT TAB(5); "Casino"
    COLOR yel: PRINT "J"; : COLOR mgr: PRINT TAB(5); "Lake (Special)"
    COLOR yel: PRINT "K"; : COLOR mgr: PRINT TAB(5); "Ruins (Special)"
    COLOR yel: PRINT "L"; : COLOR mgr: PRINT TAB(5); "Caves (Special)"
    COLOR yel: PRINT "M"; : COLOR mgr: PRINT TAB(5); "Black Market"
    COLOR yel: PRINT "N"; : COLOR mgr: PRINT TAB(5); "BoatWright"
    COLOR yel: PRINT "O"; : COLOR mgr: PRINT TAB(5); "Mystic (Special)"
    COLOR yel: PRINT "P"; : COLOR mgr: PRINT TAB(5); "Inventor's Workshop"
    PRINT : COLOR lblu: PRINT "Current type is ";
    COLOR lred: PRINT tmp$
    COLOR grn: PRINT
    PRINT "Choose new shop type:  ";
8 UKey a$
  IF a$ < "A" OR a$ > "P" THEN 8
  ShopCode(a) = ASC(a$) - 64
  GOSUB GetShopName: PRINT tmp$
  PRINT
  PRINT "Enter new Shop name/description, or press ENTER to keep current one"
  PRINT "("; ShopName$(a); ")"
  INPUT "Enter shop name/description: ", a$
  IF a$ <> "" THEN ShopName$(a) = a$
RETURN

GetShopName:
    tmp$ = "NONE"
    IF ShopCode(a) = 1 THEN tmp$ = "Weapon Shop"
    IF ShopCode(a) = 2 THEN tmp$ = "Armor Shop"
    IF ShopCode(a) = 3 THEN tmp$ = "Tavern"
    IF ShopCode(a) = 4 THEN tmp$ = "Mage's Guild"
    IF ShopCode(a) = 5 THEN tmp$ = "Healer"
    IF ShopCode(a) = 6 THEN tmp$ = "Adventurer's Guild"
    IF ShopCode(a) = 7 THEN tmp$ = "Gladiator Pit"
    IF ShopCode(a) = 8 THEN tmp$ = "Transport Emporium"
    IF ShopCode(a) = 9 THEN tmp$ = "Casino"
    IF ShopCode(a) = 10 THEN tmp$ = "Lake (Special)"
    IF ShopCode(a) = 11 THEN tmp$ = "Ruins (Special)"
    IF ShopCode(a) = 12 THEN tmp$ = "Caves (Special)"
    IF ShopCode(a) = 13 THEN tmp$ = "Black Market"
    IF ShopCode(a) = 14 THEN tmp$ = "BoatWright"
    IF ShopCode(a) = 15 THEN tmp$ = "Mystic (Special)"
    IF ShopCode(a) > 15 THEN tmp$ = "Inventor's Workshop"
RETURN

MapFKeys:
  REM We must remap the  F  keys since QBasic will
  REM not let us read extended KeyCodes..
    KEY 1, "A"
    KEY 2, "B"
    KEY 3, "C"
    KEY 4, "D"
    KEY 5, "E"
    KEY 6, "F"
    KEY 7, "G"
    KEY 8, "H"
    KEY 9, "I"
    KEY 10, "J"
    KEY 30, CHR$(9): REM Make F11 look like TAB key
    KEY 31, CHR$(27): REM Make F12 look like ESC key
    FKey$(1) = "F1"
    FKey$(2) = "F2"
    FKey$(3) = "F3"
    FKey$(4) = "F4"
    FKey$(5) = "F5"
    FKey$(6) = "F6"
    FKey$(7) = "F7"
    FKey$(8) = "F8"
    FKey$(9) = "F9"
    FKey$(10) = "F10"
    FKey$(11) = "TAB"
    FKey$(12) = "ESC"
RETURN

Title:
  COLOR lgr
  LOCATE 23, 1
  PRINT " The Sceptre of Shalimar Town Maker              by Seth Hopkinson 31-May-1996"
  LOCATE 24, 17
  COLOR dgr
  PRINT "Version 1.0 -- Date of last revision 9-Jun-1996"
  LOCATE 1, 1
RETURN

SaveCurTown:
  File$ = TwnFile$
  CLS : COLOR red: PRINT "  SAVING "; TwnFile$; "..."
GOTO DoSave

SaveTown:
  CLS : COLOR red: PRINT "  SAVE TOWN ";
  COLOR blu: PRINT TAB(45); "Previous Filename:  "; UCASE$(TwnFile$)
  File$ = TwnFile$
  COLOR grn: PRINT
  GOSUB GetFile
DoSave:
  ON ERROR GOTO BadFile
  OPEN File$ FOR OUTPUT AS #1
  WRITE #1, "SHAL BTWN"
  WRITE #1, tNam$, exitX, exitY, Town$
  WRITE #1, Shops
  FOR g = 1 TO Shops
    WRITE #1, ShopName$(g), ShopCode(g), XPos(g), YPos(g)
  NEXT g
  IF Rumors > 0 THEN
     PRINT #1, CHR$(46)
     WRITE #1, "RUMORS"
     WRITE #1, Rumors
     FOR g = 1 TO Rumors
       WRITE #1, Who$(g), Rumor$(g)
     NEXT g
  END IF
GOTO DoneTown

LoadTown:
  CLS : COLOR red: PRINT "  LOAD TOWN ";
  COLOR blu: PRINT TAB(45); "Previous Filename:  "; UCASE$(TwnFile$)
  File$ = TwnFile$
  COLOR grn: PRINT
  GOSUB GetFile
  ON ERROR GOTO BadFile
  OPEN File$ FOR INPUT AS #1
  INPUT #1, xx$
  IF UCASE$(xx$) <> "SHAL BTWN" THEN
    PRINT "BAD TOWN FORMAT: "; xx$
    CLOSE #1
    ON ERROR GOTO 0
    GetKey a$
    RETURN
  END IF
  INPUT #1, tNam$, exitX, exitY, Town$
  INPUT #1, Shops
  IF Shops = 0 THEN GOTO checkForMore
  FOR g = 1 TO Shops
    INPUT #1, ShopName$(g), ShopCode(g), XPos(g), YPos(g)
  NEXT g
  tmp = 1: a$ = ""
checkForMore:
  IF NOT EOF(1) THEN
     LINE INPUT #1, a$
     IF a$ = "." THEN
       tmp = 0
     ELSE
       GOTO checkForMore
     END IF
  END IF
  IF tmp = 1 THEN GOTO DoneTown
LoadRumors:
  INPUT #1, a$
  IF a$ <> "RUMORS" THEN GOTO LoadRumors
  INPUT #1, Rumors
  FOR g = 1 TO Rumors
    INPUT #1, Who$(g), Rumor$(g)
    ItsBeenSaid(g) = 0
  NEXT g
DoneTown:
  CLOSE #1
  ON ERROR GOTO 0
RETURN

BadFile:
  CLOSE #1
  COLOR lgr
  PRINT : PRINT
  PRINT " -  FILE ERROR  - ": PRINT
  PRINT ERR
  COLOR lblu
  GetKey a$
RESUME MainMenu

GetFile:
  COLOR yel: PRINT "Enter filename for Town "; tNam$
  PRINT : COLOR grn
  PRINT "Type  '  to use previous filename,"; TAB(45); "NOTE:  The ' key is right next"
  PRINT "or press ENTER for directory."; TAB(52); "to ENTER on most keyboards."
  PRINT
  xx$ = "": COLOR yel
  PRINT : INPUT "Enter Filename: ", xx$
  IF xx$ = "" THEN
     COLOR lblu
     PRINT
     FILES "*.BTW"
     GOTO GetFile
  END IF
  IF xx$ = "'" THEN
    File$ = TwnFile$
  ELSE
    File$ = xx$
  END IF
  GOSUB Parse
  TwnFile$ = File$
RETURN

Parse:
  g = LEN(File$)
  IF g > 8 THEN g = 8
  FOR x = 1 TO g
    xx$ = MID$(File$, x, 1)
    IF xx$ = "." OR xx$ = "\" OR xx$ = "*" OR xx$ = "?" THEN
      MID$(File$, x, 1) = "_"
    END IF
  NEXT x
  File$ = LEFT$(File$, 8) + ".BTW"
RETURN

SUB GetKey (a$) STATIC
999 a$ = INKEY$
  IF a$ = "" THEN 999
END SUB

SUB item (a, a$, B, B$) STATIC
  COLOR a
  PRINT a$;
  COLOR B
  PRINT B$
END SUB

SUB UKey (a$) STATIC
998 a$ = UCASE$(INKEY$)
  IF a$ = "" THEN 998
END SUB

