@echo off
REM 
REM    Requires CHOICE command -- Ms Dos 6.2 or better I think
REM 
echo .
echo .
echo .  SCEPTRE OF SHALIMAR PRE-RELEASE #1 MENU
echo .  by Seth Hopkinson, 9 Jun 1996                
echo .         
echo .       A.  Play Sceptre of Shalimar with original map
echo .       B.  Play Sceptre of Shalimar Gem Islands
echo .
echo .       C.  Run Monster Editor   (Create/Edit Monsters)
echo .       D.  Run Spell Editor     (Create/Edit Spells)
echo .       E.  Run Map Editor       (Create/Edit Maps)
echo .       F.  Run Town Editor      (Create/Edit Towns)
echo .       G.  Run Tile Editor      (Create/Edit Tiles)
echo .
echo .       H.  Read the README.TXT file (general information)
echo .       I.  Read the CONSET.TXT file (editor information)
echo .       J.  Read the WHATSNEW.TXT file (changes in this version)
echo .
echo .       Q.  Quit (back to DOS)
echo .
echo .
choice /c:ABCDEFGHIJQ /t:Q,45
IF ERRORLEVEL 11 GOTO Done
IF ERRORLEVEL 10 GOTO WhatNew
IF ERRORLEVEL 9 GOTO ConSet
IF ERRORLEVEL 8 GOTO ReadMe
IF ERRORLEVEL 7 GOTO TileEdit
IF ERRORLEVEL 6 GOTO TownEdit
IF ERRORLEVEL 5 GOTO MapEdit
IF ERRORLEVEL 4 GOTO SpellEdit
IF ERRORLEVEL 3 GOTO MonstEdit
IF ERRORLEVEL 2 GOTO GemIslands
IF ERRORLEVEL 1 GOTO Shalimar

:WhatNew
TYPE WHATSNEW.TXT|more
GOTO Done

:ConSet
TYPE CONSET.TXT|more
GOTO Done

:ReadMe
TYPE README.TXT|more
GOTO Done

:TileEdit
QBASIC /RUN STilEdit.BAS
GOTO Done

:TownEdit
QBASIC /RUN TownMkr.BAS
GOTO Done

:MapEdit
QBASIC /RUN LandMakr.BAS
GOTO Done

:SpellEdit
QBASIC /RUN SpellMkr.BAS
GOTO Done

:MonstEdit
QBASIC /RUN MonstMkr.BAS
GOTO Done

:GemIslands
GEMISLAN
GOTO Done

:Shalimar
SHALIMA1
GOTO Done

:Done
echo .
echo .  If you have any comments/suggestions, please email me at:
echo .
echo .        hopkins@smartlink.net
echo .
